///////////////
//BACKPACK ITEM
///////////////
datablock ItemData(ISBackPackItem)
{
	category = "Weapon";
	className = "Weapon";
	
	shapeFile = "./ISBackPackStrapsItem.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;
	
	uiName = "ISBackPack";
	iconName = "./BackPackIcon";
	doColorShift = false;
	
	image = ISBackPackAImage;
	canDrop = true;
};

/////////////////////////////
//IMAGE WHEN MOUNTED TO HANDS
/////////////////////////////
datablock ShapeBaseImageData(ISBackPackAImage)
{
	shapeFile = "./ISBackPackStrapsItem.dts";
	emap = false;
	mountPoint = 0;
	offset = "-0.5 0.25 0.25";
	eyeOffset = 0;
	rotation = eulerToMatrix("0 0 90");
	
	className = "WeaponImage";
	item = ISBackPackItem;
	
	armReady = true;
	doColorShift = false;
	
	stateName[0]					= "Activate";
	//stateSound[0]					= weaponSwitchSound; //disabled by request
	stateTimeoutValue[0]			= 0.15;
	stateSequence[0]				= "Ready";
	stateTransitionOnTimeout[0]		= "Ready";

	stateName[1]					= "Ready";
	stateAllowImageChange[1]		= true;
	stateScript[1]					= "onReady";
	stateTransitionOnTriggerDown[1]	= "Use";
	
	stateName[2]					= "Use";
	stateScript[2]					= "onUse";
	stateTransitionOnTriggerUp[2]	= "Ready";
};

////////////////////////////
//IMAGE WHEN MOUNTED TO BACK
////////////////////////////
datablock ShapeBaseImageData(ISBackPackBImage)
{
	shapeFile = "./ISBackPackItem.dts";
	emap = false;
	mountPoint = 2;
	offset = "0 -0.38 -0.25";
	eyeOffset = "0 -2 0";
	rotation = eulerToMatrix("0 0 90");
	firstPerson = false;
	
	className = "WeaponImage";
	item = "";
	
	armReady = true;
	doColorShift = false;
};

//////////////////////////////////
//MOUNT BACKPACK TO AVATAR'S HANDS
//////////////////////////////////
function ISBackPackAImage::onMount(%this, %obj, %slot)
{
	%cl = %obj.client;

	if(%obj.tool[%obj.currTool] == ISBackPackItem.getID())
	{
		%cl.ISclInfo = setWord(%cl.ISclInfo,0,1); //player has backpack
		
		//Unhide avatar pack node for player, if they had a pack
		if(getWord(%cl.ISclInfo,1) !$= "")
			%obj.unHideNode(getWord(%cl.ISclInfo,1));
			
		%obj.playThread(0,"armReadyBoth");
		%obj.unMountImage(2);
	}
}

///////////////////////////
//USE BACKPACK WHEN READIED
///////////////////////////
function ISBackPackAImage::onUse(%this, %obj, %slot)
{
	%cl = %obj.client;
	
	if(getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires v4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download v4 from RTB, restart Blockland and then rejoin. " @
				"Or, type /ISHelp for auxiliary backpack usage.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires v4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download v4 from RTB, restart Blockland and then rejoin. " @
				"Or, type /ISHelp for auxiliary backpack usage.");
		return;
	}
	commandToClient(%cl,'ISRelayBkPkToggle',1);
}

/////////////////////////////////
//MOUNT BACKPACK TO AVATAR'S BACK
/////////////////////////////////
function ISBackPackAImage::onUnMount(%this, %obj, %slot)
{
	%cl = %obj.client;
	%obj.playThread(0,"root");
	
	//Check if player still has backpack before mounting to back
	for(%c = 0; %c < %obj.getDatablock().maxTools; %c++)
	{
		%tool = %obj.tool[%c];
		if(%tool == ISBackPackItem.getID())
		{
			%check = 1;
			break;
		}
	}
	if(%check == 1 && %obj.getMountedImage(2) == 0)
	{
		//If player's avatar has a pack, hide node and temp save to unhide later
		if(%cl.pack > 0)
		{
			%packName = getWord(" armor bucket cape pack quiver tank",%cl.pack);
			%cl.ISclInfo = setWord(%cl.ISclInfo,1,%packName);
			%obj.hideNode(%packName);
		}
		%obj.mountImage(ISBackPackBImage,2);
	}
}

////////////////////
//PLAYER ENCUMBRANCE
////////////////////
function ISEncumbrance(%cl,%currWght,%maxWght)
{
	%pl = %cl.player;
	if(!isObject(%cl) || !isObject(%pl))
		return;

	//Find current weight, if not given
	if(getWord($HstSetString,4) == 1)
	{
		if(%currWght $= "")
		{
			//Player Inv
			%mxTls = %cl.player.getDatablock().maxTools;
			%BkPkID = ISBackPackItem.getID();
			
			for(%c = 0; %c < %mxTls && %c < 10; %c++)
			{
				%item = %cl.player.tool[%c];
				if(%item > 0)
					%currWght += getWord($ItemSetArray[%item],1);
			}

			//////////////////////////////////////////////////
			
			//Backpack Inv
			%item = 0;
			if(getWord($HstSetString,2) && (getWord(%cl.ISclInfo,0) || getWord($HstSetString,3) == 0))
			{
				if(getWord(%cl.bkpkInv,1) !$= "")
				{
					for(%c=3; %c<62; %c+=4)
					{
						%item = getWord(%cl.bkpkInv,%c);
						%itemAm = getWord(%cl.bkpkInv,%c+1);
						
						if(%item > 0 && %item.getClassName() $= "ItemData" && %item.uiName !$= "" && %itemAm > 0)
							%currWght += (getWord($ItemSetArray[%item],1)*%itemAm);
					}
				}
				else
				{
					%loadBP = ISLoadItems(%cl,%cl.bl_id,"BackPacks");
					for(%c=2; %c<62; %c+=4) //15
					{
						%item = getWord(%loadBP,%c);
						%itemAm = getWord(%loadBP,%c+1);
						
						if(%item > 0 && %item.getClassName() $= "ItemData" && %item.uiName !$= "" && %itemAm > 0)
							%currWght += (getWord($ItemSetArray[%item],1)*%itemAm);
					}
				}
			}
			%cl.ISclInfo = setWord(%cl.ISclInfo,3,%currWght);
		}
		
		////////////////////////////////////////////////////////////////////////////////////////////////////
		
		//Check if player is over-encumbered
		if(%currWght > %maxWght)
		{
			%cl.overEnc = true;
			
			%cl.camera.setOrbitMode(%pl,%pl.getTransform(),0.5,8,8,1);
			%cl.camera.mode = "Orbit";
			%cl.setControlObject(%cl.camera);
			
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Over-Encumbered","You have exceeded the max weight you can carry. " @
					"You will not be able to move until you drop some items from your player or backpack inventory.");
			else
				commandToClient(%cl,'ISMsgBox',"Over-Encumbered","enc","You have exceeded the max weight you can carry. " @
					"You will not be able to move until you drop some items from your player or backpack inventory.",0,"");
		}
		else if(%cl.overEnc == true)
		{
			%cl.overEnc = false;
			%cl.setControlObject(%pl);
		}
		if(getWord(%cl.ISclInfo,0) == 1 || getWord($HstSetString,3) == 0)
			commandtoClient(%cl,'ISRefreshInfoGUI',0,0,0,0,2,1 SPC %currWght SPC getWord($HstSetString,18) SPC getWord($HstSetString,19));
	}
	
	//////////////////////////////////////////////////
	
	else 
	{
		if(%cl.overEnc == true)
		{
			%cl.overEnc = false;
			%cl.setControlObject(%pl);
		}
		if(getWord(%cl.ISclInfo,0) || getWord($HstSetString,3) == 0)
			commandtoClient(%cl,'ISRefreshInfoGUI',0,0,0,0,2,0);
	}
}
