//SERVER-SIDED

///////////////////////
//INPUT EVENT FUNCTIONS
///////////////////////
function fxDTSBrick::onISEventInput(%obj,%cl,%pass)
{
	$InputTarget_["Self"]   = %obj;
	$InputTarget_["Player"] = %cl.player;
	$InputTarget_["Client"] = %cl;

	if($Server::LAN)
	{
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%cl);
	}
	else
	{
		if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%cl))
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);
		else
			$InputTarget_["MiniGame"] = 0;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if(%pass != 0)
	{
		if(%pass != 1)
		{
			if(%pass != 2)
			{
				if(%pass != 3)
				{
					if(%pass != 4)
					{
						if(%pass != 5)
						{
							if(%pass != 6)
							{
								if(%pass != 7)
								{
									if(%pass != 8)
									{
										if(%pass != 9)
										{
											if(%pass == 10)
												%obj.processInputEvent("onISGUIDropItem",%cl);
										}
											%obj.processInputEvent("onISGUISwapItems",%cl);
									}
									else
										%obj.processInputEvent("onISEventTransfer",%cl);
								}
								else
									%obj.processInputEvent("onISConditionFalse",%cl);
							}
							else
								%obj.processInputEvent("onISConditionTrue",%cl);
						}
						else
							%obj.processInputEvent("onISGUIClosedAll",%cl);
					}
					else
						%obj.processInputEvent("onISGUIClosed",%cl);
				}
				else
					%obj.processInputEvent("onISGUIOpened",%cl);
			}
			else
				%obj.processInputEvent("onISGUIMoveItem",%cl);
		}
		else
			%obj.processInputEvent("onISGUIRemoveItem",%cl);
	}
	else
		%obj.processInputEvent("onISGUIAddItem",%cl);
}

///////////////////////////////////////////////
//EXECUTE SPECIFIED CONDITIONAL IS INPUT EVENTS
///////////////////////////////////////////////
function IS_RelOutputConditions(%cl,%brick,%relOutput,%pass)
{
	//Enable or disable IS conditional events based on specifications
	for(%c=0; %c<%brick.numEvents; %c++)
	{
		if(%brick.eventInput[%c] $= "onISConditionTrue" || %brick.eventInput[%c] $= "onISConditionFalse")
		{
			%tempEnab[%c] = %brick.eventEnabled[%c];
			%check = 0;
			for(%d=0; %d<getWordCount(%relOutput); %d++)
			{
				if(%c == getWord(%relOutput,%d))
				{
					%check = 1;
					break;
				}
			}
			if(%check == 1)
				%brick.eventEnabled[%c] = 1;
			else
				%brick.eventEnabled[%c] = 0;
		}
	}
	
	//Execute IS conditional input events
	fxDTSBrick::onISEventInput(%brick,%cl,%pass);
	
	//Set IS conditional input events back to original enabled/disabled settings
	for(%c=0; %c<%brick.numEvents; %c++)
	{
		if(%brick.eventInput[%c] $= "onISConditionTrue" || %brick.eventInput[%c] $= "onISConditionFalse")
			%brick.eventEnabled[%c] = %tempEnab[%c];
	}
}

/////////////////////////////////
//EVENT: OPEN BRICK INVENTORY GUI
/////////////////////////////////
function fxDTSBrick::IS_StoreItems(%brick,%storType,%cl)
{
	if(ISSpamCheckEvents(%cl,%brick))
		return;
	if(getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	//////////////////////////////////////////////////
	
	if(%storType != 0)
	{
		if(%storType != 1)
		{
			if(%storType != 2)
			{
				if(%storType == 3)
				{
					%storType = 32;
					%storName = "(X-Large)";
				}
			}
			else
			{
				%storType = 16;
				%storName = "(Large)";
			}
		}
		else
		{
			%storType = 9;
			%storName = "(Medium)";
		}
	}
	else
	{
		%storType = 4;
		%storName = "(Small)";
	}
	%mxTls = %cl.player.getDatablock().maxTools;
	%brName = %brick.getName();
	%brName = getSubStr(%brName,1,strLen(%brName)-1);
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if(ISNameValid(%cl,%brName) == 1)
		return;
	if((%name = ISGetFile(%cl,%brName)) $= 0)
		return;
	%loadBr = ISLoadItems(%cl,%brName,%name);
	
	//Check brick inv for existing save; save items/info to string
	if(getWord(%loadBr,0) != 0)
	{	
		%presentSave = 1;
		%cl.brInv = %presentSave SPC %name SPC %loadBr;
		
		%access = getWord(%loadBr,1);
		%srcBrick = getWord(%loadBr,2);
		%rmtAcc = getWord(%loadBr,3);
		
		if(ISErrorCheck(%cl,%storType,%access,%loadBr,%brick,%srcBrick,%rmtAcc) == 1)
			return;
	}
	else
	{
		%access = 0;
		%presentSave = 0;
		%cl.brInv = %presentSave SPC %name SPC %storType SPC %access SPC %brick SPC 1 SPC %cl.bl_id SPC getSubStr(strReplace(%cl.name," ","_"),0,30) SPC %brName;
	}
	
	//Stored brick id being accessed (for error checks and events/vce)
	%cl.ISclInfo = setWord(%cl.ISclInfo,6,%brick);
	
	//////////////////////////////////////////////////
	
	//Check backpack inv for existing save; save items to string
	if(getWord($HstSetString,2) && (getWord(%cl.ISclInfo,0) || getWord($HstSetString,3) == 0))
	{
		%loadBp = ISLoadItems(%cl,%cl.bl_id,"BackPacks");
		if(%loadBP == 0)
		{
			%cl.bkpkInv = 0 SPC %cl.bl_id; //store player's bl_id - referenced when GUI needs to be closed when host updates server/item settings
			%cl.ISclInfo = setWord(%cl.ISclInfo,3,0);
		}
		else
			%cl.bkpkInv = 1 SPC %loadBp;
	}
	else
	{
		%loadBp = -1;
		%cl.ISclInfo = setWord(%cl.ISclInfo,3,0);
	}
	
	//////////////////////////////////////////////////
	
	//Get player tools; get accumulated item-weight (even if enc disabled); save to string for player inv
	%clP = %cl.player;
	for(%c = 0; %c < %mxTls && %c < 10; %c++)
	{
		%item = %clP.tool[%c];
		%plyrItms = setWord(%plyrItms,(%c*4),%item);
		if(%item > 0)
		{
			%plyrItms = setWord(%plyrItms,(%c*4)+1,1);
			%plyrItms = setWord(%plyrItms,(%c*4)+2,getWord($ItemSetArray[%item],0));
			%plyrItms = setWord(%plyrItms,(%c*4)+3,getWord($ItemSetArray[%item],1));
		}
		else
		{
			%plyrItms = setWord(%plyrItms,(%c*4)+1,0);
			%plyrItms = setWord(%plyrItms,(%c*4)+2,0);
			%plyrItms = setWord(%plyrItms,(%c*4)+3,0);
		}
		%currWght += getWord($ItemSetArray[%cl.player.tool[%c]],1);
	}
	%tempWght = getWord(%cl.ISclInfo,3);

	%cl.ISclInfo = setWord(%cl.ISclInfo,3,%tempWght+%currWght);
	ISEncumbrance(%cl,getWord(%cl.ISclInfo,3),getWord($HstSetString,18));
	%cl.plyrInv = %mxTls SPC %plyrItms;
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	for(%c = 0; %c < clientgroup.getCount(); %c++)
	{
		%tempCl = clientgroup.getObject(%c);
		if(getWord(%tempCl.brInv,8) $= %brName)
			%clCount++;
	}
	for(%c = 0; %c < clientgroup.getCount(); %c++)
	{	
		%tempCl = clientgroup.getObject(%c);
		if(%tempCl != %cl && getWord(%tempCl.brInv,8) $= %brName)
			commandtoClient(%tempCl,'ISRefreshInfoGUI',%clCount,0,0,0,1); 
	}
	
	//////////////////////////////////////////////////
	
	//Setup access button trans for client GUI (if host/not host); setup brick and item weight info var
	if(%cl.islocalconnection() || %cl.bl_id == getNumKeyID() || %cl.bl_id == getWord(%cl.brInv,6)) //use %load instead?
		%AccBtnOn = 1;
	else
		%AccBtnOn = 0;
		
	%miscInfo = setWord(%miscInfo,0,%brick);
	%miscInfo = setWord(%miscInfo,1,strReplace(%brick.getDataBlock().iconName," ","")); //???
	
	if(getWord($HstSetString,4))
	{
		%miscInfo = setWord(%miscInfo,2,1); //%encEnbl
		%miscInfo = setWord(%miscInfo,3,getWord(%cl.ISclInfo,3)); //%currWght
		%miscInfo = setWord(%miscInfo,4,getWord($HstSetString,18)); //%maxWght
		%miscInfo = setWord(%miscInfo,5,getWord($HstSetString,19)); //%wghtSmbl
	}
	
	//////////////////////////////////////////////////
	
	//Check if brick items string exceeds network strings limit; send in increments if it does
	if(strLen(%loadBr) >= 255)
	{
		%prevLoadBr = %loadBr;
		%auxLoadBr = 1;
		%loadBr = getWords(%loadBr,0,8);
	}
	%loadBr = setWord(%loadBr,0,%storType);
	commandtoClient(%cl,'ISPopulateGUI',%loadBr,%plyrItms,%loadBp,%mxTls,%brName,%miscInfo,%storType,%storName,%AccBtnOn,%clCount);
	
	if(%auxLoadBr == 1)
	{
		%count = getWordCount(%prevLoadBr);
		for(%c=9; %c<%count; %c+=4)
		{
			if(strLen(%loadBrTemp SPC getWord(%prevLoadBr,%c) SPC getWord(%prevLoadBr,%c+1) SPC getWord(%prevLoadBr,%c+2) SPC getWord(%prevLoadBr,%c+3)) < 255)
			{
				%loadBrTemp = %loadBrTemp SPC getWord(%prevLoadBr,%c) SPC getWord(%prevLoadBr,%c+1) SPC getWord(%prevLoadBr,%c+2) SPC getWord(%prevLoadBr,%c+3);
				
				if((%c+4) >= %count)
				{
					commandtoClient(%cl,'ISPopulateGUIRel',"br",(%b SPC (%c-9)),getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
					fxDTSBrick::onISEventInput(%brick,%cl,3);
					return;
				}
			}
			else
			{
				commandtoClient(%cl,'ISPopulateGUIRel',"br",%b SPC (%c-9),getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
				%loadBrTemp = " " @ getWord(%prevLoadBr,%c) SPC getWord(%prevLoadBr,%c+1) SPC getWord(%prevLoadBr,%c+2) SPC getWord(%prevLoadBr,%c+3);
				%b = (%c-9);
				
				if((%c+4) >= %count)
				{
					commandtoClient(%cl,'ISPopulateGUIRel',"br",(%b SPC (%c-9)),getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
					fxDTSBrick::onISEventInput(%brick,%cl,3);
					return;
				}
			}
		}
	}	
	fxDTSBrick::onISEventInput(%brick,%cl,3);
}

////////////////////////////////////////////////////////////////
//EVENT: ADD ITEM SPECIFIED TO CELLS (OVERWRITE IF ITEM PRESENT)
////////////////////////////////////////////////////////////////
function fxDTSBrick::IS_SetInv(%brick,%cells,%item,%random,%stckAm,%cl)
{
	if(ISSpamCheckEvents(%cl,%brick))
		return;
	if(getWord($HstSetString,17) != 1 && getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	%brName = %brick.getName();
	%brName = getSubStr(%brName,1,strLen(%brName)-1);
	if(ISNameValid(%cl,%brName) == 1)
		return;

	if(%cl.brInv $= "")
	{
		%name = ISGetFile(%cl,%brName);
		if(%name $= "0") 
			return;
		%load = ISLoadItems(%cl,%brName,%name);
	}
	else
	{
		%name = getWord(%cl.brInv,1);
		%load = getWords(%cl.brInv,2,138);
	}
	
	//////////////////////////////////////////////////
	//If load is found
	
	if(getWord(%load,0) != 0)
	{
		%access = getWord(%load,1);
		%storType = getWord(%load,0);
		%brItms = getWords(%load,9,138);
		%srcBrick = getWord(%load,2);
		%rmtAcc = getWord(%load,3);
		
		if(%item == -1)
			%item = 0;
		%cellA = mAbs(mFloatLength(getWord(%cells,0),0));
		%cellB = mAbs(mFloatLength(getWord(%cells,1),0));
		
		if(%rmtAcc == 0 && %srcBrick != %brick)
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Remote Access Disabled","Remote access is disabled for this inventory save; this is not the source brick. " @
					"Please enable remote access using IS_StoreItems before using other events on it.");
			else
				commandtoClient(%cl,'ISMsgBox',"Remote Access Disabled","error","Remote access is disabled for this inventory save; this is not the source brick. " @
					"Please enable remote access using IS_StoreItems before using other events on it.",0,"");
			return;
		}
		if(ISErrorCheck(%cl,%storType,%access,%load,%brick,%srcBrick,%rmtAcc))
			return;
		
		//////////////////////////////////////////////////
		//Set items to inventory
		
		if(%cellB > %storType)
			%cellB = %storType;
		if(%cellA >= %storType || %cellA >= %cellB)
			return;
			
		%count = DataBlockGroup.getCount();
		for(%c = %cellA; %c < %cellB && %c < %storType && %c < 32; %c++)
		{
			//If random items option is selected
			if(%random == 1)
			{
				%failsafe = 0;
				while(true)
				{
					%tempItem = getRandom(0,%count);
					%tempSkAm = getWord($ItemSetArray[%tempItem],0);
					%tempWght = getWord($ItemSetArray[%tempItem],1);
					
					if(%stckAm == 0)
						%tempAm = getRandom(1,%tempSkAm);
					else if(%stckAm > %tempSkAm)
						%tempAm = %tempSkAm;
					else
						%tempAm = %stckAm;
					
					if(%failsafe > 100)
					{
						if(%item > 0)
						{
							%tempItem = %item;
							%tempSkAm = getWord($ItemSetArray[%item],0);
							%tempWght = getWord($ItemSetArray[%item],1);
							
							if(%stckAm == 0)
								%tempAm = getRandom(1,%tempSkAm);
							else if(%stckAm > %tempSkAm)
								%tempAm = %tempSkAm;
							else
								%tempAm = %stckAm;
						}
						else
						{
							%tempItem = 0;
							%tempAm = 0;
							%tempSkAm = 0;
							%tempWght = 0;
						}
						break;
					}
					else if(isObject(%tempItem) && %tempItem.getClassName() $= "ItemData" && %tempItem.getName() !$= "WrenchItem" && %tempItem.uiName !$= "")
						break;
					
					%failsafe++;
				}
				%brItms = setWord(%brItms,(%c*4),%tempItem);
				%brItms = setWord(%brItms,(%c*4)+1,%tempAm);
				%brItms = setWord(%brItms,(%c*4)+2,%tempSkAm);
				%brItms = setWord(%brItms,(%c*4)+3,%tempWght);
			}
			else
			{
				if(%item > 0)
				{
					%itemSkAm = getWord($ItemSetArray[%item],0);

					if(%stckAm == 0)
						%itemAm = getRandom(1,%itemSkAm);
					else if(%stckAm > %itemSkAm)
						%itemAm = %itemSkAm;
					else
						%itemAm = %stckAm;
								
					%brItms = setWord(%brItms,(%c*4),%item);
					%brItms = setWord(%brItms,(%c*4)+1,%itemAm);
					%brItms = setWord(%brItms,(%c*4)+2,getWord($ItemSetArray[%item],0));
					%brItms = setWord(%brItms,(%c*4)+3,getWord($ItemSetArray[%item],1));
				}
				else
				{
					%brItms = setWord(%brItms,(%c*4),0);
					%brItms = setWord(%brItms,(%c*4)+1,0);
					%brItms = setWord(%brItms,(%c*4)+2,0);
					%brItms = setWord(%brItms,(%c*4)+3,0);
				}
			}
		}
		
		//////////////////////////////////////////////////
		//Save and update all open brick inventory GUIs
		
		if(ISOverWriteSave(%cl,%name,%brName,%storType,%brItms,%access,%brick) == 1)
			return;
			
		for(%c = 0; %c < clientgroup.getCount(); %c++)
		{
			%tempCl = clientgroup.getObject(%c);
			if(getWord(%tempCl.brInv,8) $= %brName)
			{
				%tempCl.brInv = getWords(%tempCl.brInv,0,10) SPC %brItms;
				
				if(strLen(%brItms) < 255)
					commandToClient(%tempCl,'ISMultRefreshGUI',%brItms,"Br");
				else
				{
					%wrdCount = getWordCount(%brItms);
					%loadBrTemp = "";
					%b = 0;
					
					for(%d=0; %d<%wrdCount; %d+=4)
					{
						if(strLen(%loadBrTemp SPC getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3)) < 255)
						{
							%loadBrTemp = %loadBrTemp SPC getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3);
							
							if((%d+4) >= %wrdCount)
							{
								commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
								break;
							}
						}
						else
						{
							commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
							%loadBrTemp = " " @ getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3);
							%b = %d;
							
							if((%d+4) >= %wrdCount)
							{
								commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
								break;
							}
						}
					}
				}
			}
		}
	}
	else
	{
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"No Save Present",
				"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.");
		else
			commandtoClient(%cl,'ISMsgBox',"No Save Present","error",
				"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.",0,"");
	}
}

///////////////////////////////////////////////////////////
//EVENT: APPEND ITEMS TO AVAILABLE SLOTS IN BRICK INVENTORY
///////////////////////////////////////////////////////////
function fxDTSBrick::IS_AddItem(%brick,%inv,%item,%random,%numStckAm,%cl)
{
	if(ISSpamCheckEvents(%cl,%brick))
		return;
	if(getWord($HstSetString,17) != 1 && getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	if(%item == -1)
		%item = 0;
		
	%stckAm = mAbs(mFloatLength(getWord(%numStckAm,1),0));
	if(%stckAm > 999)
		%stckAm = 999;

	////////////////////////////////////////////////////////////////////////////////////////////////////

	if(%inv == 0)
	{
		%brName = %brick.getName();
		%brName = getSubStr(%brName,1,strLen(%brName)-1);
		if(ISNameValid(%cl,%brName) == 1)
			return;
		
		if(%cl.brInv $= "")
		{
			%name = ISGetFile(%cl,%brName);
			if(%name $= "0") 
				return;
			%load = ISLoadItems(%cl,%brName,%name);
		}
		else
		{
			%name = getWord(%cl.brInv,1);
			%load = getWords(%cl.brInv,2,138);
		}

		//////////////////////////////////////////////////
		
		if(getWord(%load,0) != 0)
		{
			%access = getWord(%load,1);
			%storType = getWord(%load,0);
			%brItms = getWords(%load,9,138);
			%srcBrick = getWord(%load,2);
			%rmtAcc = getWord(%load,3);
			
			%num = mAbs(mFloatLength(getWord(%numStckAm,0),0));
			if(%num > %storType)
				%num = %storType;
			else if(%num == 0)
				%num = getRandom(1,%storType);

			if(%rmtAcc == 0 && %srcBrick != %brick)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Remote Access Disabled","Remote access is disabled for this inventory save; this is not the source brick. " @
						"Please enable remote access using IS_StoreItems before using other events on it.");
				else
					commandtoClient(%cl,'ISMsgBox',"Remote Access Disabled","error","Remote access is disabled for this inventory save; this is not the source brick. " @
						"Please enable remote access using IS_StoreItems before using other events on it.",0,"");
				return;
			}
			if(ISErrorCheck(%cl,%storType,%access,%load,%brick,%srcBrick,%rmtAcc) == 1)
				return;

			//////////////////////////////////////////////////

			%count = getWordCount($ItemListString);
			%itemCount = 0;
			
			for(%c=0; %c<%storType && %itemCount<%num && %c<32; %c++) //for adding multiple items
			{
				if(%random)
				{
					%tempItemB = getWord($ItemListString,getRandom(0,%count));
					%tempSkAmB = getWord($ItemSetArray[%tempItemB],0);
					
					if(%stckAm == 0)
						%tempAmB = getRandom(1,%tempSkAmB);
					else if(%stckAm > %tempSkAmB)
						%tempAmB = %tempSkAmB;
					else
						%tempAmB = %stckAm;
						
					%numStck = %tempAmB;
				}
				else
				{
					%tempItemB = %item;
					%tempSkAmB = getWord($ItemSetArray[%tempItemB],0);
					
					if(%stckAm == 0)
						%tempAmB = getRandom(1,%tempSkAmB);
					else if(%stckAm > %tempSkAmB)
						%tempAmB = %tempSkAmB;
					else
						%tempAmB = %stckAm;
					%numStck = %tempAmB;
				}

				//////////////////////////////////////////////////
				
				for(%d=0; %d<%storType && %d<32; %d++)
				{
					%tempItem = getWord(%brItms,(%d*4));
					%tempAm = getWord(%brItms,(%d*4)+1);
					%tempSkAm = getWord($ItemSetArray[%tempItem],0);
					%tempWght = getWord($ItemSetArray[%tempItem],1);
					
					if(%tempItem == 0 || (%tempItem == %tempItemB && %tempSkAm > %tempAm))
					{
						if(%tempItem == 0)
						{
							if(%tempItemB == 0)
								%tempAmB = 0;
							else
							{
								if(%tempAmB > %tempSkAmB)
								{
									%tempAm += %tempSkAmB;
									%tempAmB -= %tempSkAmB;
								}
								else
								{
									%tempAm += %tempAmB;
									%tempAmB = 0;
								}
							}
						}
						else
						{
							%rem = %tempSkAm - %tempAm;
							if(%rem > %tempAmB)
							{
								%tempAm += %tempAmB;
								%tempAmB = 0;
							}
							else
							{
								%tempAm += %rem;
								%tempAmB -= %rem;
							}
						}
						%brItms = setWord(%brItms,(%d*4),%tempItemB);
						%brItms = setWord(%brItms,(%d*4)+1,%tempAm);
						%brItms = setWord(%brItms,(%d*4)+2,%tempSkAmB);
						%brItms = setWord(%brItms,(%d*4)+3,getWord($ItemSetArray[%tempItemB],1));
						
						if(%tempAmB < 1)
						{
							%itemCount++;
							break;
						}
					}
				}
			}
			if(%itemCount < %num || %tempAmB > 0)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Note",%itemCount @ " of " @ %num @ " stacks successfully added to brick's inventory  (" @
						%tempAmB @ " of " @ %numStck @ " individual items from last stack weren't able to be added).");
				else
					commandtoClient(%cl,'ISMsgBox',"Note","error",%itemCount @ " of " @ %num @ " stacks successfully added to brick's inventory  (" @
						%tempAmB @ " of " @ %numStck @ " individual items from last stack weren't able to be added).",0,"");
			}

			//////////////////////////////////////////////////
			
			if(ISOverWriteSave(%cl,%name,%brName,%storType,%brItms,%access,%brick) == 1)
				return;

			//Update all necessary client GUIs
			for(%c = 0; %c < clientgroup.getCount(); %c++)
			{
				%tempCl = clientgroup.getObject(%c);
				if(getWord(%tempCl.brInv,8) $= %brName)
				{
					%tempCl.brInv = getWords(%tempCl.brInv,0,10) SPC %brItms;
					
					if(strLen(%brItms) < 255)
						commandToClient(%tempCl,'ISMultRefreshGUI',%brItms,"Br");
					else
					{
						//Gradually load items for all player-GUIs if item data length exceeds network-strings-limit
						%wrdCount = getWordCount(%brItms);
						%loadBrTemp = "";
						%b = 0;
						
						for(%d=0; %d<%wrdCount; %d+=4)
						{
							if(strLen(%loadBrTemp SPC getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3)) < 255)
							{
								%loadBrTemp = %loadBrTemp SPC getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3);
								
								if((%d+4) >= %wrdCount)
								{
									commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
									break;
								}
							}
							else
							{
								commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
								%loadBrTemp = " " @ getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3);
								%b = %d;
								
								if((%d+4) >= %wrdCount)
								{
									commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
									break;
								}
							}
						}
					}
				}
			}
		}
		else
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"No Save Present",
					"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.");
			else
				commandtoClient(%cl,'ISMsgBox',"No Save Present","error",
					"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.",0,"");
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	else if(%inv == 1)
	{
		if(getWord($HstSetString,2) != 1)
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Backpack Disabled","Backpack storage/usage has been disabled by the server host.");
			else
				commandtoClient(%cl,'ISMsgBox',"Backpack Disabled","error","Backpack storage/usage has been disabled by the server host.",0,"");
			return;
		}
		if(getWord(%cl.ISclInfo,0) != 1 && getWord($HstSetString,3))
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"No Backpack","Backpack item must be equipped to add items to its inventory.");
			else
				commandtoClient(%cl,'ISMsgBox',"No Backpack","error","Backpack item must be equipped to add items to its inventory.",0,"");
			return;
		}
		
		%bkpkID = ISBackPackItem.getID();
		if(%item == %bkpkID)
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Error","You can't put a backpack inside of another backpack.");
			else
				commandToClient(%cl,'ISMsgBox',"Error","error","You can't put a backpack inside of another backpack.",0,"");
			return;
		}
		
		if(%cl.bkpkInv !$= "")
		{
			%bkpkItms = getWords(%cl.bkpkInv,3,62);
			%loadBp = getWords(%cl.bkpkInv,1,62);
			%savePres = getWord(%cl.bkpkInv,0);
		}
		else
		{
			%loadBp = ISLoadItems(%cl,%cl.bl_id,"BackPacks");
			%bkpkItms = getWords(%loadBp,2,61);
			
			if(%loadBp == 0)
				%savePres = 0;
			else
				%savePres = 1;
		}
		
		%count = getWordCount($ItemListString);
		%itemCount = 0;
		
		%num = mAbs(mFloatLength(getWord(%numStckAm,0),0));
		if(%num == 0)
			%num = getRandom(1,15);
		if(%num > 15)
			%num = 15;
		
		for(%c=0; %itemCount<%num && %c<15; %c++) //for adding multiple items
		{
			if(%random)
			{
				%tempItemB = getWord($ItemListString,getRandom(0,%count));
				%tempSkAmB = getWord($ItemSetArray[%tempItemB],0);
				if(%tempItemB == %bkpkID)
					%tempItemB = 0;

				if(%stckAm == 0)
					%tempAmB = getRandom(1,%tempSkAmB);
				else if(%stckAm > %tempSkAmB)
					%tempAmB = %tempSkAmB;
				else
					%tempAmB = %stckAm;
					
				%numStck = %tempAmB;
			}
			else
			{
				%tempItemB = %item;
				%tempSkAmB = getWord($ItemSetArray[%tempItemB],0);
				
				if(%stckAm == 0)
					%tempAmB = getRandom(1,%tempSkAmB);
				else if(%stckAm > %tempSkAmB)
					%tempAmB = %tempSkAmB;
				else
					%tempAmB = %stckAm;
				%numStck = %tempAmB;
			}
			
			//////////////////////////////////////////////////
			
			for(%d=0; %d<15; %d++)
			{
				%tempItem = getWord(%bkpkItms,(%d*4));
				%tempAm = getWord(%bkpkItms,(%d*4)+1);
				%tempSkAm = getWord($ItemSetArray[%tempItem],0);
				%tempWght = getWord($ItemSetArray[%tempItem],1);
				
				if(%tempItem == 0 || (%tempItem == %item && %tempSkAm > %tempAm))
				{
					if(%tempItem == 0)
					{
						if(%tempItemB == 0)
							%tempAmB = 0;
						else
						{
							if(%tempAmB > %tempSkAmB)
							{
								%tempAm += %tempSkAmB;
								%tempAmB -= %tempSkAmB;
							}
							else
							{
								%tempAm += %tempAmB;
								%tempAmB = 0;
							}
						}
					}
					else
					{
						%rem = %tempSkAm - %tempAm;
						if(%rem > %tempAmB)
						{
							%tempAm += %tempAmB;
							%tempAmB = 0;
						}
						else
						{
							%tempAm += %rem;
							%tempAmB -= %rem;
						}
					}
					%bkpkItms = setWord(%bkpkItms,(%d*4),%tempItemB);
					%bkpkItms = setWord(%bkpkItms,(%d*4)+1,%tempAm);
					%bkpkItms = setWord(%bkpkItms,(%d*4)+2,%tempSkAmB);
					%bkpkItms = setWord(%bkpkItms,(%d*4)+3,getWord($ItemSetArray[%tempItemB],1));
					
					if(%tempAmB < 1)
					{
						%itemCount++;
						break;
					}
				}
			}
		}
		if(%itemCount < %num || %tempAmB > 0)
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Note",%itemCount @ " of " @ %num @ " stacks successfully added to backpack's inventory  (" @
					%tempAmB @ " of " @ %numStck @ " individual items from last stack weren't able to be added).");
			else
				commandtoClient(%cl,'ISMsgBox',"Note","error",%itemCount @ " of " @ %num @ " stacks successfully added to backpack's inventory  (" @
					%tempAmB @ " of " @ %numStck @ " individual items from last stack weren't able to be added).",0,"");
		}
		
		//////////////////////////////////////////////////
		
		if(%savePres)
		{
			if(ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,%bkpkItms,0,0) == 1)
			{
				ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,getWords(%loadBp,2,61),0,0);
				return;
			}
		}
		else if(ISSaveItems(%cl,%cl.bl_id,"BackPacks",0,%bkpkItms,0) == 1)
		{
			ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,getWords(%loadBp,2,61),0,0);
			return;
		}
		
		if(getWord(%cl.bkpkInv,1) !$= "")//?
			%cl.bkpkInv = getWords(%cl.bkpkInv,0,2) SPC %bkpkItms;
			
		ISEncumbrance(%cl,"",getWord($HstSetString,18));
		if(%cl.bkpkInv !$= "")
			commandToClient(%cl,'ISMultRefreshGUI',%bkpkItms,"Bp");
	}
}

/////////////////////////////////////////////
//CLEARS AN ITEM/ITEMS FROM BRICK'S INVENTORY
/////////////////////////////////////////////
function fxDTSBrick::IS_ClearItem(%brick,%inv,%item,%anyItem,%num,%cl)
{
	if(ISSpamCheckEvents(%cl,%brick))
		return;
	if(getWord($HstSetString,17) != 1 && getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	if(%item == -1)
		%item = 0;
				
	////////////////////////////////////////////////////////////////////////////////////////////////////

	if(%inv == 0)
	{
		%brName = %brick.getName();
		%brName = getSubStr(%brName,1,strLen(%brName)-1);
		if(ISNameValid(%cl,%brName) == 1)
			return;

		if(%cl.brInv $= "")
		{
			%name = ISGetFile(%cl,%brName);
			if(%name $= "0") 
				return;
			%load = ISLoadItems(%cl,%brName,%name);
		}
		else
		{
			%name = getWord(%cl.brInv,1);
			%load = getWords(%cl.brInv,2,138);
		}

		//////////////////////////////////////////////////

		if(getWord(%load,0) != 0)
		{
			%access = getWord(%load,1);
			%storType = getWord(%load,0);
			%brItms = getWords(%load,9,138);
			%srcBrick = getWord(%load,2);
			%rmtAcc = getWord(%load,3);
			
			if(%num > %storType)
				%num = %storType;
			else if(%num == 0)
				%num = getRandom(1,%storType);

			if(%rmtAcc == 0 && %srcBrick != %brick)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Remote Access Disabled","Remote access is disabled for this inventory save; this is not the source brick. " @
						"Please enable remote access using IS_StoreItems before using other events on it.");
				else
					commandtoClient(%cl,'ISMsgBox',"Remote Access Disabled","error","Remote access is disabled for this inventory save; this is not the source brick. " @
						"Please enable remote access using IS_StoreItems before using other events on it.",0,"");
				return;
			}
			if(ISErrorCheck(%cl,%storType,%access,%load,%brick,%srcBrick,%rmtAcc) == 1)
				return;
			
			//////////////////////////////////////////////////
			
			if(%anyItem)
			{
				for(%c = 0; %check < %num && %c < %storType && %c < 32; %c++)
				{
					%tempItem = getWord(%brItms,(%c*4));
					if(isObject(%tempItem) && %tempItem !$= "WrenchItem" && %tempItem.getClassName() $= "ItemData" && %tempItem.uiName !$= "") //%tempItem > 0?
					{
						%brItms = setWord(%brItms,(%c*4),0);
						%brItms = setWord(%brItms,(%c*4)+1,0);
						%brItms = setWord(%brItms,(%c*4)+2,0);
						%brItms = setWord(%brItms,(%c*4)+3,0);
						%check++;
					}
				}
			}
			else
			{
				for(%c = 0; %check < %num && %c < %storType && %c < 32; %c++)
				{
					%tempItem = getWord(%brItms,(%c*4));
					if(%tempItem == %item)
					{
						%brItms = setWord(%brItms,(%c*4),0);
						%brItms = setWord(%brItms,(%c*4)+1,0);
						%brItms = setWord(%brItms,(%c*4)+2,0);
						%brItms = setWord(%brItms,(%c*4)+3,0);
						%check++;
					}
				}
			}
			
			//////////////////////////////////////////////////
			
			if(ISOverWriteSave(%cl,%name,%brName,%storType,%brItms,%access,%brick) == 1)
				return;

			//Update all necessary client GUIs
			for(%c = 0; %c < clientgroup.getCount(); %c++)
			{
				%tempCl = clientgroup.getObject(%c);
				if(getWord(%tempCl.brInv,8) $= %brName)
				{
					%tempCl.brInv = getWords(%tempCl.brInv,0,10) SPC %brItms;
					
					if(strLen(%brItms) < 255)
						commandToClient(%tempCl,'ISMultRefreshGUI',%brItms,"Br");
					else
					{
						//Gradually load items for all player-GUIs if item data length exceeds network-strings-limit
						%wrdCount = getWordCount(%brItms);
						%loadBrTemp = "";
						%b = 0;
					
						for(%d=0; %d<%wrdCount; %d+=4)
						{
							if(strLen(%loadBrTemp SPC getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3)) < 255)
							{
								%loadBrTemp = %loadBrTemp SPC getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3);

								if((%d+4) >= %wrdCount)
								{
									commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
									break;
								}
							}
							else
							{
								commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
								%loadBrTemp = " " @ getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3);
								%b = %d;
								
								if((%d+4) >= %wrdCount)
								{
									commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
									break;
								}
							}
						}
					}
				}
			}
		}
		else
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"No Save Present",
					"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.");
			else
				commandtoClient(%cl,'ISMsgBox',"No Save Present","error",
					"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.",0,"");
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	else if(%inv == 1)
	{
		if(getWord($HstSetString,2) != 1)
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Backpack Disabled","Backpack storage/usage has been disabled by the server host.");
			else
				commandtoClient(%cl,'ISMsgBox',"Backpack Disabled","error","Backpack storage/usage has been disabled by the server host.",0,"");
			return;
		}
		if(getWord(%cl.ISclInfo,0) != 1 && getWord($HstSetString,3))
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"No Backpack","Backpack item must be equipped to clear items from its inventory.");
			else
				commandtoClient(%cl,'ISMsgBox',"No Backpack","error","Backpack item must be equipped to clear items from its inventory.",0,"");
			return;
		}
	
		if(%cl.bkpkInv !$= "")
		{
			%bkpkItms = getWords(%cl.bkpkInv,3,62);
			%loadBp = getWords(%cl.bkpkInv,1,62);
			%savePres = getWord(%cl.bkpkInv,0);
		}
		else
		{
			%loadBp = ISLoadItems(%cl,%cl.bl_id,"BackPacks");
			%bkpkItms = getWords(%loadBp,2,61);
			
			if(%loadBp == 0)
				%savePres = 0;
			else
				%savePres = 1;
		}
		%bkpkID = ISBackPackItem.getID();
		
		if(%num > 15)
			%num = 15;
		else if(%num == 0)
			%num = getRandom(1,15);
				
		if(%anyItem)
		{
			for(%c = 0; %check < %num && %c < 15; %c++)
			{
				%tempItem = getWord(%bkpkItms,(%c*4));
				if(isObject(%tempItem) && %tempItem !$= %bkpkID && %tempItem !$= "WrenchItem" && %tempItem.getClassName() $= "ItemData" && %tempItem.uiName !$= "") //%tempItem > 0?
				{
					%bkpkItms = setWord(%bkpkItms,(%c*4),0);
					%bkpkItms = setWord(%bkpkItms,(%c*4)+1,0);
					%bkpkItms = setWord(%bkpkItms,(%c*4)+2,0);
					%bkpkItms = setWord(%bkpkItms,(%c*4)+3,0);
					%check++;
				}
			}
		}
		else
		{
			for(%c = 0; %check < %num && %c < 15; %c++)
			{
				%tempItem = getWord(%bkpkItms,(%c*4));
				if(%tempItem == %item)
				{
					%bkpkItms = setWord(%bkpkItms,(%c*4),0);
					%bkpkItms = setWord(%bkpkItms,(%c*4)+1,0);
					%bkpkItms = setWord(%bkpkItms,(%c*4)+2,0);
					%bkpkItms = setWord(%bkpkItms,(%c*4)+3,0);
					%check++;
				}
			}
		}
		
		//////////////////////////////////////////////////
		
		if(%savePres)
		{
			if(ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,%bkpkItms,0,0) == 1)
			{
				ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,getWords(%loadBp,2,61),0,0);
				return;
			}
		}
		else if(ISSaveItems(%cl,%cl.bl_id,"BackPacks",0,%bkpkItms,0) == 1)
		{
			ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,getWords(%loadBp,2,61),0,0);
			return;
		}
		
		if(getWord(%cl.bkpkInv,1) !$= "")//?
			%cl.bkpkInv = getWords(%cl.bkpkInv,0,2) SPC %bkpkItms;
		ISEncumbrance(%cl,"",getWord($HstSetString,18));
		if(%cl.bkpkInv !$= "")
			commandToClient(%cl,'ISMultRefreshGUI',%bkpkItms,"Bp");
	}
}

//////////////////////////////////////////////////////////
//TRANSFER ITEM FROM BRICK INV TO PLAYER INV OR VICE VERSA
//////////////////////////////////////////////////////////
function fxDTSBrick::IS_TransferItem(%brick,%action,%item,%anyItem,%sendAm,%cl)
{
	if(ISSpamCheckEvents(%cl,%brick))
		return;
	if(getWord($HstSetString,17) != 1 && getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
				
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Brick Inv (always loaded for each action)
	
	%brName = %brick.getName();
	%brName = getSubStr(%brName,1,strLen(%brName)-1);
	if(ISNameValid(%cl,%brName) == 1)
		return;
	
	if(%cl.brInv $= "")
	{
		%name = ISGetFile(%cl,%brName);
		if(%name $= "0") 
			return;
		%load = ISLoadItems(%cl,%brName,%name);
	}
	else
	{
		%name = getWord(%cl.brInv,1);
		%load = getWords(%cl.brInv,2,138);
	}
	
	//////////////////////////////////////////////////
	
	if(getWord(%load,0) != 0)
	{
		%access = getWord(%load,1);
		%storType = getWord(%load,0);
		%brItms = getWords(%load,9,138);
		%srcBrick = getWord(%load,2);
		%rmtAcc = getWord(%load,3);
		
		if(%cl.brInv $= "")
		{
			%delBrInv = 1;
			if(getWord(%load,0) != 0)
				%cl.brInv = 1 SPC %name SPC %load;
			else
				%cl.brInv = 0 SPC %name SPC %load;
		}
		
		if(%item == -1)
			return;
		%bkpkID = ISBackPackItem.getID();
		
		if(getWord(%cl.ISclInfo,6) $= "")
		{
			%cl.ISclInfo = setWord(%cl.ISclInfo,6,%brick);
			%delClVar = 1;
		}
		
		//////////////////////////////////////////////////
		
		if(%rmtAcc == 0 && %srcBrick != %brick)
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Remote Access Disabled","Remote access is disabled for this inventory save; this is not the source brick. " @
					"Please enable remote access using IS_StoreItems before using other events on it.");
			else
				commandtoClient(%cl,'ISMsgBox',"Remote Access Disabled","error","Remote access is disabled for this inventory save; this is not the source brick. " @
					"Please enable remote access using IS_StoreItems before using other events on it.",0,"");
			return;
		}
		if(ISErrorCheck(%cl,%storType,%access,%load,%brick,%srcBrick,%rmtAcc) == 1)
			return;
	}
	else
	{
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"No Save Found",
				"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.");
		else
			commandtoClient(%cl,'ISMsgBox',"No Save Found","error",
				"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.",0,"");
		return;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Backpack Inv
	
	if(%action > 1)
	{
		if(getWord($HstSetString,2) != 1)
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Backpack Disabled","Backpack storage/usage has been disabled by the server host.");
			else
				commandtoClient(%cl,'ISMsgBox',"Backpack Disabled","error","Backpack storage/usage has been disabled by the server host.",0,"");
			return;
		}
		if(getWord(%cl.ISclInfo,0) != 1 && getWord($HstSetString,3))
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"No Backpack","Can't transfer items to/from backpack if you don't have it equipped.");
			else
				commandtoClient(%cl,'ISMsgBox',"No Backpack","error","Can't transfer items to/from backpack if you don't have it equipped.",0,"");
			return;
		}
	
		if(%cl.bkpkInv !$= "")
		{
			%bkpkItms = getWords(%cl.bkpkInv,3,62);
			%loadBp = getWords(%cl.bkpkInv,1,62);
		}
		else
		{
			%loadBp = ISLoadItems(%cl,%cl.bl_id,"BackPacks");
			%bkpkItms = getWords(%loadBp,2,61);
			
			%delBkpkInv = 1;
			if(getWord(%loadBp,0) != 0)
				%cl.bkpkInv = 1 SPC %loadBp;
			else
				%cl.bkpkInv = 0 SPC %loadBp;
		}
		
		//////////////////////////////////////////////////
		//Transfering an item from brick to backpack (search bkpk for empty cell or cell w/ same item)
		
		if(%action == 2)
		{
			//Brick Inv
			if(%anyItem)
			{
				for(%c=0; %c<%storType && %c<32; %c++)
				{
					%tempItem = getWord(%brItms,(%c*4));
					%tempItemAm = getWord(%brItms,(%c*4)+1);
					
					if(%sendAm == 0)
						%tempsendAm = %tempItemAm;
					else if(%sendAm == -1)
						%tempsendAm = getRandom(1,%tempItemAm);
					else
						%tempsendAm = %sendAm;
					
					if(isObject(%tempItem) && %tempItem != %bkpkID && %tempItem.getClassName() $= "ItemData" && %tempItem.uiName !$= "" && %tempItemAm >= %tempsendAm)
					{
						%cellA = "brStor" @ %c;
						%foundA = 1;
						break;
					}
				}
			}
			else
			{
				if(%item == %bkpkID)
				{
					if(getWord(%cl.ISclInfo,2) != 4)
						commandtoClient(%cl,'messageboxOK',"Illegal Move","Can't add a backpack item to a backpack's inventory.");
					else
						commandtoClient(%cl,'ISMsgBox',"Illegal Move","error","Can't add a backpack item to a backpack's inventory.",0,"");
					return;
				}
				
				for(%c=0; %c<%storType && %c<32; %c++)
				{
					%tempItem = getWord(%brItms,(%c*4));
					%tempItemAm = getWord(%brItms,(%c*4)+1);
					
					if(%sendAm == 0)
						%tempsendAm = %tempItemAm;
					else if(%sendAm == -1)
						%tempsendAm = getRandom(1,%tempItemAm);
					else
						%tempsendAm = %sendAm;
						
					if(%tempItem == %item && %tempItemAm >= %tempsendAm)
					{
						%cellA = "brStor" @ %c;
						%foundA = 1;
						break;
					}
				}
			}
			if(%foundA != 1)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Not Found","Transferable stack not found in brick's inventory.");
				else
					commandtoClient(%cl,'ISMsgBox',"Not Found","error","Transferable stack not found in brick's inventory.",0,"");
				return;
			}

			//////////////////////////////////////////////////
			
			//Backpack Inv
			for(%c=0; %c<15; %c++)
			{
				%tempItemB = getWord(%bkpkItms,(%c*4));
				%tempItemAm = getWord(%bkpkItms,(%c*4)+1);
				%tempSkAm = getWord($itemSetArray[%tempItemB],0);
				
				if(%tempItemB == 0 || (%tempItemB == %tempItem && (%tempSkAm - %tempItemAm) >= %tempsendAm))
				{
					%cellB = "bpStor" @ %c;
					%foundB = 1;
					break;
				}
			}
			if(%foundB != 1)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"No Room For Stack","No room for stack in backpack's inventory.");
				else
					commandtoClient(%cl,'ISMsgBox',"No Room For Stack","error","No room for stack in backpack's inventory.",0,"");
				return;
			}
		}
		
		//////////////////////////////////////////////////
		//Backpack to Brick
		
		else if(%action == 3)
		{
			//Backpack Inv
			if(%anyItem)
			{
				for(%c=0; %c<15; %c++)
				{
					%tempItem = getWord(%bkpkItms,(%c*4));
					%tempItemAm = getWord(%bkpkItms,(%c*4)+1);
					
					if(%sendAm == 0)
						%tempsendAm = %tempItemAm;
					else if(%sendAm == -1)
						%tempsendAm = getRandom(1,%tempItemAm);
					else
						%tempsendAm = %sendAm;
						
					if(isObject(%tempItem) && %tempItem != %bkpkID && %tempItem.getClassName() $= "ItemData" && %tempItem.uiName !$= "" && %tempItemAm >= %tempsendAm)
					{
						%cellA = "bpStor" @ %c;
						%foundA = 1;
						break;
					}
				}
			}
			else
			{
				for(%c=0; %c<15; %c++)
				{
					%tempItem = getWord(%bkpkItms,(%c*4));
					%tempItemAm = getWord(%bkpkItms,(%c*4)+1);
					
					if(%sendAm == 0)
						%tempsendAm = %tempItemAm;
					else if(%sendAm == -1)
						%tempsendAm = getRandom(1,%tempItemAm);
					else
						%tempsendAm = %sendAm;
						
					if(%tempItem == %item && %tempItemAm >= %tempsendAm)
					{
						%cellA = "bpStor" @ %c;
						%foundA = 1;
						break;
					}
				}
			}
			if(%foundA != 1)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Not Found","Transferable stack not found in backpack's inventory.");
				else
					commandtoClient(%cl,'ISMsgBox',"Not Found","error","Transferable stack not found in backpack's inventory.",0,"");
				return;
			}
			
			//////////////////////////////////////////////////
			
			//Brick Inv
			for(%c=0; %c<%storType && %c<32; %c++)
			{
				%tempItemB = getWord(%brItms,(%c*4));
				%tempItemAm = getWord(%brItms,(%c*4)+1);
				%tempSkAm = getWord($itemSetArray[%tempItemB],0);
				
				if(%tempItemB == 0 || (%tempItemB == %tempItem && (%tempSkAm - %tempItemAm) >= %tempsendAm))
				{
					%cellB = "brStor" @ %c;
					%foundB = 1;
					break;
				}
			}			
			if(%foundB != 1)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"No Room For Stack","No room for stack in brick's inventory.");
				else
					commandtoClient(%cl,'ISMsgBox',"No Room For Stack","error","No room for stack in brick's inventory.",0,"");
				return;
			}
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Player Inv
	
	if(%action < 2)
	{
		%mxTls = %cl.player.getDatablock().maxTools;
		
		//////////////////////////////////////////////////
		//Transfering an item from brick to player
		
		if(%action == 0)
		{
			//Brick Inv
			if(%anyItem)
			{
				for(%c=0; %c<%storType && %c<32; %c++)
				{
					%tempItem = getWord(%brItms,(%c*4));
					%tempItemAm = getWord(%brItms,(%c*4)+1);
					%tempsendAm = 1;
					
					if(isObject(%tempItem) && %tempItem.getClassName() $= "ItemData" && %tempItem.uiName !$= "")
					{
						if(%tempItem == %bkpkID)
						{
							for(%d=0; %d<%mxTls && %d<10; %d++)
							{
								%tempItemC = %cl.player.tool[%d];
								if(%tempItemC == %bkpkID)
									%foundC = 1;
							}	
							if(%foundC != 1)
							{
								%cellA = "brStor" @ %c;
								%foundA = 1;
								break;
							}
						}
						else
						{
							%cellA = "brStor" @ %c;
							%foundA = 1;
							break;
						}
					}
				}
			}
			else
			{
				for(%c=0; %c<%storType && %c<32; %c++)
				{
					%tempItem = getWord(%brItms,(%c*4));
					%tempItemAm = getWord(%brItms,(%c*4)+1);
					%tempsendAm = 1;
					
					if(%tempItem == %item)
					{
						%cellA = "brStor" @ %c;
						%foundA = 1;
						break;
					}
				}
			}
			if(%foundA != 1)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Not Found","Transferable stack not found in brick's inventory.");
				else
					commandtoClient(%cl,'ISMsgBox',"Not Found","error","Transferable stack not found in brick's inventory.",0,"");
				return;
			}
			
			//////////////////////////////////////////////////
			
			//Player Inv
			for(%c=0; %c<%mxTls && %c<10; %c++)
			{
				%tempItem = %cl.player.tool[%c]; //prevent mult bkpks and swapping stack of items via isrefresh function
				if(%tempItem == 0)
				{
					%cellB = "plStor" @ %c;
					%foundB = 1;
					break;
				}
			}			
			if(%foundB != 1)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"No Room For Stack","No room for stack in player inventory.");
				else
					commandtoClient(%cl,'ISMsgBox',"No Room For Stack","error","No room for stack in player inventory.",0,"");
				return;
			}
		}
		
		//////////////////////////////////////////////////
		//Player to Brick
		
		else if(%action == 1)
		{				
			//Player Inv
			if(%anyItem)
			{
				for(%c=0; %c<%mxTls && %c<10; %c++)
				{
					%tempItem = %cl.player.tool[%c];
					%tempsendAm = 1;
					
					if(isObject(%tempItem) && %tempItem.getClassName() $= "ItemData" && %tempItem.uiName !$= "")
					{
						%cellA = "plStor" @ %c;
						%foundA = 1;
						break;
					}
				}
			}
			else
			{
				for(%c=0; %c<%mxTls && %c<10; %c++)
				{
					%tempItem = %cl.player.tool[%c];
					%tempsendAm = 1;
					
					if(%tempItem == %item)
					{
						%cellA = "plStor" @ %c;
						%foundA = 1;
						break;
					}
				}
			}
			if(%foundA != 1)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Not Found","Transferable stack not found in player inventory.");
				else
					commandtoClient(%cl,'ISMsgBox',"Not Found","error","Transferable stack not found in player inventory.",0,"");
				return;
			}
			
			//////////////////////////////////////////////////
			
			//Brick Inv
			for(%c=0; %c<%storType && %c<32; %c++)
			{
				%tempItemB = getWord(%brItms,(%c*4));
				%tempItemAm = getWord(%brItms,(%c*4)+1);
				%tempSkAm = getWord($itemSetArray[%tempItemB],0);
				
				if(%tempItemB == 0 || (%tempItemB == %tempItem && (%tempSkAm - %tempItemAm) >= %tempsendAm))
				{
					%cellB = "brStor" @ %c;
					%foundB = 1;
					break;
				}
			}			
			if(%foundB != 1)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"No Room For Stack","No room for stack in brick's inventory.");
				else
					commandtoClient(%cl,'ISMsgBox',"No Room For Stack","error","No room for stack in brick's inventory.",0,"");
				return;
			}
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	//refresh
	ServerCmdISRefresh(%cl,%cellB,%cellA,0,%tempsendAm); //don't exec events in function
	fxDTSBrick::onISEventInput(%brick,%cl,8);
	
	//clear methods if they didn't exist prior to event execution (i.e. GUI not open)
	if(%delBrInv)
		%cl.brInv = "";
	if(%delBkpkInv)
		%cl.bkpkInv = "";
	if(%delPlyrInv)
		%cl.plyrInv = "";
	if(%delClVar)
		%cl.ISclInfo = setWord(%cl.ISclInfo,6,"");
			
}

//////////////////////////////////////////////
//CHECK IF ITEM PRESENT IN SPECIFIED INVENTORY
//////////////////////////////////////////////
function fxDTSBrick::IS_ifItemPresent(%brick,%inv,%itemSpecs,%anyItem,%relOutput,%cl) //option to check remote inv too?
{
	if(ISSpamCheckEvents(%cl,%brick))
		return;
	if(getWord($HstSetString,17) != 1 && getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	%item = getWord(%itemSpecs,0);
	if(%item == -1)
		%item = 0;

	if(%inv != 0)
	{
		if(%inv != 1)
		{
			//////////////////////////////////////////////////
			//Check backpack inventory
			
			if(%inv == 2)
			{
				if(getWord($HstSetString,2) != 1)
				{
					if(getWord(%cl.ISclInfo,2) != 4)
						commandtoClient(%cl,'messageboxOK',"Backpack Disabled","Backpack storage/usage has been disabled by the server host.");
					else
						commandtoClient(%cl,'ISMsgBox',"Backpack Disabled","error","Backpack storage/usage has been disabled by the server host.",0,"");
					return;
				}
				if(getWord(%cl.ISclInfo,0) != 1 && getWord($HstSetString,3))
				{
					if(getWord(%cl.ISclInfo,2) != 4)
						commandtoClient(%cl,'messageboxOK',"No Backpack","Backpack item must be equipped to access it's inventory.");
					else
						commandtoClient(%cl,'ISMsgBox',"No Backpack","error","Backpack item must be equipped to access it's inventory.",0,"");
					return;
				}
		
				if(getWord(%itemSpecs,2) $= "" && getWord(%itemSpecs,3) $= "")
				{
					%cellA = 0;
					%cellB = 15;
				}
				else
				{
					%cellA = mAbs(mFloatLength(getWord(%itemSpecs,2),0));
					%cellB = mAbs(mFloatLength(getWord(%itemSpecs,3),0));
					
					if(%cellB > 15)
						%cellB = 15;
					if(%cellA >= 15 || %cellA >= %cellB)
						return;
				}
				if(getWord(%cl.ISclInfo,0) == 1 || getWord($HstSetString,3) == 0)
				{
					if(%cl.bkpkInv !$= "")
					{
						%bkpkItms = getWords(%cl.bkpkInv,3,62);
						%savePres = getWord(%cl.bkpkInv,0);
					}
					else
					{
						%loadBp = ISLoadItems(%cl,%cl.bl_id,"BackPacks");
						%bkpkItms = getWords(%loadBp,2,61);
						
						if(%loadBp == 0)
							%savePres = 0;
						else
							%savePres = 1;
					}
					
					if(%savePres)
					{
						if(%anyItem == 0)
						{
							%stckAm = mAbs(mFloatLength(getWord(%itemSpecs,1),0));
							if(%stckAm > 999)
								%stckAm = 999;
								
							for(%c = %cellA; %c < %cellB; %c++)
							{
								if(getWord(%bkpkItms,(%c*4)) == %item)
								{
									if(%stckAm > 0)
									{
										if(getWord(%bkpkItms,(%c*4)+1) == %stckAm)
										{
											if(%relOutput !$= "")
												IS_RelOutputConditions(%cl,%brick,%relOutput,6);
											else
												fxDTSBrick::onISEventInput(%brick,%cl,6);
											return;
										}
									}
									else
									{
										if(%relOutput !$= "")
											IS_RelOutputConditions(%cl,%brick,%relOutput,6);
										else
											fxDTSBrick::onISEventInput(%brick,%cl,6);
										return;
									}
								}
							}
							if(%relOutput !$= "")
								IS_RelOutputConditions(%cl,%brick,%relOutput,7);
							else
								fxDTSBrick::onISEventInput(%brick,%cl,7);
						}
						else
						{
							for(%c = %cellA; %c < %cellB; %c++)
							{
								%item = getWord(%bkpkItms,(%c*4));
								if(isObject(%item) && %item.getClassName() $= "ItemData" && %item.uiName !$= "")
								{
									%stckAm = mAbs(mFloatLength(getWord(%itemSpecs,1),0));
									if(%stckAm > 999)
										%stckAm = 999;
									
									if(%stckAm > 0)
									{
										if(getWord(%bkpkItms,(%c*4)+1) == %stckAm)
										{
											if(%relOutput !$= "")
												IS_RelOutputConditions(%cl,%brick,%relOutput,6);
											else
												fxDTSBrick::onISEventInput(%brick,%cl,6);
											return;
										}
									}
									else
									{
										if(%relOutput !$= "")
											IS_RelOutputConditions(%cl,%brick,%relOutput,6);
										else
											fxDTSBrick::onISEventInput(%brick,%cl,6);
										return;
									}
								}
							}
							if(%relOutput !$= "")
								IS_RelOutputConditions(%cl,%brick,%relOutput,7);
							else
								fxDTSBrick::onISEventInput(%brick,%cl,7);
						}
					}
					else
						if(%relOutput !$= "")
							IS_RelOutputConditions(%cl,%brick,%relOutput,7);
						else
							fxDTSBrick::onISEventInput(%brick,%cl,7);
				}
				else
					if(%relOutput !$= "")
						IS_RelOutputConditions(%cl,%brick,%relOutput,7);
					else
						fxDTSBrick::onISEventInput(%brick,%cl,7);
			}
		}
		
		//////////////////////////////////////////////////
		//Check brick inventory
		
		else
		{
			%brName = %brick.getName();
			%brName = getSubStr(%brName,1,strLen(%brName)-1);
			if(ISNameValid(%cl,%brName) == 1)
				return;
			
			if(%cl.brInv $= "")
			{
				%name = ISGetFile(%cl,%brName);
				if(%name $= "0") 
					return;
				%load = ISLoadItems(%cl,%brName,%name);
			}
			else
			{
				%name = getWord(%cl.brInv,1);
				%load = getWords(%cl.brInv,2,138);
			}
			
			//////////////////////////////////////////////////
			
			if(getWord(%load,0) != 0)
			{
				%access = getWord(%load,1);
				%storType = getWord(%load,0);
				%brItms = getWords(%load,9,138);
				%srcBrick = getWord(%load,2);
				%rmtAcc = getWord(%load,3);

				if(%rmtAcc == 0 && %srcBrick != %brick)
				{
					if(getWord(%cl.ISclInfo,2) != 4)
						commandtoClient(%cl,'messageboxOK',"Remote Access Disabled","Remote access is disabled for this inventory save; this is not the source brick. " @
							"Please enable remote access using IS_StoreItems before using other events on it.");
					else
						commandtoClient(%cl,'ISMsgBox',"Remote Access Disabled","error","Remote access is disabled for this inventory save; this is not the source brick. " @
							"Please enable remote access using IS_StoreItems before using other events on it.",0,"");
					return;
				}
				if(ISErrorCheck(%cl,%storType,%access,%load,%brick,%srcBrick,%rmtAcc) == 1)
					return;
					
				if(getWord(%itemSpecs,2) $= "" && getWord(%itemSpecs,3) $= "")
				{
					%cellA = 0;
					%cellB = %storType;
				}
				else
				{
					%cellA = mAbs(mFloatLength(getWord(%itemSpecs,2),0));
					%cellB = mAbs(mFloatLength(getWord(%itemSpecs,3),0));
					
					if(%cellB > %storType)
						%cellB = %storType;
					if(%cellA >= %storType || %cellA >= %cellB)
						return;
				}
				
				//////////////////////////////////////////////////
				
				if(%anyItem == 0)
				{
					%stckAm = mAbs(mFloatLength(getWord(%itemSpecs,1),0));
					if(%stckAm > 999)
						%stckAm = 999;
									
					for(%c = %cellA; %c < %storType && %c < %cellB; %c++)
					{
						if(getWord(%brItms,(%c*4)) == %item)
						{
							if(%stckAm > 0)
							{
								if(getWord(%brItms,(%c*4)+1) == %stckAm)
								{
									if(%relOutput !$= "")
										IS_RelOutputConditions(%cl,%brick,%relOutput,6);
									else
										fxDTSBrick::onISEventInput(%brick,%cl,6);
									return;
								}
							}
							else
							{
								if(%relOutput !$= "")
									IS_RelOutputConditions(%cl,%brick,%relOutput,6);
								else
									fxDTSBrick::onISEventInput(%brick,%cl,6);
								return;
							}
						}
					}
					if(%relOutput !$= "")
						IS_RelOutputConditions(%cl,%brick,%relOutput,7);
					else
						fxDTSBrick::onISEventInput(%brick,%cl,7);
				}
				else
				{
					for(%c = %cellA; %c < %storType && %c < %cellB; %c++)
					{
						%item = getWord(%brItms,(%c*4));
						if(isObject(%item) && %item.getClassName() $= "ItemData" && %item.uiName !$= "")
						{
							%stckAm = mAbs(mFloatLength(getWord(%itemSpecs,1),0));
							if(%stckAm > 999)
								%stckAm = 999;

							if(%stckAm > 0)
							{
								if(getWord(%brItms,(%c*4)+1) == %stckAm)
								{
									if(%relOutput !$= "")
										IS_RelOutputConditions(%cl,%brick,%relOutput,6);
									else
										fxDTSBrick::onISEventInput(%brick,%cl,6);
									return;
								}
							}
							else
							{
								if(%relOutput !$= "")
									IS_RelOutputConditions(%cl,%brick,%relOutput,6);
								else
									fxDTSBrick::onISEventInput(%brick,%cl,6);
								return;
							}
						}
					}
					if(%relOutput !$= "")
						IS_RelOutputConditions(%cl,%brick,%relOutput,7);
					else
						fxDTSBrick::onISEventInput(%brick,%cl,7);
				}
			}
			else
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"No Save Present",
						"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.");
				else
					commandtoClient(%cl,'ISMsgBox',"No Save Present","error",
						"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.",0,"");
			}
		}
	}
	
	//////////////////////////////////////////////////
	//Check player inventory
	
	else
	{
		%mxTls = %cl.player.getDatablock().maxTools;
		if(getWord(%itemSpecs,2) $= "" && getWord(%itemSpecs,3) $= "")
		{
			%cellA = 0;
			%cellB = %mxTls;
		}
		else
		{
			%cellA = mAbs(mFloatLength(getWord(%itemSpecs,2),0));
			%cellB = mAbs(mFloatLength(getWord(%itemSpecs,3),0));
			
			if(%cellB > %mxTls)
				%cellB = %mxTls;
			if(%cellA >= %mxTls || %cellA >= %cellB)
				return;
		}
				
		if(%anyItem == 0)
		{
			%stckAm = mAbs(mFloatLength(getWord(%itemSpecs,1),0));
			if(%stckAm > 999)
				%stckAm = 999;
							
			for(%c = %cellA; %c < 10 && %c < %cellB; %c++)
			{
				%itemB = %cl.player.tool[%c];
				if(%itemB == %item)
				{
					if(%stckAm > 0)
					{
						if(%itemB == %stckAm)
						{
							if(%relOutput !$= "")
								IS_RelOutputConditions(%cl,%brick,%relOutput,6);
							else
								fxDTSBrick::onISEventInput(%brick,%cl,6);
							return;
						}
					}
					else
					{
						if(%relOutput !$= "")
							IS_RelOutputConditions(%cl,%brick,%relOutput,6);
						else
							fxDTSBrick::onISEventInput(%brick,%cl,6);
						return;
					}
				}
			}
			if(%relOutput !$= "")
				IS_RelOutputConditions(%cl,%brick,%relOutput,7);
			else
				fxDTSBrick::onISEventInput(%brick,%cl,7);
		}
		else
		{
			for(%c = %cellA; %c < 10 && %c < %cellB; %c++)
			{
				%item = %cl.player.tool[%c];
				if(isObject(%item) && %item.getClassName() $= "ItemData" && %item.uiName !$= "")
				{
					%stckAm = mAbs(mFloatLength(getWord(%itemSpecs,1),0));
					if(%stckAm > 999)
						%stckAm = 999;
							
					if(%stckAm > 0)
					{
						if(%item == %stckAm)
						{
							if(%relOutput !$= "")
								IS_RelOutputConditions(%cl,%brick,%relOutput,6);
							else
								fxDTSBrick::onISEventInput(%brick,%cl,6);
							return;
						}
					}
					else
					{
						if(%relOutput !$= "")
							IS_RelOutputConditions(%cl,%brick,%relOutput,6);
						else
							fxDTSBrick::onISEventInput(%brick,%cl,6);
						return;
					}
				}
			}
			if(%relOutput !$= "")
				IS_RelOutputConditions(%cl,%brick,%relOutput,7);
			else
				fxDTSBrick::onISEventInput(%brick,%cl,7);
		}
	}
}

///////////////////////////////////////
//CHECK IF TWO INVENTORIES ARE THE SAME
///////////////////////////////////////
function fxDTSBrick::IS_ifInvSameAs(%brick,%matchSpec,%matchSize,%invB,%relOutput,%cl)
{
	if(ISSpamCheckEvents(%cl,%brick))
		return;
	if(getWord($HstSetString,17) != 1 && getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
		
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	%brName = %brick.getName();
	%brName = getSubStr(%brName,1,strLen(%brName)-1);
	if(ISNameValid(%cl,%brName) == 1)
		return;
	
	if(%cl.brInv $= "")
	{
		%name = ISGetFile(%cl,%brName);
		if(%name $= "0") 
			return;
		%load = ISLoadItems(%cl,%brName,%name);
	}
	else
	{
		%name = getWord(%cl.brInv,1);
		%load = getWords(%cl.brInv,2,138);
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if(getWord(%load,0) != 0)
	{
		%access = getWord(%load,1);
		%storType = getWord(%load,0);
		%brItms = getWords(%load,9,138);
		%srcBrick = getWord(%load,2);
		%rmtAcc = getWord(%load,3);
		
		if(%rmtAcc == 0 && %srcBrick != %brick)
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Remote Access Disabled","Remote access is disabled for inventory: \"" @ %brName @
					"\"; this is not the source brick. Please enable remote access using IS_StoreItems before using other events on it.");
			else
				commandtoClient(%cl,'ISMsgBox',"Remote Access Disabled","error","Remote access is disabled for inventory: \"" @ %brName @
					"\"; this is not the source brick. Please enable remote access using IS_StoreItems before using other events on it.",0,"");
			return;
		}
		if(ISErrorCheck(%cl,%storType,%access,%load,%brick,%srcBrick,%rmtAcc) == 1)
			return;
		
		//////////////////////////////////////////////////
		//Inventory B
		
		if(ISNameValid(%cl,%invB) == 1)
			return;
		
		//Check if load present
		%nameB = ISGetFile(%cl,%invB);
		if(%nameB $= "0")
			return;
		%loadB = ISLoadItems(%cl,%invB,%nameB);
		
		//////////////////////////////////////////////////
		
		if(getWord(%loadB,0) != 0)
		{
			%accessB = getWord(%loadB,1);
			%storTypeB = getWord(%loadB,0);
			%brItmsB = getWords(%loadB,9,getWordCount(%loadB));
			%srcBrickB = getWord(%loadB,2);
			%rmtAccB = getWord(%loadB,3);
			
			if(%rmtAccB == 0  && %srcBrickB != %brick)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Remote Access Disabled","Remote access is disabled for inventory: \"" @ %invB @
						"\"; this is not the source brick. Please enable remote access using IS_StoreItems before using other events on it.");
				else
					commandtoClient(%cl,'ISMsgBox',"Remote Access Disabled","error","Remote access is disabled for inventory: \"" @ %invB @
						"\"; this is not the source brick. Please enable remote access using IS_StoreItems before using other events on it.",0,"");
				return;
			}
			if(ISErrorCheck(%cl,%storTypeB,%accessB,%loadB,%brick,%srcBrickB,%rmtAccB) == 1)
				return;		
	
			////////////////////////////////////////////////////////////////////////////////////////////////////
			//Compare inventories
			
			//Make sure inventory sizes match, if required
			if(%matchSize && %storType != %storTypeB)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Error","Inventory sizes don't match.");
				else
					commandtoClient(%cl,'ISMsgBox',"Error","error","Inventory sizes don't match.",0,"");
				return;
			}
			
			//////////////////////////////////////////////////
			
			if(%matchSpec != 0)
			{
				if(%matchSpec != 1)
				{
					if(%matchSpec != 2)
					{
						//////////////////////////////////////////////////
						//If ignoring item positions and stacks; only matching items
						
						if(%matchSpec == 3)
						{
							for(%c = 0; %c < 32; %c++)
							{
								for(%d = 0; %d < 32; %d++)
								{
									if(getWord(%ItmPass,(%d)) != 1 && getWord(%brItmsB,(%c*4)) == getWord(%brItms,(%d*4)))
									{
										%ItmPass = setWord(%ItmPass,%d,1);
										break;
									}
								}
							}
							for(%c = 0; %c < 32; %c++)
							{
								if(getWord(%ItmPass,%c) != 1)
								{
									if(%relOutput !$= "")
										IS_RelOutputConditions(%cl,%brick,%relOutput,7);
									else
										fxDTSBrick::onISEventInput(%brick,%cl,7);
									return;
								}
							}
							if(%relOutput !$= "")
								IS_RelOutputConditions(%cl,%brick,%relOutput,6);
							else
								fxDTSBrick::onISEventInput(%brick,%cl,6);
						}
					}
					
					//////////////////////////////////////////////////
					//If matching items with exact position and item stacks as other inventory
					
					else
					{
						for(%c = 0; %c < 32; %c++)
						{
							if(getWord(%brItmsB,(%c*4)) != getWord(%brItms,(%c*4)))
							{
								if(%relOutput !$= "")
									IS_RelOutputConditions(%cl,%brick,%relOutput,7);
								else
									fxDTSBrick::onISEventInput(%brick,%cl,7);
								return;
							}
							else if(getWord(%brItmsB,(%c*4)+1) != getWord(%brItms,(%c*4)+1))
							{
								if(%relOutput !$= "")
									IS_RelOutputConditions(%cl,%brick,%relOutput,7);
								else
									fxDTSBrick::onISEventInput(%brick,%cl,7);
								return;
							}
						}
						if(%relOutput !$= "")
							IS_RelOutputConditions(%cl,%brick,%relOutput,6);
						else
							fxDTSBrick::onISEventInput(%brick,%cl,6);
					}
				}
				
				//////////////////////////////////////////////////
				//If ignoring item positions, but matching items and stacks
				
				else
				{
					for(%c = 0; %c < 32; %c++)
					{
						for(%d = 0; %d < 32; %d++)
						{
							if(getWord(%ItmPass,(%d)) != 1 && getWord(%brItmsB,(%c*4)) == getWord(%brItms,(%d*4)))
							{
								if(getWord(%brItmsB,(%c*4)+1) == getWord(%brItms,(%d*4)+1))
								{
									%ItmPass = setWord(%ItmPass,%d,1);
									break;
								}
							}
						}
					}
					for(%c = 0; %c < 32; %c++)
					{
						if(getWord(%ItmPass,%c) != 1)
						{
							if(%relOutput !$= "")
								IS_RelOutputConditions(%cl,%brick,%relOutput,7);
							else
								fxDTSBrick::onISEventInput(%brick,%cl,7);
							return;
						}
					}
					if(%relOutput !$= "")
						IS_RelOutputConditions(%cl,%brick,%relOutput,6);
					else
						fxDTSBrick::onISEventInput(%brick,%cl,6);
				}
			}
			
			//////////////////////////////////////////////////
			//If matching items with exact position as other inventory, but ignoring item stacks
			
			else
			{
				for(%c = 0; %c < 32; %c++)
				{
					if(getWord(%brItmsB,(%c*4)) != getWord(%brItms,(%c*4)))
					{
						if(%relOutput !$= "")
							IS_RelOutputConditions(%cl,%brick,%relOutput,7);
						else
							fxDTSBrick::onISEventInput(%brick,%cl,7);
						return;
					}
				}
				if(%relOutput !$= "")
					IS_RelOutputConditions(%cl,%brick,%relOutput,6);
				else
					fxDTSBrick::onISEventInput(%brick,%cl,6);
			}
		}
		
		//////////////////////////////////////////////////
		
		else
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Save Not Found","Inventory save not found for given name.");
			else
				commandtoClient(%cl,'ISMsgBox',"Save Not Found","error","Inventory save not found for given name.",0,"");
			return;
		}
	}
	else
	{
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"No Save Present",
				"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.");
		else
			commandtoClient(%cl,'ISMsgBox',"No Save Present","error",
				"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.",0,"");
		return;
	}
}

/////////////////////////////////////////////
//COPY INVENTORY FROM OR TO ANOTHER INVENTORY
/////////////////////////////////////////////
function fxDTSBrick::IS_CopyInv(%brick,%action,%invB,%cl)
{
	if(ISSpamCheckEvents(%cl,%brick))
		return;
	if(getWord($HstSetString,17) != 1 && getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	%brName = %brick.getName();
	%brName = getSubStr(%brName,1,strLen(%brName)-1);
	if(ISNameValid(%cl,%brName) == 1 || %brName $= %invB)
		return;
	
	if(%cl.brInv $= "")
	{
		%name = ISGetFile(%cl,%brName);
		if(%name $= "0") 
			return;
		%load = ISLoadItems(%cl,%brName,%name);
	}
	else
	{
		%name = getWord(%cl.brInv,1);
		%load = getWords(%cl.brInv,2,138);
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if(getWord(%load,0) != 0)
	{
		%access = getWord(%load,1);
		%storType = getWord(%load,0);
		%brItms = getWords(%load,9,138);
		%srcBrick = getWord(%load,2);
		%rmtAcc = getWord(%load,3);
		
		if(%rmtAcc == 0 && %srcBrick != %brick)
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Remote Access Disabled","Remote access is disabled for inventory: \"" @ %brName @
				"\"; this is not the source brick. Please enable remote access using IS_StoreItems before using other events on it.");
			else
				commandtoClient(%cl,'ISMsgBox',"Remote Access Disabled","error","Remote access is disabled for inventory: \"" @ %brName @
				"\"; this is not the source brick. Please enable remote access using IS_StoreItems before using other events on it.",0,"");
			return;
		}
		if(ISErrorCheck(%cl,%storType,%access,%load,%brick,%srcBrick,%rmtAcc) == 1)
			return;
		
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//Inventory B
		
		if(ISNameValid(%cl,%invB) == 1)
			return;
		
		%nameB = ISGetFile(%cl,%invB);
		if(%nameB $= "0")
			return;
		%loadB = ISLoadItems(%cl,%invB,%nameB);
		
		//////////////////////////////////////////////////
		
		if(getWord(%loadB,0) != 0)
		{
			%accessB = getWord(%loadB,1);
			%storTypeB = getWord(%loadB,0);
			%brItmsB = getWords(%loadB,9,getWordCount(%loadB));
			%srcBrickB = getWord(%loadB,2);
			%rmtAccB = getWord(%loadB,3);
		
			if(%rmtAccB == 1 || %srcBrickB == %brick)
			{
				if(%storType == %storTypeB)
				{
					if(ISErrorCheck(%cl,%storTypeB,%accessB,%loadB,%brick,%srcBrickB,%rmtAccB))
						return;
					
					//////////////////////////////////////////////////
					//From invB to original inv (From)
					
					if(%action == 0)
					{
						if(ISOverWriteSave(%cl,%name,%brName,%storType,%brItmsB,%access,%brick))
							return;
							
						for(%c = 0; %c < clientgroup.getCount(); %c++)
						{
							%tempCl = clientgroup.getObject(%c);
							if(getWord(%tempCl.brInv,8) $= %brName)
							{
								%tempCl.brInv = getWords(%tempCl.brInv,0,10) SPC %brItmsB;
								
								if(strLen(%brItmsB) < 255)
									commandToClient(%tempCl,'ISMultRefreshGUI',%brItmsB,"Br");
								else
								{
									//Gradually load items for all player-GUIs if item data length exceeds network-strings-limit
									%wrdCount = getWordCount(%brItmsB);
									%loadBrTemp = "";
									%b = 0;
					
									for(%d=0; %d<%wrdCount; %d+=4)
									{
										if(strLen(%loadBrTemp SPC getWord(%brItmsB,%d) SPC getWord(%brItmsB,%d+1) SPC getWord(%brItmsB,%d+2) SPC getWord(%brItmsB,%d+3)) < 255)
										{
											%loadBrTemp = %loadBrTemp SPC getWord(%brItmsB,%d) SPC getWord(%brItmsB,%d+1) SPC getWord(%brItmsB,%d+2) SPC getWord(%brItmsB,%d+3);
											
											if((%d+4) >= %wrdCount)
											{
												commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
												break;
											}
										}
										else
										{
											commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
											%loadBrTemp = " " @ getWord(%brItmsB,%d) SPC getWord(%brItmsB,%d+1) SPC getWord(%brItmsB,%d+2) SPC getWord(%brItmsB,%d+3);
											%b = %d;
											
											if((%d+4) >= %wrdCount)
											{
												commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
												break;
											}
										}
									}
								}
							}
						}
					}
					
					//////////////////////////////////////////////////
					//From original inv to invB (To)
					
					else
					{
						if(ISOverWriteSave(%cl,%nameB,%invB,%storTypeB,%brItms,%accessB,%brick))
							return;
						
						for(%c = 0; %c < clientgroup.getCount(); %c++)
						{
							%tempCl = clientgroup.getObject(%c);
							if(getWord(%tempCl.brInv,8) $= %invB)
							{
								%tempCl.brInv = getWords(%tempCl.brInv,0,10) SPC %brItms;
								
								if(strLen(%brItms) < 255)
									commandToClient(%tempCl,'ISMultRefreshGUI',%brItms,"Br");
								else
								{
									//Gradually load items for all player-GUIs if item data length exceeds network-strings-limit
									%wrdCount = getWordCount(%brItms);
									%loadBrTemp = "";
									%b = 0;
									
									for(%d=0; %d<%wrdCount; %d+=4)
									{
										if(strLen(%loadBrTemp SPC getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3)) < 255)
										{
											%loadBrTemp = %loadBrTemp SPC getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3);
											
											if((%d+4) >= %wrdCount)
											{
												commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
												break;
											}
										}
										else
										{
											commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
											%loadBrTemp = " " @ getWord(%brItms,%d) SPC getWord(%brItms,%d+1) SPC getWord(%brItms,%d+2) SPC getWord(%brItms,%d+3);
											%b = %d;
											
											if((%d+4) >= %wrdCount)
											{
												commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC %d,getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
												break;
											}
										}
									}
								}
							}
						}
					}
				}
				else
				{
					if(getWord(%cl.ISclInfo,2) != 4)
						commandtoClient(%cl,'messageboxOK',"Error","Inventory sizes do not match.");
					else
						commandtoClient(%cl,'ISMsgBox',"Error","error","Inventory sizes do not match.",0,"");
					return;
				}
			}
			else
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Remote Access Disabled","Remote access is disabled for inventory: \"" @ %invB @ 
						"\"; this is not the source brick. Please enable remote access using IS_StoreItems before using other events on it.");
				else
					commandtoClient(%cl,'ISMsgBox',"Remote Access Disabled","error","Remote access is disabled for inventory: \"" @ %invB @ 
						"\"; this is not the source brick. Please enable remote access using IS_StoreItems before using other events on it.",0,"");
				return;
			}
		}
		else
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Save Not Found","Save not found for inventory: \"" @ %invB @ 
					"\". Please create this save using the IS_StoreItems event before using other events on it.");
			else
				commandtoClient(%cl,'ISMsgBox',"Save Not Found","error","Save not found for inventory: \"" @ %invB @ 
					"\". Please create this save using the IS_StoreItems event before using other events on it.",0,"");
			return;
		}
	}
	else
	{
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"Save Not Found",
				"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.");
		else
			commandtoClient(%cl,'ISMsgBox',"Save Not Found","error",
				"Save not found for this brick. Please create this save using the IS_StoreItems event before using other events on it.",0,"");
		return;
	}
}

///////////////////////////////////////////////////////
//CHECK IF ITEMS SWITCHED PERTRAIN TO SPECIFIC CRITERIA
///////////////////////////////////////////////////////
function fxDTSBrick::IS_ifTransferred(%brick,%action,%item,%anyItem,%relOutput,%cl)
{
	if(ISSpamCheckEvents(%cl,%brick))
		return;
	if(getWord($HstSetString,17) != 1 && getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////

	if(%action != 0)
	{
		if(%action != 1)
		{
			if(%action != 2)
			{
				//////////////////////////////////////////////////
				//If item == removed from brick inv
				if(%action == 3)
				{
					if(%anyItem)
					{
						%tempItem = getWord(%cl.ISitemInfo,15);
						if(%tempItem !$= "Nothing" && %tempItem !$= "")
							%check = 1;
					}
					else
					{
						if(strReplace(%item.uiName," ","") $= getWord(%cl.ISitemInfo,15))
							%check = 1;
					}
				}
			}
			
			//////////////////////////////////////////////////
			//If item == added to brick inv
			
			else
			{
				if(%anyItem)
				{
					%tempItem = getWord(%cl.ISitemInfo,10);
					if(%tempItem !$= "Nothing" && %tempItem !$= "")
						%check = 1;
				}
				else
				{
					if(strReplace(%item.uiName," ","") $= getWord(%cl.ISitemInfo,10))
						%check = 1;
				}
			}
		}
		
		//////////////////////////////////////////////////
		//If item == last selected
		
		else
		{
			if(%anyItem)
			{
				%tempItem = getWord(%cl.ISitemInfo,5);
				if(%tempItem !$= "Nothing" && %tempItem !$= "")
					%check = 1;
			}
			else
			{
				if(strReplace(%item.uiName," ","") $= getWord(%cl.ISitemInfo,5))
					%check = 1;
			}
		}
	}
	
	//////////////////////////////////////////////////
	//If item == first selected
	
	else
	{
		if(%anyItem)
		{
			%tempItem = getWord(%cl.ISitemInfo,0);
			if(%tempItem !$= "Nothing" && %tempItem !$= "")
				%check = 1;
		}
		else
		{
			if(strReplace(%item.uiName," ","") $= getWord(%cl.ISitemInfo,0))
				%check = 1;
		}
	}
	
	//////////////////////////////////////////////////
	
	//Return input event true or false
	if(%check == 1)
	{
		if(%relOutput !$= "")
			IS_RelOutputConditions(%cl,%brick,%relOutput,6);
		else
			fxDTSBrick::onISEventInput(%brick,%cl,6);
	}
	else
	{
		if(%relOutput !$= "")
			IS_RelOutputConditions(%cl,%brick,%relOutput,7);
		else
			fxDTSBrick::onISEventInput(%brick,%cl,7);
	}
}

/////////////////////////////////
//UNDO LAST GUI OR EVENT TRANSFER
/////////////////////////////////
function fxDTSBrick::IS_UndoTransfer(%brick,%cl)
{
	if(ISSpamCheckEvents(%cl,%brick))
		return;
	if(getWord($HstSetString,17) != 1 && getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if(getWord(%cl.ISclInfo,7) $= "" || getWord(%cl.ISclInfo,8) $= "" || getWord(%cl.ISclInfo,9) < 1)
	{
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"Error","Can't undo last action.");
		else
			commandtoClient(%cl,'ISMsgBox',"Error","error","Can't undo last action.",0,"");
		return;
	}
	if(getWord(%cl.ISclInfo,10))
		ServerCmdISRefresh(%cl,getWord(%cl.ISclInfo,7),getWord(%cl.ISclInfo,8),0,getWord(%cl.ISclInfo,9));
	else
		ServerCmdISRefresh(%cl,getWord(%cl.ISclInfo,8),getWord(%cl.ISclInfo,7),0,getWord(%cl.ISclInfo,9));
	
	//Prevent endless IS_UndoTransfer loop (i.e. event abuse)
	%cl.ISclInfo = setWord(%cl.ISclInfo,7,"");
	%cl.ISclInfo = setWord(%cl.ISclInfo,8,"");
	%cl.ISclInfo = setWord(%cl.ISclInfo,9,""); //?
	%cl.ISclInfo = setWord(%cl.ISclInfo,10,"");
}

///////////////////////////////////
//SET BRICK INV NAME (SUPPORTS VCE)
///////////////////////////////////
function fxDTSBrick::IS_VCESetBrName(%brick,%brName,%cl)
{
	if(ISSpamCheckEvents(%cl,%brick))
		return;
	if(getWord($HstSetString,17) != 1 && getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if($AddOn__Event_Variables != 1)
	{
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"VCE Disabled","VCE add-on must be enabled in order to use this event.");
		else
			commandtoClient(%cl,'ISMsgBox',"VCE Disabled","error","VCE add-on must be enabled in order to use this event.",0,"");
		return;
	}
	%brName = "_" @ getSubStr(strReplace(%brName," ","_"),0,30);
	%newBrName = filterVariableString(%brName,%brick,%cl,%cl.player,%vehicle);
	%brick.setName(%newBrName);
}

//////////////////////////////////////////////
//CHECK IF ITEM PRESENT IN SPECIFIED INV CELLS
//////////////////////////////////////////////
function fxDTSBrick::IS_ifItemInCells(%brick,%inv,%item,%specs,%relOutput,%cl) //option to check remote inv too?
{
	fxDTSBrick::IS_ifItemPresent(%brick,%inv,%item SPC %specs,0,%relOutput,%cl);
}
