//SERVER-SIDED

//////////////////////////////////////////////////
//CHECK IF CLIENT IS OVER QUOTA FOR STORAGE BRICKS
//////////////////////////////////////////////////
function ISQuotaCheck(%cl,%name,%brName)
{	
	%fileNames = "abcdefghijklmnopqrstuvwxyz";
	%file = new FileObject();
	for(%c = 0; %c < 26; %c++)
	{
		//check if save file is present
		%tempChar = getSubStr(%fileNames,%c,1);
		%fp = "Config/Server/ItemStorage/" @ %tempChar @ ".txt";
		if(isFile(%fp))
		{
			%file.openForRead(%fp);
			%fileLnAm = 0;
			while(!%file.isEOF())
			{
				%strLn = %file.readLine();

				//Check file quota
				if(%name $= %tempChar)
				{
					%fileLnAm++;
					if(%fileLnAm >= getWord($HstSetString,8))
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Over File Quota",
								" Server has reached the limit of \"" @ getWord($HstSetString,8) @ "\" for saves starting with the letter: \"" @ %tempChar @
								"\". Please choose another name for your storage brick; SAVE FAILED.");
						else
							commandtoClient(%cl,'ISMsgBox',"Over File Quota","denied",
								" Server has reached the limit of \"" @ getWord($HstSetString,8) @ "\" for saves starting with the letter: \"" @ %tempChar @
								"\". Please choose another name for your storage brick; SAVE FAILED.",0,"");
						return 1;
					}
				}
				
				//Check player quota
				if(getWord(%strLn,4) $= %cl.bl_id && getWord(%strLn,0) != 0)
				{
					%savesAm++;
					if(%savesAm >= getWord($HstSetString,7))
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Over Player Quota",
								" Only \"" @ getWord($HstSetString,7) @ "\" storage brick(s) are allowed per player; you have reached the limit." @
								" Try reusing old saves, or use your saves manager to remove other saves; SAVE FAILED.");
						else
							commandtoClient(%cl,'ISMsgBox',"Over Player Quota","denied",
								" Only \"" @ getWord($HstSetString,7) @ "\" storage brick(s) are allowed per player; you have reached the limit." @
								" Try reusing old saves, or use your saves manager to remove other saves; SAVE FAILED.",0,"");
						return 1;
					}
				}
			}
		}
	}
	%file.close();
	%file.delete();
	return 0;
}

//////////////////////////////////////
//CHECK IF STORAGE BRICK NAME IS VALID
//////////////////////////////////////
function ISNameValid(%cl,%brName)
{
	%wc = getWordCount(%brName);
	
	//If name is blank
	if(%wc == 0)
	{
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"Invalid Name","Please give the storage brick a valid name.");
		else
			commandToClient(%cl,'ISMsgBox',"Invalid Name","error","Please give the storage brick a valid name.",0,"");
		return 1;
	}
	
	//If name is more than one word
	else if(%wc > 1)
	{
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"Invalid Name","Please limit names for storage bricks to 1 word.");
		else
			commandToClient(%cl,'ISMsgBox',"Invalid Name","error","Please limit names for storage bricks to 1 word.",0,"");
		return 1;
	}
	
	//If name is greater than 30 characters
	if(strLen(%brName) > 30)
	{
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"Invalid Name","Please limit names for storage bricks to 30 characters.");
		else
			commandToClient(%cl,'ISMsgBox',"Invalid Name","error","Please limit names for storage bricks to 30 characters.",0,"");
		return 1;
	}
	
	//ISGETFILE also makes sure name starts with a letter
	return 0;
}

/////////////////////////////////////////////////////////////////////////
//CHECK TO MAKE SURE EVENT DATA LINES UP WITH SAVE DATA (IF SAVE PRESENT)
/////////////////////////////////////////////////////////////////////////
function ISErrorCheck(%cl,%storType,%access,%load,%brick,%srcBrick,%rmtAcc)
{
	%brick = strReplace(%brick.getPosition()," ","_");
	
	//////////////////////////////////////////////////
	//Storage type validation
	
	%SaveST = getWord(%load,0);
	if(%saveST != %storType)
	{
		if(%saveST != 4)
		{
			if(%saveST != 9)
			{
				if(%saveST != 16)
				{
					if(%saveST == 32)
						%temp = "X-Large";
				}
				else
					%temp = "Large";
			}
			else
				%temp = "Medium";
		}
		else
			%temp = "Small";
		
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"Error","Storage brick size in event menu doesn't match value in save." @
				" Please set the storage brick size in the event menu to: \"" @ %temp @ "\"");
		else
			commandToClient(%cl,'ISMsgBox',"Error","error","Storage brick size in event menu doesn't match value in save." @
				" Please set the storage brick size in the event menu to: \"" @ %temp @ "\"",0,"");
		return 1;
	}
	
	//////////////////////////////////////////////////
	//If remote access is enabled
	
	if(%rmtAcc == 0 && %brick !$= %srcBrick)
	{
		if(!%cl.islocalconnection() && %cl.bl_id != getNumKeyID() && %cl.bl_id != getWord(%cl.brInv,6)) //else //check 
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Remote Access Disabled",
					"Remote access is disabled for this inventory save; this brick is not the source brick.");
			else
				commandToClient(%cl,'ISMsgBox',"Remote Access Disabled","error",
					"Remote access is disabled for this inventory save; this brick is not the source brick.",0,"");
		}
		else
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Remote Access Disabled",
					"Remote access is disabled for this inventory save; this brick is not the source brick. " @
					"Set this new brick as the source brick so you can access the inventory? (Host/Owner-Only Privilege)");
			else
				commandtoClient(%cl,'ISMsgBox',"Remote Access Disabled","error",
					"Remote access is disabled for this inventory save; this brick is not the source brick. " @
					"Set this new brick as the source brick so you can access the inventory? (Host/Owner-Only Privilege)",1,%brick);
		}
		return 1;
	}
	
	//////////////////////////////////////////////////
	//Permissions check //necessary?
	
	%tempAccess = getWord(%cl.brInv,3);
	if(getWord(%load,0) != 0 && %access != %tempAccess) //use player var instead of %load?
	{
		if(%access != 0)
		{
			if(%access != 1)
			{
				if(%access != 2)
				{
					if(%access == 3)
						%temp = "SuperAdminOnly";
				}
				else
					%temp = "AdminOnly";
			}
			else
				%temp = "Public";
		}
		else
			%temp = "Private";	
			
		if(!%cl.islocalconnection() && %cl.bl_id != getNumKeyID() && %cl.bl_id != getWord(%brInv,6)) //else //check 
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Error",
					"Current access setting doesn't match value in save, which is set to \"" @ %temp @
					"\" (it might have been changed while you were viewing the storage brick's inventory).");
			else
				commandtoClient(%cl,'ISMsgBox',"Error","error",
					"Current access setting doesn't match value in save, which is set to \"" @ %temp @
					"\" (it might have been changed while you were viewing the storage brick's inventory).",0,"");
			return 1;
		}
	}
	else if(%access != 1) //Private, AdminOnly or SuperAdminOnly 
	{
		if(%access == 0 && %cl.bl_id != getWord(%load,4) && !%cl.islocalconnection() && %cl.bl_id != getNumKeyID())
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Access Denied","Storage brick access is set to Private;" @
					" you don't have permission to access it.");
			else
				commandtoClient(%cl,'ISMsgBox',"Access Denied","locked","Storage brick access is set to Private;" @
					" you don't have permission to access it.",0,"");
			return 1;
		}
		else if(%access == 2 && !%cl.isAdmin)
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Access Denied","Storage brick access is set to AdminOnly;" @
					" you don't have permission to access it.");
			else
				commandtoClient(%cl,'ISMsgBox',"Access Denied","locked","Storage brick access is set to AdminOnly;" @
					" you don't have permission to access it.",0,"");
			return 1;
		}
		else if(%access == 3 && !%cl.isSuperAdmin)
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Access Denied","Storage brick access is set to SuperAdminOnly;" @
					 " you don't have permission to access it.");
			else
				commandtoClient(%cl,'ISMsgBox',"Access Denied","locked","Storage brick access is set to SuperAdminOnly;" @
					 " you don't have permission to access it.",0,"");
			return 1;
		}
	}
	return 0;
}

/////////////////////////////////////////////////////////////////////////
//CHECK IF PLAYER IS SPAMMING SERVER CMDS; IF SO, TAKE ACTION SET BY HOST
/////////////////////////////////////////////////////////////////////////
function ISSpamCheck(%cl,%pass,%limitA,%limitB,%limitC)
{
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Initial spam check / warning
	
	if(getWord($HstSetString,11) != 1)
	{
		%ISaccessTmI = getWord(%cl.ISaccessTmI,%pass);
		%ISaccessTmF = getWord(%cl.ISaccessTmF,%pass);
		
		%ISaccessAm = getWord(%cl.ISaccessAm,%pass) + 1;
		%cl.ISaccessAm = setWord(%cl.ISaccessAm,%pass,%ISaccessAm);

		//Initial warning, before taking action
		if(((getSimTime() - %ISaccessTmF) < %limitA) || %ISaccessAm > %limitC) //ISaccessTm can eventually become too large of a value?
		{
			//Message setup cascade
			if(%pass != 0)
			{
				if(%pass != 1)
				{
					if(%pass != 2)
					{
						if(%pass != 3)
						{
							if(%pass != 4)
							{
								if(%pass != 5)
								{
									if(%pass != 6)
									{
										if(%pass != 7)
										{
											if(%pass != 8)
											{
												if(%pass != 9)
												{
													if(%pass == 10)
													{
														%MsgTxt = "Please wait at least half a second when using backpack server commands.";
														%MsgTxtB = "You have crossed the server's spam-redline for excessive execution of backpack server commands.";
														%MsgAll = "\c0" @ %cl.name SPC "(" @ %cl.bl_id @
															")\c6 is spamming the server through excessive execution of backpack server commands; action taken.";
													}
												}
												else
												{
													%MsgTxt = "Please wait at least 2 seconds when updating server settings.";
													%MsgTxtB = "You have crossed the server's spam-redline for excessive updating of server settings.";
													%MsgAll = "\c0" @ %cl.name SPC "(" @ %cl.bl_id @
														")\c6 is spamming the server through excessive updating of server settings; action taken.";
												}
											}
											else
											{
												%MsgTxt = "Please wait at least 2 seconds between resave attempts.";
												%MsgTxtB = "You have crossed the server's spam-redline for excessive resaving.";
												%MsgAll = "\c0" @ %cl.name SPC "(" @ %cl.bl_id @
													")\c6 is spamming the server through excessive resave attempts; action taken.";
											}
										}
										else
										{
											%MsgTxt = "Please wait at least 1 second between HasAddOn-Relay attemps.";
											%MsgTxtB = "You have crossed the server's spam-redline for excessive HasAddOn-Relay attempts.";
											%MsgAll = "\c0" @ %cl.name SPC "(" @ %cl.bl_id @
												")\c6 is spamming the server through excessive HasAddOn-Relay attempts; action taken.";
										}
									}
									else
									{
										%MsgTxt = "Please wait at least 1 second before updating inventory info.";
										%MsgTxtB = "You have crossed the server's spam-redline for excessive updating of inventory info.";
										%MsgAll = "\c0" @ %cl.name SPC "(" @ %cl.bl_id @
											")\c6 is spamming the server through excessive updates of inventory info; action taken.";
									}
								}
								else
								{
									%MsgTxt = "Please wait at least 2 seconds before requesting Saves Manager GUI.";
									%MsgTxtB = "You have crossed the server's spam-redline for excessive Saves Manager GUI requests.";
									%MsgAll = "\c0" @ %cl.name SPC "(" @ %cl.bl_id @
										")\c6 is spamming the server through excessive Saves Manager GUI requests; action taken.";
								}
							}
							else
							{
								%MsgTxt = "Please wait at least 2 seconds when requesting to delete saves from server.";
								%MsgTxtB = "You have crossed the server's spam-redline for excessive requests to delete saves.";
								%MsgAll = "\c0" @ %cl.name SPC "(" @ %cl.bl_id @
									")\c6 has crossed the server's spam-redline for excessive requests to delete saves; action taken.";
							}
						}
						else
						{
							%MsgTxt = "Please wait at least 2 seconds when requesting your saves from server.";
							%MsgTxtB = "You have crossed the server's spam-redline for excessive requests to list saves.";
							%MsgAll = "\c0" @ %cl.name SPC "(" @ %cl.bl_id @
								")\c6 has crossed the server's spam-redline for excessive requests to list saves; action taken.";
						}
					}
					else
					{
						%MsgTxt = "Please wait at least 2 seconds before reopening GUI.";
						%MsgTxtB = "You have crossed the server's spam-redline for excessive GUI access.";
						%MsgAll = "\c0" @ %cl.name SPC "(" @ %cl.bl_id @
							")\c6 has crossed the server's spam-redline for excessive GUI access; action taken.";
					}
				}
				else
				{
					%MsgTxt = "Please wait at least 2 seconds before reopening GUI.";
					%MsgTxtB = "You have crossed the server's spam-redline for excessive GUI access.";
					%MsgAll = "\c0" @ %cl.name SPC "(" @ %cl.bl_id @
						")\c6 has crossed the server's spam-redline for excessive GUI access; action taken.";
				}
			}
			else
			{
				if(%limitA == 33)
					%MsgTxt = "Please wait at least 33 milliseconds when editing the brick's inventory using IS_UndoTransfer " @
						"(it's recommended to use a delay between 33 - 250 milliseconds for the event).";
				else
					%MsgTxt = "Please wait at least half a second when editing the brick's inventory.";
				
				%MsgTxtB = "You have crossed the server's spam-redline for excessive GUI cell selection.";
				%MsgAll = "\c0" @ %cl.name SPC "(" @ %cl.bl_id @
					")\c6 has crossed the server's spam-redline for excessive GUI cell selection; action taken.";
			}
			
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Spam",%MsgTxt);
			else
				commandToClient(%cl,'ISMsgBox',"Spam","spam",%MsgTxt,0,"");
		}
		%cl.ISaccessTmF = setWord(%cl.ISaccessTmF,%pass,getSimTime());
		
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//Spam-redline check
		
		//If redline is crossed, take action against spammer
		if((%ISaccessTmF - %ISaccessTmI) <= %limitB)
		{
			if(%ISaccessAm > %limitC)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Spam",%MsgTxtB); //B?
				else
					commandtoClient(%cl,'ISMsgBox',"Spam","spam",%MsgTxtB);  //B?
				messageAll('',%MsgAll);
				
				//Check if host; if not, discipline
				if(!%cl.islocalconnection() && %cl.bl_id != getNumKeyID())
				{
					if(getWord($HstSetString,13) == 1)
						%cl.delete();
					else if(getWord($HstSetString,14) == 1)
						servercmdBan("", %cl, %cl.bl_id, getWord($HstSetString,15),"Auto-banned for spamming/abusing the Item Storage add-on.");
				}
				%cl.ISaccessAm = setWord(%cl.ISaccessAm,%pass,0);
				%cl.ISaccessTmI = setWord(%cl.ISaccessTmI,%pass,getSimTime());
				return 1;
			}
		}
		else
		{
			%cl.ISaccessAm = setWord(%cl.ISaccessAm,%pass,0);
			%cl.ISaccessTmI = setWord(%cl.ISaccessTmI,%pass,getSimTime());
		}
	}
	return 0;
}

////////////////////////////////////////////////////////////////////
//CHECK IF PLAYER IS SPAMMING EVENTS; IF SO, TAKE ACTION SET BY HOST
////////////////////////////////////////////////////////////////////
function ISSpamCheckEvents(%cl,%brick)
{
	if(getWord($HstSetString,9) == 1 || getWord($HstSetString,10) == 1)
	{
		%brick.ISaccessAmB = setWord(%brick.ISaccessAmB,0,%brick.ISaccessAmB++);
		if((getSimTime() - %brick.ISaccessTmB) < 20000)
		{
			//Primary redline
			if(getWord(%brick.ISaccessAmB,1) != 1)
			{
				if(getWord(%brick.ISaccessAmB,0) > 25)
				{
					if(getWord($HstSetString,10) == 1)
						%brick.ISaccessAmB = setWord(%brick.ISaccessAmB,1,1);
						
					if(getWord($HstSetString,9) == 1)
					{
						SimObject::cancelEvents(%brick);
						messageAll('',"\c6Event spam disabled on brick: \c0" @ %brick @ "\c6 (brick ownerID: \c0" @ %brick.client.bl_id @
							"\c6) Event executed by: \c0" @ %cl.bl_id);
					}
					%brick.ISaccessAmB = setWord(%brick.ISaccessAmB,0,0);
					return 1;
				}
			}
			
			//Secondary redline
			else
			{
				if(getWord(%brick.ISaccessAmB,0) > 5 && getWord($HstSetString,10) == 1)
				{
					%brick.clearEvents();
					messageAll('',"\c6Event spam disabled on brick: \c0" @ %brick @ "\c6 (brick ownerID: \c0" @ %brick.client.bl_id @
						"\c6) Event executed by: \c0" @ %cl.bl_id @ " (SECOND OFFENSE; BRICK EVENTS CLEARED)");
						
					%brick.ISaccessAmB = "0 0";
					return 1;
				}
			}
		}
		else
		{
			%brick.ISaccessAmB = "0 0";
			%brick.ISaccessTmB = getSimTime();
		}
	}
	return 0;
}
