//CLIENT-SIDED

/////////
//KEYBIND
/////////
if(!$ISKBindMain)
{
	//Saves Manager
	$remapDivision[$remapCount] = "Item Storage";
	$remapName[$remapCount] = "Toggle Saves Manager GUI";
	$remapCmd[$remapCount] = "Toggle_ISSavesGUI";
	$remapCount++;
	
	//Backpack
	$remapName[$remapCount] = "Toggle Backpack GUI";
	$remapCmd[$remapCount] = "Toggle_ISBackpackGUI";
	$remapCount++;
	$ISKBindMain=1;
}

///////////////////////////////////
//SAVES MANAGER GUI TOGGLE BEHAVIOR
///////////////////////////////////
function Toggle_ISSavesGUI(%toggle)
{
	if(%toggle)
	{
		if(isObject(ISSavesGUI_Client) && ISSavesGUI_Client.isAwake())
			canvas.popDialog(ISSavesGUI_Client);
		else if(isObject(ISSavesGUI_Host) && ISSavesGUI_Host.isAwake())
			canvas.popDialog(ISSavesGUI_Host);
		else
		{
			if(ItemStorWndw.host $= "")
				commandtoServer('ISPushSavesGUI'); //only needs to be sent once to check if client is host
			else if(ItemStorWndw.host == 1)
				canvas.pushDialog(ISSavesGUI_Host);
			else
				canvas.pushDialog(ISSavesGUI_Client);
		}
	}
}

//////////////////////////////
//BACKPACK GUI TOGGLE BEHAVIOR
//////////////////////////////
function Toggle_ISBackpackGUI(%toggle)
{
	if(%toggle == 1) //if toggling backpack GUI
	{
		if(ISBackpackGUI.isAwake())
		{
			commandtoserver('ISDelVars',1);
			canvas.popDialog(ISBackpackGUI);
		}
		else
			commandToServer('ISPopulateBkPkGUI',0);
	}
	else if(%toggle == 2) //if only opening backpack GUI wndw
		commandToServer('ISPopulateBkPkGUI',1);
	else if(%toggle == 3) //if closing backpack GUI
	{
		if(ISMainGUI.isAwake() && ItemStorWndwC.isAwake())
			ISMainGUI.remove(ItemStorWndwC);
		else if(ISBackPackGUI.isAwake())
			canvas.popDialog(ISBackpackGUI);
	}
	else if(%toggle == 4 && ISMainGUI.isAwake()) //if opening GUI relative to if main GUI is open
		commandToServer('ISPopulateBkPkGUI',1);
	else if(%toggle == 5) //close all inventory GUIs
	{
		if(ISBackPackGUI.isAwake())
			canvas.popDialog(ISBackPackGUI);
		if(ISMainGUI.isAwake())
			canvas.popDialog(ISMainGUI);
		if(ISTransAmGUI.isAwake())
			canvas.popDialog(ISTransAmGUI);
	}
}

////////////////////////
//MAIN GUI CELL BEHAVIOR
////////////////////////
function ItemStorage_Select(%currCell,%setAm)
{
	%prevCell = ItemStorWndw.prevCell;
	
	//If cell is primary selection 
	if(%prevCell $= "")
	{
		if(%currCell.storedItem == 0) //if first cell doesn't have an item, ignore
			return;
		else if(%currCell.storedItem > 0) //if != 0 //if first cell selected only and has an item, highlight item
		{
			%currCell.mColor = setWord(%currCell.mColor,3,"63");
			ItemStorWndw.prevCell = %currCell;
			ItemStorWndw.prevTime = getSimTime();
			
			%r = strReplace(%currCell,"Stor","Stck").getValue();
			ItemStorWndw.temp = setWord(ItemStorWndw.temp,0,getWord(%r,1));
			ItemStorWndw.temp = setWord(ItemStorWndw.temp,1,getWord(%r,3));
			
			if(getWord(ItemStorWndw.temp,2) == 1)
			{
				%cellN = getSubStr(%currCell,0,2);
				%cell = getSubStr(%currCell,6,2);
				
				%t = %cellN @ "Stor" @ %cell;
				%w = %cellN @ "Stck" @ %cell;
				%x = %cellN @ "StckBG" @ %cell;
				%itemWght = %currCell.storedWeight;

				%len = strLen(%itemWght SPC getWord(ItemStorWndw.temp,4));
				if(%len < 8)
					%w.setText("<just:right><font:Impact:18><color:ffffff> " @ %itemWght @ " <color:999999> " @ getWord(ItemStorWndw.temp,4));
				else
					%w.setText("<just:right><font:Impact:17><color:ffffff> " @ %itemWght @ " <color:999999> " @ getWord(ItemStorWndw.temp,4));
				%x.extent = 60 SPC 14;
				%x.position = 0 SPC 46;
			}
			return;
		}
	}
	
	 //If cell is secondary selection
	if(%prevCell !$= "")
	{
		if(%prevCell $= %currCell)
		{
			//if same cell is selected, and player rapidly double-clicked item, stack all items into one cell
			if((getSimTime() - ItemStorWndw.prevTime) <= 250 && getSubStr(%currCell,0,2) !$= "pl")
			{
				ItemStorWndw.prevTime = "";
				
				%r = ItemStorWndw.temp;
				if(getWord(%r,0) <= getWord(%r,1))
					CommandToServer('ISRefresh',%currCell,%prevCell,1,-2);
				else
				{
					ItemStorWndw.prevCell = "";
					ItemStorWndw.prevTime = "";
					%currCell.mColor = setWord(%currCell.mColor,3,"255");
					return;
				}
			}
			
			//if same cell is selected, and player didn't rapidly double-click, ignore
			else
			{
				%currCell.mColor = setWord(%currCell.mColor,3,"255");
				ItemStorWndw.prevCell = "";
				ItemStorWndw.prevTime = "";
				
				if(getWord(ItemStorWndw.temp,2) == 1)
				{
					%cellN = getSubStr(%currCell,0,2);
					%cell = getSubStr(%currCell,6,2);
					%w = %cellN @ "Stck" @ %cell;
					%x = %cellN @ "StckBG" @ %cell;
					
					if(%cellN !$= "pl")
					{
						%w.setText("<just:right><font:Impact:18><color:ffffff> " @ getWord(ItemStorWndw.temp,0) @ " <color:999999> " @ getWord(ItemStorWndw.temp,1));
						%len = strLen(getWord(ItemStorWndw.temp,0) SPC getWord(ItemStorWndw.temp,1));
						%len = (%len * 8) - 4; //8=char size; 4=two spaces between amount and weight symbol
					}
					else
					{
						%w.setText("<just:right><font:Impact:18><color:ffffff>1");
						%len = 8;
					}
					%x.extent = %len SPC 14;
					%x.position = (60 - %len) SPC 46;
				}
				return;
			}
		}
		
		//If manually setting amount to remove from stack
		else if(%setAm == 1)
		{
			ItemStorWndw.prevTime = "";
			
			if(getSubStr(%prevCell,0,2) !$= "Pl" && getSubStr(%currCell,0,2) !$= "Pl")
			{
				%r = getWord(ItemStorWndw.temp,0);
				
				if(%currCell.storedItem > 0)
				{
					%s = getWord(strReplace(%currCell,"Stor","Stck").getValue(),1);
					%sB = getWord(strReplace(%currCell,"Stor","Stck").getValue(),3);
					%ssB = %sB-%s;
					if(%ssB < %r) //snap transfer limit to max that can be sent to other stack, if over
						%r = %ssB;
				}
				
				if(%r > 1 && (%currCell.storedItem == 0 || (%currCell.storedItem == %prevCell.storedItem && ((%s+1) < %sB)))) //or keep to %s
				{
					ISTAmTxt.setValue("");
					ISTransAmWndw.currCell = %currCell;
					
					ISTAmSldr.setValue("");
					ISTAmSldr.range = "0.000000" SPC %r @ ".000000";
					ISTAmSldr.ticks = %r - 1;
					
					canvas.pushDialog(ISTransAmGUI);
				}
				else
					CommandToServer('ISRefresh',%currCell,%prevCell,1,1);
			}
			else
				CommandToServer('ISRefresh',%currCell,%prevCell,1,1);
		}
		
		//If moving entire stack of items
		else if(getSubStr(%prevCell,0,2) !$= "Pl" && getSubStr(%currCell,0,2) !$= "Pl")
			CommandToServer('ISRefresh',%currCell,%prevCell,1,-1); //switch items server-sided (for security and encase of errors)
		else
			CommandToServer('ISRefresh',%currCell,%prevCell,1,1);
	}
}

////////////////////////////////////////////////////////////
//APPLY STACK OR WEIGHT VALUE TO ALL VALUES IN ITEMS MANAGER
////////////////////////////////////////////////////////////
function ISItemGUIApplyAll(%stackAm,%WghtAm)
{
	for(%c=0; %c<(ISItemsSwList.getCount()-1); %c++)
	{
		%s = "Stack" @ %c;
		%w = "Weight" @ %c;
		
		if(%stackAm > 0)
			%s.setValue(%stackAm);
		if(%WghtAm > 0)
			%w.setValue(%WghtAm);
	}
}

//////////////////////////////////
//SETUP ROW DATA FOR ITEMS MANAGER
//////////////////////////////////
function ISAddGUIItem(%item,%pos,%stack,%weight,%bgCol,%count) //move to another file? 
{
	//Determine if item icon present and valid
	if(%item.iconName $= "" || !isFile(%item.iconName))
	{
		%sf = strReplace(%item.shapeFile,"_","/");
		%sf = strReplace(%item.shapeFile,"/"," ");
		%sf = getWord(%sf,2);
		%icon = "add-ons/print_letters_default/prints/" @ getSubStr(%sf,0,1) @ ".png";

		if(!isFile(%icon))
			%icon = "add-ons/print_letters_default/prints/-qmark.png";
	}
	else
		%icon = %item.IconName;
		
	//Swatch BG Color
	if(%bgCol == 1)
		%color = "170 170 170 255";
	else
		%color = "200 200 200 255";
	
	//Preview-Icon ColorShift Color
	if(%item.doColorShift == 1)
	{
		%csc = %item.colorShiftColor;
		%csColor = mFloatLength((getWord(%csc,0) * 255),0)
				SPC mFloatLength((getWord(%csc,1) * 255),0)
				SPC mFloatLength((getWord(%csc,2) * 255),0)
				SPC mFloatLength((getWord(%csc,3) * 255),0);
	}
	else
		%csColor = "255 255 255 255";
	
	//////////////////////////////////////////////////
	//Item Data for New Row
	
	ISItemsSwList.add(new GuiSwatchCtrl(%item) {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 " @ %pos;
		extent = "306 38";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		color = %color;

		new GuiBitmapCtrl() {
		   profile = "GuiDefaultProfile";
		   horizSizing = "right";
		   vertSizing = "bottom";
		   position = "3 3";
		   extent = "32 32";
		   minExtent = "8 2";
		   enabled = "1";
		   visible = "1";
		   clipToParent = "1";
		   bitmap = %icon;
		   wrap = "0";
		   lockAspectRatio = "0";
		   alignLeft = "0";
		   alignTop = "0";
		   overflowImage = "0";
		   keepCached = "0";
		   mColor = %csColor;
		   mMultiply = "0";
		};
		new GuiMLTextCtrl() {
		   profile = "GuiMLTextProfile";
		   horizSizing = "left";
		   vertSizing = "bottom";
		   position = "37 9";
		   extent = "168 20";
		   minExtent = "8 2";
		   enabled = "1";
		   visible = "1";
		   clipToParent = "1";
		   lineSpacing = "2";
		   allowColorChars = "0";
		   maxChars = "37";
		   text = "<font:Impact:20>" @ %item.uiName;
		   maxBitmapHeight = "-1";
		   selectable = "1";
		   autoResize = "1";
		};
		new GuiTextEditCtrl("Stack" @ %count) {
		   profile = "GuiTextEditProfile";
		   horizSizing = "right";
		   vertSizing = "bottom";
		   position = "245 10";
		   extent = "23 18";
		   minExtent = "8 2";
		   enabled = "1";
		   visible = "1";
		   clipToParent = "1";
		   text = %stack;
		   command = "Stack" @ %count @ ".setValue(mAbs(mFloatLength(Stack" @ %count @ ".getValue(),0)));";
		   maxLength = "3";
		   historySize = "0";
		   password = "0";
		   tabComplete = "0";
		   sinkAllKeyEvents = "0";
		};
		new GuiTextEditCtrl("Weight" @ %count) {
		   profile = "GuiTextEditProfile";
		   horizSizing = "right";
		   vertSizing = "bottom";
		   position = "269 10";
		   extent = "35 18";
		   minExtent = "8 2";
		   enabled = "1";
		   visible = "1";
		   clipToParent = "1";
		   text = %weight;
		   command = "Weight" @ %count @ ".setValue(mAbs(mFloatLength(Weight" @ %count @ ".getValue(),0)));";
		   maxLength = "5";
		   historySize = "0";
		   password = "0";
		   tabComplete = "0";
		   sinkAllKeyEvents = "0";
		};
	});
}

//////////////////////////////////////////////////////////////////
//LOAD PREVIOUS ITEM SETTINGS AND ENABLED ITEMS INTO ITEMS MANAGER
//////////////////////////////////////////////////////////////////
function ISLoadItemSettings(%local) //executed by server (made to support multiple calls)
{
	%fp = "Config/Client/ItemStorageCl.txt"; 
	%file = new FileObject();
	if(!isFile(%fp)) 
	{
		%file.openForWrite(%fp);
		%file.writeLine(">>List of item buy, sell and stack values (used for output events, VCE vars and GUIs)"); //?
	}
	
	%pos = 38;
	%bgCol = 1;
	%count = 0;
	ISItemsSwList.deleteAll(); //clear list (if items already present)
	
	//////////////////////////////////////////////////
	
	ISItemsSwList.add(new GuiSwatchCtrl() {
	   profile = "GuiDefaultProfile";
	   horizSizing = "right";
	   vertSizing = "bottom";
	   position = "0 0";
	   extent = "306 38";
	   minExtent = "8 2";
	   enabled = "1";
	   visible = "1";
	   clipToParent = "1";
	   color = "33 33 33 255";

	   new GuiBitmapButtonCtrl() {
		  profile = "BlockButtonProfile";
		  horizSizing = "right";
		  vertSizing = "bottom";
		  position = "3 7";
		  extent = "96 24";
		  minExtent = "8 2";
		  enabled = "1";
		  visible = "1";
		  clipToParent = "1";
		  command = "ISItemGUIApplyAll(ISStackSetAll.getValue(),ISWeightSetAll.getValue());";
		  text = "APPLY TO ALL";
		  groupNum = "-1";
		  buttonType = "PushButton";
		  bitmap = "base/client/ui/button1";
		  lockAspectRatio = "0";
		  alignLeft = "0";
		  alignTop = "0";
		  overflowImage = "0";
		  mKeepCached = "0";
		  mColor = "255 255 255 255";
			 wrap = "0";
	   };
	   new GuiTextEditCtrl(ISStackSetAll) {
		  profile = "GuiTextEditProfile";
		  horizSizing = "right";
		  vertSizing = "bottom";
		  position = "245 10";
		  extent = "23 18";
		  minExtent = "8 2";
		  enabled = "1";
		  visible = "1";
		  clipToParent = "1";
		  command = "ISStackSetAll.setValue(mAbs(mFloatLength(ISStackSetAll.getValue(),0)));";
		  maxLength = "3";
		  historySize = "0";
		  password = "0";
		  tabComplete = "0";
		  sinkAllKeyEvents = "0";
	   };
	   new GuiTextEditCtrl(ISWeightSetAll) {
		  profile = "GuiTextEditProfile";
		  horizSizing = "right";
		  vertSizing = "bottom";
		  position = "269 10";
		  extent = "35 18";
		  minExtent = "8 2";
		  enabled = "1";
		  visible = "1";
		  clipToParent = "1";
		  command = "ISWeightSetAll.setValue(mAbs(mFloatLength(ISWeightSetAll.getValue(),0)));";
		  maxLength = "5";
		  historySize = "0";
		  password = "0";
		  tabComplete = "0";
		  sinkAllKeyEvents = "0";
	   };
	});

	//////////////////////////////////////////////////
	
	if(%local)
		%group = DataBlockGroup;
	else
		%group = ServerConnection;
	for(%c=0; %c<%group.getCount(); %c++)
	{
		%item = %group.getObject(%c); //adapts client-sided for dedicated servers
		if(%item.getClassName() $= "ItemData" && %item.uiName !$= "")
		{
			%check = 0;
			%itemUIN = strReplace(%item.uiName," ","_");
			
			%file.openForRead(%fp);
			while(!%file.isEOF() && %check != 1)
			{
				%strLn = %file.readLine();

				if(getWord(%strLn,0) $= %itemUIN)
				{
					%stack = getWord(%strLn,1);
					if(%stack $= "")
						%stack = 16;
						
					%weight = getWord(%strLn,2);
					if(%weight $= "")
						%weight = 10;
						
					%check = 1;
				}
			}
			if(%check != 1)
			{
				%stack = 16;
				%weight = 10;
			}
			
			ISAddGUIItem(%item,%pos,%stack,%weight,%bgCol,%count);
			%pos += 38;
			if(%bgCol == 1)
				%bgCol = 0;
			else
				%bgCol = 1;
				
			%count++;
		}
		%file.close();
	}
	ISItemsSwList.extent = getWord(ISItemsSwList.extent,0) SPC (38*ISItemsSwList.getCount()); //adjust scroll window size
	%file.delete();
}

/////////////////////////////////////
//LOAD PREVIOUS GUI SETTINGS INTO GUI
/////////////////////////////////////
function ISLoadGUISettings()
{
	%file = new FileObject();
	%fp = "Config/Client/ItemStorageCl.txt";
	if(!isFile(%fp))
	{
		%file.openForWrite(%fp);
		%file.writeLine(">>Client-sided GUI and Item settings");
	}
	%file.openForRead(%fp);
	%file.readLine();
	%str = %file.readLine();
	
	%n = "  abcdefghijklmnopqr";
	%strTemp = "0 1 1 1 0 0 0 25 250 1 1 0 0 1 0 60 0 0 500 3"; //saved?/version, manual, GUI settings
	for(%c=2; %c<20; %c++) //get version?
	{
		%m = "ISHst" @ getSubStr(%n,%c,1);
		%w = getWord(%str,%c);
		%x = getWord(%strTemp,%c);
		
		if(%c < 19)
		{
			if(%w !$= "" && getWord(%str,0) == 4)
				%m.setValue(%w);
			else
				%m.setValue(%x);
		}
		else
		{
			if(%w !$= "" && getWord(%str,0) == 4)
				%m.setSelected(%w);
			else
				%m.setSelected(%x);
		}
	}
	%file.close();
	%file.delete();
}

////////////////////////////////////////////////////
//SAVE ITEM SETTINGS TO FILE AND SEND DATA TO SERVER
////////////////////////////////////////////////////
function ISSaveItemSettings()
{
	%fp = "Config/Client/ItemStorageCl.txt";
	%fpB = "Config/Client/ItemStorageCl-Backup.txt";
	%file = new FileObject();
	if(!isFile(%fp)) //?
	{
		%file.openForWrite(%fp);
		%file.writeLine(">>Client-sided GUI and Item settings"); //?
	}
	%file.openForRead(%fp);
	
	//Setup client array of item setting saves to manipulate
	%lineCount = 0;
	while(!%file.isEOF())
	{
		%load = %file.readLine();
		%strLn[%lineCount] = %load; //
		%lineCount++;
	}
	%lineCount -= 2;
	
	//////////////////////////////////////////////////
	
	%itemString = "";
	%pass = 0;
	%objCount = ISItemsSwList.getCount();
	
	for(%c = 1; %c < %objCount; %c++)
	{
		%itemID = ISItemsSwList.getObject(%c).getName(); //get swatch name, which is set to item id
		%w = "Stack" @ %c-1;
		%s = "Weight" @ %c-1;
		%itemWeight = %w.getValue();
		%itemStack = %s.getValue();
			
		if(strLen(%itemString SPC %itemID SPC %itemWeight SPC %itemStack) < 255)
		{
			if(%c < %objCount)
			{
				%itemString = %itemString SPC %itemID SPC %itemWeight SPC %itemStack;
				
				%itemUIN = strReplace(%itemID.uiName," ","_"); //save uiName for clients (server uses actual item name, since clients can't access it)
				%check = 0;
				for(%d = 0; %d < %lineCount; %d++)
				{
					if(getWord(%strLn[%d],0) $= %itemUIN)
					{
						%strLn[%d] = %itemUIN SPC %itemWeight SPC %itemStack;
						%check = 1;
					}
				}
				if(%check != 1)
				{
					%lineAppCount++;
					%strLn[%lineCount+%lineAppCount] = %itemUIN SPC %itemWeight SPC %itemStack;
				}
				
				if(%c >= (%objCount-1))
				{
					%itemString = %itemString SPC %itemID SPC %itemWeight SPC %itemStack; //?
					commandToServer('ISItmSetArr',getSubStr(%itemString,1,strLen(%itemString)),%pass);
				}
			}
			else
			{
				%itemString = %itemString SPC %itemID SPC %itemWeight SPC %itemStack; //?
				commandToServer('ISItmSetArr',getSubStr(%itemString,1,strLen(%itemString)),%pass);
			}
		}
		else
		{
			commandToServer('ISItmSetArr',getSubStr(%itemString,1,strLen(%itemString)),%pass);
			
			%pass = 1;
			%itemString = " " @ %itemID SPC %itemWeight SPC %itemStack;
			
			%itemUIN = strReplace(%itemID.uiName," ","_"); //save uiName for clients (server uses actual item name, since clients can't access it)
			%check = 0;
			for(%d = 0; %d < %lineCount; %d++)
			{
				if(getWord(%strLn[%d],0) $= %itemUIN)
				{
					%strLn[%d] = %itemUIN SPC %itemWeight SPC %itemStack;
					%check = 1;
				}
			}
			if(%check != 1)
			{
				%lineAppCount++;
				%strLn[%lineCount+%lineAppCount] = %itemUIN SPC %itemWeight SPC %itemStack;
			}
		}
	}
	
	//////////////////////////////////////////////////
	//Save changes to client file if not initial load by server; notify host
	
	%file.openForWrite(%fp);
	for(%e = 0; %e < (%lineCount+%lineAppCount); %e++)
		%file.writeLine(%strLn[%e]);
	%file.close();
	
	if(ISHstO.getValue())
	{
		%file.openForWrite(%fpB);
		for(%e = 0; %e < (%lineCount+%lineAppCount); %e++)
			%file.writeLine(%strLn[%e]);
		%file.close();
	}
	%file.delete();
	
	ClientCmdISMsgBox("Changes Saved","approved","Changes have been saved/applied successfully!",0,"");
}

///////////////////////////////////////////////////
//SAVE GUI SETTINGS TO FILE AND SEND DATA TO SERVER
///////////////////////////////////////////////////
function ISSaveGUISettings()
{
	//check if save file outdated before saving
	
	//Grag GUI settings; store in string
	%str = "4 0"; //saved/version, ISShowManual.getValue();-unused
	%n = "abcdefghijklmnopqr";
	for(%c=0; %c<17; %c++)
	{
		%m = "ISHst" @ getSubStr(%n,%c,1);
		%str = %str SPC %m.getValue();
	}
	%str = %str SPC ISHstR.getSelected();

	//Initialize
	%file = new FileObject();
	%fp = "Config/Client/ItemStorageCl.txt";
	%fpB = "Config/Client/ItemStorageCl-Backup.txt";
	if(!isFile(%fp))
	{
		%file.openForWrite(%fp);
		%file.writeLine(">>Client-sided GUI and Item settings");
	}
	%file.openForRead(%fp);
	
	//Store array
	%count = 0;
	while(!%file.isEOF())
	{
		%strLn[%count] = %file.readLine();
		%count++;
	}

	//Write array to file
	%file.openForWrite(%fp); //check if file exists first?
	%strLn[0] = ">>Client-sided GUI and Item settings";
	%strLn[1] = %str;
	for(%c=0; %c<%count; %c++)
		%file.writeLine(%strLn[%c]);
	%file.close();
	
	if(ISHstO.getValue())
	{
		%file.openForWrite(%fpB);
		for(%c=0; %c<%count; %c++)
			%file.writeLine(%strLn[%c]);
		%file.close();
	}
	%file.delete();

	commandToServer('ISServSetString',%str);
	ClientCmdISMsgBox("Changes Saved","approved","Changes have been saved/applied successfully!",0,"");
}

///////////////////////////////////
//CONVERT OLD SAVES TO WORK WITH V4
///////////////////////////////////
function ISConvertSaves() //Only meant to update saves from v3 to v4
{
	%fileNames = "abcdefghijklmnopqrstuvwxyz";
	%file = new FileObject();

	for(%c = 0; %c < 26; %c++)
	{
		%tempChar = getSubStr(%fileNames,%c,1);
		%fp = "Config/Server/ItemStorage/" @ %tempChar @ ".txt";
		
		%lineCount = 0;
		if(isFile(%fp))
		{
			%checkB = 1;
			%file.openForRead(%fp);
			while(!%file.isEOF())
			{
				%strLn = %file.readLine();
				%storType = getWord(%strLn,0);
				%newLn = "";
				
				if(getWord(%strLn,0) > 0 && getWordCount(%strLn) == (9+%storType))
				{
					%check = 1;
					for(%d=0; %d<%storType && %d<32; %d++)
					{
						%itemN = getWord(%strLn,9+%d);
						if(%itemN !$= "0" && %itemN !$= "" && %itemN !$= " ")
							%newLn = %newLn SPC %itemN SPC 1;
						else
							%newLn = %newLn SPC 0 SPC 0;
					}
					%lineArr[%lineCount] = getWords(%strLn,0,8) @ %newLn; //0-8?
				}
				else
					%lineArr[%lineCount] = %strLn;
				%lineCount++;
			}
			%file.openForWrite(%fp); //check if file exists first?
			for(%e=0; %e<%lineCount; %e++)
				%file.writeLine(%lineArr[%e]);
		}
	}
	deleteVariables("%lineArr*");

	//////////////////////////////////////////////////
	
	%fp = "Config/Server/ItemStorage/BackPacks.txt";
		
	%lineCount = 0;
	if(isFile(%fp))
	{
		%checkB = 1;
		%file.openForRead(%fp);
		while(!%file.isEOF())
		{
			%strLn = %file.readLine();
			%newLn = "";
			
			if(getWord(%strLn,0) > 0 && getWordCount(%strLn) == 17)
			{
				%check = 1;
				for(%c=0; %c<15; %c++)
				{
					%itemN = getWord(%strLn,2+%c);
					if(%itemN !$= "0" && %itemN !$= "" && %itemN !$= " ")
						%newLn = %newLn SPC %itemN SPC 1;
					else
						%newLn = %newLn SPC 0 SPC 0;
				}
				%lineArr[%lineCount] = getWords(%strLn,0,1) @ %newLn;
			}
			else
				%lineArr[%lineCount] = %strLn;
			%lineCount++;
		}
		%file.openForWrite(%fp); //check if file exists first?
		for(%d=0; %d<%lineCount; %d++)
			%file.writeLine(%lineArr[%d]);
	}
	
	//////////////////////////////////////////////////
	
	%file.close();
	%file.delete();

	if(%check == 1)
		ClientCmdISMsgBox("Conversion Complete","approved","All brick and backpack saves have been updated successfully, and will now work with version 4.",0,"");
	else if(%checkB == 1)
		ClientCmdISMsgBox("Error","error","Brick and backpack saves are already compatible with version 4.",0,"");
	else
		ClientCmdISMsgBox("Error","error","No save files found.",0,"");
}
