//SERVER-SIDED

////////////////////////////////////
//LOAD ITEMS FROM SERVER'S SAVE FILE
////////////////////////////////////
function ISLoadItems(%cl,%brName,%name)
{
	%fp = "Config/Server/ItemStorage/" @ %name @ ".txt";
	%file = new FileObject();
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Backpack saves
	
	if(%name !$= "BackPacks")
	{
		if(!isFile(%fp))
			return;
		%file.openForRead(%fp);
		
		//Search for storage brick name in save file; return loaded info if found
		while(!%file.isEOF())
		{
			%strLn = %file.readLine();
			if(getWord(%strLn,6) $= %brName && getWord(%strLn,0) != 0)
			{
				%file.close();
				%file.delete();
				
				//convert item names to IDs for gameconnected clients and add stack limits
				for(%c = 0; %c < getWord(%strLn,0) && %c < 32; %c++)
				{
					%item = getWord(%strLn,9+(%c*2));
					%stackNum = mFloatLength(getWord(%strLn,9+(%c*2)+1),0);
					
					if(%item !$= 0 && isObject(%item) && %item.getClassName() $= "ItemData" && %item.getName() !$= "" && %stackNum > 0) //isObject(%item)) //make sure item exists, otherwise skip
					{
						%itemID = %item.getID();
						%stackLimit = getWord($ItemSetArray[%itemID],0);
						if(%stackNum > %stackLimit)
							%stackNum = %stackLimit;
						%weight = getWord($ItemSetArray[%itemID],1);
						
						%strLnB = setWord(%strLnB,(%c*4),%itemID);
						%strLnB = setWord(%strLnB,(%c*4)+1,%stackNum);
						%strLnB = setWord(%strLnB,(%c*4)+2,%stackLimit);
						%strLnB = setWord(%strLnB,(%c*4)+3,%weight);
					}
					else
					{
						%strLnB = setWord(%strLnB,(%c*4),0);
						%strLnB = setWord(%strLnB,(%c*4)+1,0);
						%strLnB = setWord(%strLnB,(%c*4)+2,0);
						%strLnB = setWord(%strLnB,(%c*4)+3,0);
					}
				}
				return getWords(%strLn,0,8) SPC %strLnB;
			}
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Other saves
	
	else
	{
		if(!isFile(%fp)) 
		{
			%file.openForWrite(%fp);
			%file.writeLine(">>List of all item storage saves for player backpacks");
			%file.writeLine(">>OwnerID/Name, Items");
		}
		%file.openForRead(%fp);
		
		//Search for client's bl_id in BackPack save file; return items string if found
		while(!%file.isEOF())
		{
			%strLn = %file.readLine();
			if(getWord(%strLn,0) == %brName && getWord(%strLn,0) !$= "")
			{
				%file.close();
				%file.delete();
				
				for(%c = 0; %c < 15; %c++) 
				{
					%item = getWord(%strLn,2+(%c*2));
					%stackNum = mFloatLength(getWord(%strLn,2+(%c*2)+1),0); //checks if positive and > 0 below
					
					if(%item !$= 0 && isObject(%item) && %item.getName() !$= "ISBackPackItem"  && %item.getClassName() $= "ItemData" && %item.getName() !$= ""  && %stackNum > 0) //isObject(%item) && 
					{
						%itemID = %item.getID();
						%stackLimit = getWord($ItemSetArray[%itemID],0);
						
						if(%stackNum > %stackLimit)
							%stackNum = %stackLimit;
							
						%weight = getWord($ItemSetArray[%itemID],1);
						
						%strLnB = setWord(%strLnB,(%c*4),%itemID); //convert item names to IDs for clients
						%strLnB = setWord(%strLnB,(%c*4)+1,%stackNum);
						%strLnB = setWord(%strLnB,(%c*4)+2,%stackLimit);
						%strLnB = setWord(%strLnB,(%c*4)+3,%weight);
					}
					else
					{
						%strLnB = setWord(%strLnB,(%c*4),0); //convert item names to IDs for clients
						%strLnB = setWord(%strLnB,(%c*4)+1,0);
						%strLnB = setWord(%strLnB,(%c*4)+2,0);
						%strLnB = setWord(%strLnB,(%c*4)+3,0);
					}
					%currWght += (%weight * %stackNum);
				}
				%cl.ISclInfo = setWord(%cl.ISclInfo,3,%currWght);
				return getWords(%strLn,0,1) SPC %strLnB;
			}
		}
	}
	%file.close();
	%file.delete();
	return 0;
}

////////////////////////
//LOAD INFO FROM SAVE(S)
////////////////////////
function ISLoadInfo(%slctn,%slctnData,%fldr,%num)
{
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Search all files
	
	if(%fldr $= "AllFiles")
	{
		%Fchar = "abcdefghijklmnopqrstuvwxyz";
		%file = new FileObject();
		%lineCount = 0;
		
		for(%c=0; %c<26 && %lineCount<50; %c++)
		{
			//Check if save files exist
			%name = getSubStr(%Fchar,%c,1);
			%fp = "Config/Server/ItemStorage/" @ %name @ ".txt";
			if(isFile(%fp))
			{
				%file.openForRead(%fp);
				
				if(%slctn !$= "AllSaves")
				{
					//Retrieve specific info from save, if it matches criteria
					while(!%file.isEOF() && %lineCount < 50)
					{
						%load = %file.readLine();
						if(getWord(%load,%num) $= %slctnData && getWord(%load,0) != 0)
						{
							%itemCount = 0;
							for(%d=9; %d<73; %d+=2)
							{
								%item = getWord(%load,%d);
								if(%item !$= "0" && %item  !$= "" && isObject(%item))
									%itemCount++;
							}
							%strLn = %strLn SPC getWord(%load,6) SPC %itemCount SPC getWord(%load,0) SPC getWord(%load,1) SPC getWord(%load,3) SPC getWord(%load,4);
							%lineCount++;
						}
					}
				}
				else
				{
					//Retrieve all saves from all files
					while(!%file.isEOF() && %lineCount<50)
					{
						%load = %file.readLine();
						if(getWord(%load,0) != 0)
						{
							%itemCount = 0;
							for(%d=9; %d<73; %d+=2)
							{
								%item = getWord(%load,%d);
								if(%item !$= "0" && %item  !$= "" && isObject(%item))
									%itemCount++;
							}
							%strLn = %strLn SPC getWord(%load,6) SPC %itemCount SPC getWord(%load,0) SPC getWord(%load,1) SPC getWord(%load,3) SPC getWord(%load,4);
							%lineCount++;
						}
					}
				}
			}
		}
		%file.close();
		%file.delete();
		%strLn = setWord(%strLn,0,%lineCount);
		return %strLn;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Search backpack saves
	
	else if(%fldr $= "BackPacks")
	{
		//////////////////////////////////////////////////
		//Check if save file exists
		
		%fp = "Config/Server/ItemStorage/" @ %fldr @ ".txt";
		%file = new FileObject();
		if(!isFile(%fp))
			return;
		%file.openForRead(%fp);
		
		//////////////////////////////////////////////////
		//Retrieve specific info from all saves
		
		if(%slctn $= "AllSaves")
		{
			while(!%file.isEOF())
			{
				%load = %file.readLine();
				if(getWord(%load,0) != 0 && %lineCount<50)
				{
					%itemCount = 0;
					for(%c=2; %c<32; %c+=2)
					{
						%item = getWord(%load,%c);
						if(%item !$= "0" && %item  !$= "" && isObject(%item))
							%itemCount++;
					}
					%strLn = %strLn SPC getWord(%load,1) SPC %itemCount SPC getWord(%load,0);
					%lineCount++;
				}
			}
			%file.close();
			%file.delete();
			%strLn = setWord(%strLn,0,%lineCount);
			return %strLn;
		}
		
		//////////////////////////////////////////////////
		//Retrieve specific info from save, if it matches criteria
		
		else
		{
			while(!%file.isEOF())
			{
				%load = %file.readLine();
				if(getWord(%load,%num) $= %slctnData && getWord(%load,0) != 0 && %lineCount<50)
				{
					%itemCount = 0;
					for(%c=2; %c<32; %c+=2)
					{
						%item = getWord(%load,%c);
						if(%item !$= "0" && %item  !$= "" && isObject(%item))
							%itemCount++;
					}
					%strLn = %strLn SPC getWord(%load,1) SPC %itemCount SPC getWord(%load,0);
					%lineCount++;
				}
			}
			%file.close();
			%file.delete();
			%strLn = setWord(%strLn,0,%lineCount);
			return %strLn;
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Search certain file
	
	else
	{
		//////////////////////////////////////////////////
		//Check if save file exists
		
		%fp = "Config/Server/ItemStorage/" @ %fldr @ ".txt";
		%file = new FileObject();
		if(!isFile(%fp))
			return;
		%file.openForRead(%fp);
		
		//////////////////////////////////////////////////
		//Retrieve specific info from all saves
		
		if(%slctn $= "AllSaves")
		{
			while(!%file.isEOF())
			{
				%load = %file.readLine();
				if(getWord(%load,0) != 0 && %lineCount<50)
				{
					%itemCount = 0;
					for(%c=9; %c<73; %c+=2)
					{
						%item = getWord(%load,%c);
						if(%item !$= "0" && %item  !$= "" && isObject(%item))
							%itemCount++;
					}
					%strLn = %strLn SPC getWord(%load,6) SPC %itemCount SPC getWord(%load,0) SPC getWord(%load,1) SPC getWord(%load,3) SPC getWord(%load,4);
					%lineCount++;
				}
			}
			%file.close();
			%file.delete();
			%strLn = setWord(%strLn,0,%lineCount);
			return %strLn;
		}
		
		//////////////////////////////////////////////////
		//Retrieve specific info from save, if it matches criteria
		
		else
		{
			while(!%file.isEOF())
			{
				%load = %file.readLine();
				if(getWord(%load,0) != 0 && getWord(%load,%num) $= %slctnData && %lineCount < 50)
				{
					%itemCount = 0;
					for(%c=9; %c<73; %c+=2)
					{
						%item = getWord(%load,%c);
						if(%item !$= "0" && %item  !$= "" && isObject(%item))
							%itemCount++;
					}
					%strLn = %strLn SPC getWord(%load,6) SPC %itemCount SPC getWord(%load,0) SPC getWord(%load,1) SPC getWord(%load,3) SPC getWord(%load,4);
					%lineCount++;
				}
			}
			%file.close();
			%file.delete();
			%strLn = setWord(%strLn,0,%lineCount);
			return %strLn;
		}
	}
	return 0;
}

//////////////////////////////////
//SAVE ITEMS TO SERVER'S SAVE FILE
//////////////////////////////////
function ISSaveItems(%cl,%brName,%name,%storType,%brItms,%access,%srcBrick)
{
	if(%name !$= "BackPacks")
	{
		if(ISQuotaCheck(%cl,%name,%brName) == 1)
			return 1;
			
		//Check if save file exists
		%fp = "Config/Server/ItemStorage/" @ %name @ ".txt";
		%fpB = "Config/Server/ItemStorage/BackupFiles/" @ %name @ ".txt";
		%file = new FileObject();
		
		if(!isFile(%fp)) 
		{
			%file.openForWrite(%fp);
			%file.writeLine(">>List of all item storage saves with names beginning with the letter: " @ %name);
			%file.writeLine(">>StorageSize, AccessValue, SourceBrick, RemoteAccessValue, OwnerID/Name, BrickName, LastEditedByID/Name, Items");
		}
		%file.openForAppend(%fp);

		//Write info to file
		%wrLn = %storType SPC %access SPC strReplace(%srcBrick.getPosition()," ","_") SPC 1 SPC %cl.bl_id SPC getSubStr(strReplace(%cl.name," ","_"),0,30) SPC 
			%brName SPC %cl.bl_id SPC getSubStr(strReplace(%cl.name," ","_"),0,30);
		for(%c = 0; %c < %storType && %c < 32; %c++)
		{
			%item = getWord(%brItms,%c*4);
			%itemAm = getWord(%brItms,(%c*4)+1);
			if(%itemAm > 999)
				%itemAm = 999;
			else if(%itemAm < 1)
				%item = 0;
			
			if(%item != 0 && %item.getClassName() $= "ItemData" && %item.getName() !$= "")
				%t = %item.getName() SPC %itemAm;
			else
				%t = 0 SPC 0;
			%wrLn = %wrLn SPC %t;
		}

		//Update player method that save is present
		%cl.brInv = setWord(%cl.brInv,0,1);
	}
	else
	{
		//Check if save file exists
		%fp = "Config/Server/ItemStorage/BackPacks.txt";
		%fpB = "Config/Server/ItemStorage/BackupFiles/BackPacks.txt";
		%file = new FileObject();
		
		if(!isFile(%fp)) 
		{
			%file.openForWrite(%fp);
			%file.writeLine(">>List of all item storage saves for player backpacks");
			%file.writeLine(">>OwnerID/Name, Items");
		}
		
		//Check backpack quota
		%file.openForRead(%fp);
		%lineNum = 0;
		
		while(!%file.isEOF())
		{
			%load = %file.readLine();
			if(getWord(%load,0) != 0)
				%lineNum++;
			else
			{
				%lineStr = getSubStr(%load,0,2);
				if(%lineStr !$= ">>" && %lineStr !$= "//" && %lineStr !$= "")
					%lineNum++;
			}
			
			if(%lineNum >= getWord($HstSetString,8))
			{
				%file.close();
				%file.delete();
				
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Over File Quota",
						"Server has reached the limit of \"" @ getWord($HstSetString,8) @ "\" for backpack saves. " @
						"Existing saves need to be deleted to make room for new ones; SAVE FAILED.");
				else
					commandtoClient(%cl,'ISMsgBox',"Over File Quota","denied",
						"Server has reached the limit of \"" @ getWord($HstSetString,8) @ "\" for backpack saves. " @
						"Existing saves need to be deleted to make room for new ones; SAVE FAILED.",0,"");
				return 1;
			}
		}
	
		//Write info to file
		%wrLn = %cl.bl_id SPC getSubStr(strReplace(%cl.name," ","_"),0,30);
		%bkpkID = ISBackPackItem.getID();
		for(%c = 0; %c < 15; %c++)
		{
			%item = getWord(%brItms,(%c*4));
			%itemAm = getWord(%brItms,(%c*4)+1);
			if(%itemAm > 999)
				%itemAm = 999;
			else if(%itemAm < 1)
				%item = 0;
			
			if(%item != 0 && %item.getClassName() $= "ItemData" && %item.getName() !$= "" && %item != %bkpkID)
				%t = %item.getName() SPC %itemAm;
			else
				%t = 0 SPC 0;
			%wrLn = %wrLn SPC %t;
		}
		%cl.bkpkInv = setWord(%cl.bkpkInv,0,1);
		%cl.bkpkInv = setWord(%cl.bkpkInv,1,%cl.bl_id);
	}
	
	%file.openForAppend(%fp);
	%file.writeLine(%wrLn);
	%file.close();
	if(getWord($HstSetString,16))
	{
		%file.openForAppend(%fpB);
		%file.writeLine(%wrLn);
		%file.close();
	}
	%file.delete();
}

////////////////////////////
//OVERWRITE AN EXISTING SAVE
////////////////////////////
function ISOverWriteSave(%cl,%name,%brName,%storType,%brItms,%access,%brick,%avoidErr)
{
	//Check if save file exists
	%fp = "Config/Server/ItemStorage/" @ %name @ ".txt";
	%fpB = "Config/Server/ItemStorage/BackupFiles/" @ %name @ ".txt";
	%file = new FileObject();
	
	if(%name !$= "BackPacks")
	{
		if(!isFile(%fp)) 
		{
			%file.openForWrite(%fp);
			%file.writeLine(">>List of all item storage saves with names beginning with the letter: " @ %name);
			%file.writeLine(">>StorageSize, AccessValue, SourceBrick, RemoteAccessValue, OwnerID/Name, BrickName, LastEditedByID/Name, Items");
		}
		%file.openForRead(%fp);
		
		//Save file lines to array; overwrite modified line
		%lineNum = 0; //must be defined or first line won't be written to file
		while(!%file.isEOF())
		{
			%load = %file.readLine();
			if(getWord(%load,0) != 0)
			{
				if(getWord(%load,6) $= %brName)
				{
					//Carry over certain info and include new info (remote access, source brick, etc. are saved in ISSAVEINFO)
					%wrLn = getWord(%load,0) SPC %access SPC getWords(%load,2,6) SPC %cl.bl_id SPC getSubStr(strReplace(%cl.name," ","_"),0,30);
					
					for(%c = 0; %c < %storType && %c < 32; %c++)
					{
						%item = getWord(%brItms,%c*4);
						%itemAm = getWord(%brItms,(%c*4)+1);
						if(%itemAm > 999)
							%itemAm = 999;
						else if(%itemAm < 1)
							%item = 0;
						
						if(%item != 0 && %item.getClassName() $= "ItemData" && %item.getName() !$= "")
							%t = %item.getName() SPC %itemAm;
						else
							%t = 0 SPC 0;
						%wrLn = %wrLn SPC %t;
					}
					%temp[%lineNum] = %wrLn;
					%pass = 1;
				}
				else
					%temp[%lineNum] = %load;
				%lineNum++;
			}
		}
		
		//If save wasn't found
		if(%pass != 1)
		{
			%file.close();
			%file.delete();
			
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Save Not Found","Save was not found (it might have been deleted by the host or owner).");
			else
				commandtoClient(%cl,'ISMsgBox',"Save Not Found; Resave?","error","Save was not found (it might have been deleted by the host or owner)." @
					" Create new save with current items with you as the owner? Items will be deleted if you decline.",2,%brick);
			return 1;
		}
		
		//Write new file from array
		%file.openForWrite(%fp);
		%file.writeLine(">>List of all item storage saves with names beginning with the letter: " @ %name);
		%file.writeLine(">>StorageSize, AccessValue, SourceBrick, RemoteAccessValue, OwnerID/Name, BrickName, LastEditedByID/Name, Items");
		for(%c = 0; %c < %lineNum; %c++)
			%file.writeLine(%temp[%c]);
		%file.close();
		
		if(getWord($HstSetString,16))
		{
			%file.openForWrite(%fpB);
			%file.writeLine(">>List of all item storage saves with names beginning with the letter: " @ %name);
			%file.writeLine(">>StorageSize, AccessValue, SourceBrick, RemoteAccessValue, OwnerID/Name, BrickName, LastEditedByID/Name, Items");
			for(%c = 0; %c < %lineNum; %c++)
			%file.writeLine(%temp[%c]);
			%file.close();
		}
		%file.delete();
	}
	else
	{
		if(!isFile(%fp)) 
		{
			%file.openForWrite(%fp);
			%file.writeLine(">>List of all item storage saves for player backpacks");
			%file.writeLine(">>OwnerID/Name, Items");
		}
		%file.openForRead(%fp);
		
		//Save file lines to array; overwrite modified line
		%lineNum = 0; //must be defined or first line won't be written to file
		%bkpkID = ISBackPackItem.getID();
		
		while(!%file.isEOF())
		{
			%load = %file.readLine();
			%lineStr = getSubStr(%load,0,2);
			if(getWord(%load,0) != 0 || (%lineStr !$= "" && %lineStr !$= ">>" && %lineStr !$= "//"))
			{
				if(getWord(%load,0) == %brName) //%brName = client's ID, in this case
				{
					%wrLn = getWords(%load,0,1);
					for(%c = 0; %c < 15; %c++)
					{
						%item = getWord(%brItms,(%c*4));
						%itemAm = getWord(%brItms,(%c*4)+1);
						if(%itemAm > 999)
							%itemAm = 999;
						else if(%itemAm < 1)
							%item = 0;
						
						if(%item != 0 && %item.getClassName() $= "ItemData" && %item.getName() !$= "" && %item != %bkpkID)
							%t = %item.getName() SPC %itemAm;
						else
							%t = 0 SPC 0;
						%wrLn = %wrLn SPC %t;
					}
					%temp[%lineNum] = %wrLn;
					%pass = 1;
				}
				else
					%temp[%lineNum] = %load;
				%lineNum++;
			}
		}
		
		//If save wasn't found
		if(%pass != 1)
		{
			%file.close();
			%file.delete();
			
			if(%avoidErr != 1)
			{
				if(getWord(%cl.ISclInfo,2) != 4)
					commandtoClient(%cl,'messageboxOK',"Save Not Found","Backpack save was not found; Overwriting of save failed.");
				else
					commandtoClient(%cl,'ISMsgBox',"Save Not Found","error","Backpack save was not found; Overwriting of save failed.",0,"");
			}
			return 1;
		}
		
		//Write new file from array
		%file.openForWrite(%fp);
		%file.writeLine(">>List of all item storage saves for player backpacks");
		%file.writeLine(">>OwnerID/Name, Items");
		for(%c = 0; %c < %lineNum; %c++)
			%file.writeLine(%temp[%c]);
		%file.close();
		
		if(getWord($HstSetString,16))
		{
			%file.openForWrite(%fpB);
			%file.writeLine(">>List of all item storage saves for player backpacks");
			%file.writeLine(">>OwnerID/Name, Items");
			for(%c = 0; %c < %lineNum; %c++)
				%file.writeLine(%temp[%c]);
			%file.close();
		}
		%file.delete();
	}
}

/////////////////////////////////////////////////////////
//SAVE ACCESS, SOURCEBRICK, REMOTEACCESS, ETC. SEPARATELY
/////////////////////////////////////////////////////////
function ISSaveInfo(%cl,%brName,%name,%access,%srcBrick,%rmtAcc,%ownerID,%ownerName)
{
	//Access, source brick, remote access and change in ownership are saved separately from items

	if(isObject(%srcBrick) && %srcBrick.getClassName() $= "fxDTSBrick")
		%srcBrick = strReplace(%srcBrick.getPosition()," ","_");
	
	//Check if save file exists
	%fp = "Config/Server/ItemStorage/" @ %name @ ".txt";
	%fpB = "Config/Server/ItemStorage/BackupFiles/" @ %name @ ".txt";
	%file = new FileObject();
	if(!isFile(%fp)) 
	{
		%file.openForWrite(%fp);
		%file.writeLine(">>List of all item storage saves with names beginning with the letter: " @ %name);
		%file.writeLine(">>StorageSize, AccessValue, SourceBrick, RemoteAccessValue, OwnerID/Name, BrickName, LastEditedByID/Name, Items");
	}
	%file.openForRead(%fp);
	
	//Save file lines to array; overwrite modified line
	%lineNum = 0;
	while(!%file.isEOF())
	{
		%load = %file.readLine();
		if(getWord(%load,0) != 0)
		{
			if(getWord(%load,6) $= %brName)
			{
				%wrLn = getWord(%load,0) SPC %access SPC %srcBrick SPC %rmtAcc SPC %ownerID SPC %ownerName SPC
					getWord(%load,6) SPC %cl.bl_id SPC getSubStr(strReplace(%cl.name," ","_"),0,30);
				
				%wrLn = %wrLn SPC getWords(%load,9,getWordCount(%load)-1); //-1?
				%temp[%lineNum] = %wrLn;
			}
			else
				%temp[%lineNum] = %load;
			%lineNum++;
		}
	}
	
	//Write new file from array
	%file.openForWrite(%fp);
	%file.writeLine(">>List of all item storage saves with names beginning with the letter: " @ %name);
	%file.writeLine(">>StorageSize, AccessValue, SourceBrick, RemoteAccessValue, OwnerID/Name, BrickName, LastEditedByID/Name, Items");
	for(%c = 0; %c < %lineNum; %c++)
		%file.writeLine(%temp[%c]);
	%file.close();
	
	if(getWord($HstSetString,16))
	{
		%file.openForWrite(%fpB);
		%file.writeLine(">>List of all item storage saves with names beginning with the letter: " @ %name);
		%file.writeLine(">>StorageSize, AccessValue, SourceBrick, RemoteAccessValue, OwnerID/Name, BrickName, LastEditedByID/Name, Items");
		for(%c = 0; %c < %lineNum; %c++)
			%file.writeLine(%temp[%c]);
		%file.close();
	}
	%file.delete();
}

//////////////////////////////////////////
//RETRIEVE NAME OF FILE THAT CONTAINS SAVE
//////////////////////////////////////////
function ISGetFile(%cl,%brName)
{
	%name = getSubStr(%brName,0,1);
	%Fchar = "abcdefghijklmnopqrstuvwxyz";
	
	for(%c=0;%c<26;%c++)
	{
		%tempChar = getSubStr(%Fchar,%c,1);
		
		if(%tempChar $= %name)
			return %name;
	}
	if(getWord(%cl.ISclInfo,2) != 4)
		commandtoClient(%cl,'messageboxOK',"Invalid Name","The first character of your storage brick's name must be a letter between A to Z.");
	else
		commandtoClient(%cl,'ISMsgBox',"Invalid Name","error","The first character of your storage brick's name must be a letter between A to Z.",0,"");
	return 0;
}
