//Host GUI settings are saved in "Config/Client/ItemStorageCl.txt"
//Client Cmds are for loading/updating GUIs only

//exec("add-ons/System_ItemStorage/GUIs/ISManualGUI.gui");
exec("add-ons/System_ItemStorage/GUIs/ISMainGUI.gui");
exec("add-ons/System_ItemStorage/GUIs/ISPlyrInvGUI.gui");
exec("add-ons/System_ItemStorage/GUIs/ISBackPackGUI.gui");
exec("add-ons/System_ItemStorage/GUIs/ISMsgBoxGUI.gui");
exec("add-ons/System_ItemStorage/GUIs/ISTransAmGUI.gui");
exec("add-ons/System_ItemStorage/Scripts/GUIBehvr.cs");

/////////////////////////////////////////////
//RELAY COMMAND TO TOGGLE CLIENT BACKPACK GUI
/////////////////////////////////////////////
function ClientCmdISRelayBkPkToggle(%toggle)
{
	Toggle_ISBackpackGUI(%toggle);
}

///////////////////////////////////////////////////
//RELAY COMMAND TO SETUP HASADDON METHOD FOR PLAYER
///////////////////////////////////////////////////
function ClientCmdISHasAddOnRelay()
{
	commandToServer('ISHasAddOnRelay',4);
}

////////////////////////////////
//MESSAGE CLIENT WITH CUSTOM GUI
////////////////////////////////
function ClientCmdISMsgBox(%title,%icon,%text,%OKcmd,%var)
{
	canvas.pushDialog(ISMsgBoxGUI);
	
	ISMsgBoxTitle.setText("<font:Impact:24><color:ffffff>" @ %title);
	ISMsgBoxIcon.setBitmap("add-ons/system_itemstorage/GUIs/" @ %icon);
	ISMsgBoxText.setText("<font:Impact:18>" @ %text);
	ISMsgBoxText.var = %var;
	
	if(%OKcmd != 0)
	{
		if(%OKcmd == 1)
			ISokCmd.command = "commandToServer('ISRefreshInfo',ISMsgBoxText.var,-1,-1,-1,-1);canvas.popDialog(ISMsgBoxGUI);";
		else if(%OKcmd == 2)
			ISokCmd.command = "commandToServer('ISReSave');canvas.popDialog(ISMsgBoxGUI);";
		else if(%OKcmd == 3)
			ISokCmd.command = "canvas.popDialog(ISMsgBoxGUI);ISSaveItemSettings();"; //canvas.popDialog(ISItemsGUI);
		else if(%OKcmd == 4)
			ISokCmd.command = "canvas.popDialog(ISMsgBoxGUI);ISSaveGUISettings();";
		ISMsgBoxOkCan.visible = 1;
	}
	else
		ISMsgBoxOkCan.visible = 0;
}

/////////////////////////
//LOAD ITEM DATA INTO GUI
/////////////////////////
function ClientCmdISPopulateGUI(%loadBr,%plyrItms,%loadBp,%mxTls,%brName,%miscInfo,%storType,%storName,%AccBtnOn,%clCount)
{
	ItemStorWndw.prevCell = "";
	ItemStorWndw.temp = "" SPC "" SPC getWord(%miscInfo,2) SPC getWord(%miscInfo,4) SPC getWord(%miscInfo,5);

	////////////////////////////////////////////////////////////////////////////////////////////////////
	//If not just accessing backpack
	
	if(%loadBr != -1)
	{
		//Load brick and player data into GUI for access later
		ItemStorWndw.access = getWord(%loadBr,1);
		ItemStorWndw.rmtAcc = getWord(%loadBr,3);
		ItemStorWndw.ownerName = getWord(%loadBr,5);
		ItemStorWndw.brName = %brName;
		%access = getWord(%loadBr,1);
		%rmtAcc = getWord(%loadBr,3);
	
		//////////////////////////////////////////////////
		
		//Update client count
		IsAccessNum.setText("<font:Impact:24>" @ %clCount-1);
		
		//Update brick preview icon
		if(getWord(%miscInfo,1) !$= "")
			ISPrevIcon.setBitmap(getWord(%miscInfo,1)); //gameconnection clients can't find brick datablock / iconname; send from server
		else
			ISPrevIcon.setBitmap("base/client/ui/brickicons/Unknown");
			
		//Update inventory name and owner
		if(getWord(%loadBr,5) $= "")
			ItemStorWndw.setText("\"" @ %brName @ "\" -> NewSave");
		else
			ItemStorWndw.setText("\"" @ %brName @ "\" -> " @ getWord(%loadBr,5));
		
		//Add inventory size/name 
		SwTBrInv.setText("<font:Impact:24><color:ffffff>Brick Inventory" SPC %storName);
		
		//////////////////////////////////////////////////
		//Set access button text, color, enabled/disabled
		
		if(%access != 0)
		{
			if(%access == 1)
			{
				ISAccessBtn.setText("PUBLIC");
				ISAccessBtn.mColor = "0 255 0 255";
			}
			else if(%access == 2)
			{
				ISAccessBtn.setText("ADMIN");
				ISAccessBtn.mColor = "255 255 0 255";
			}
			else
			{
				ISAccessBtn.setText("S-ADMIN");
				ISAccessBtn.mColor = "255 128 0 255";
			}
		}
		else
		{
			ISAccessBtn.setText("PRIVATE");
			ISAccessBtn.mColor = "255 0 0 255";
		}
		
		//////////////////////////////////////////////////
		//Set access button trans/non-trans (if owner/host or not)
		
		if(%AccBtnOn == 1)
		{
			ISAccessBtn.enabled = 1;
			ISAccessBtn.mColor = setWord(ISAccessBtn.mColor,3,255);
		}
		else
		{
			ISAccessBtn.enabled = 0;
			ISAccessBtn.mColor = setWord(ISAccessBtn.mColor,3,128);
		}
		
		//////////////////////////////////////////////////
		//Set remote access button text
		
		if(%rmtAcc == 1 || %rmtAcc $= "")
		{
			ISRmteAccessBtn.setText("Remote Access [ON]");
			ISRmteAccessBtn.mColor = "150 190 255 255";
		}
		else
		{
			ISRmteAccessBtn.setText("Remote Access [OFF]");
			ISRmteAccessBtn.mColor = "190 210 255 255";
		}
		
		//Detect if using HUGE inv; increase scroll window size if so
		%storType = getWord(%loadBr,0);
		if(%storType == 32 || %storType == -32)
			SWBtns.extent = "244 484";
		else
			SWBtns.extent = "244 242";
			
		//Open GUIs
		canvas.pushDialog(ISMainGUI);
		
		for(%c = 0; %c < ISMainGUI.getCount(); %c++)
		{
			if(ISMainGUI.getObject(%c).getName() $= "ItemStorWndwB")
			{
				%checkB = 1;
				break;
			}
		}
		if(%loadBp == -1)
		{
			if(%checkB != 1)
			{
				ISMainGUI.add(ItemStorWndwB);
				ItemStorWndwB.closeCommand = "commandtoserver('ISDelVars',0);canvas.popDialog(ISMainGUI);";
			}
			for(%c = 0; %c < ISMainGUI.getCount(); %c++)
			{
				if(ISMainGUI.getObject(%c).getName() $= "ItemStorWndwC")
				{
					ISMainGUI.remove(ItemStorWndwC);
					break;
				}
			}
		}
		
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//Load cells for brick GUI
		
		if(%storType > 0)
		{
			for(%c = 0; %c < 32; %c++)
			{
				%t = "BrStor" @ %c;
				%u = "BtnBS" @ %c;
				%v = "BrBp" @ %c;
				%w = "BrStck" @ %c;
				%x = "BrStckBG" @ %c;
				
				//Only load cells relative to storage size
				if(%c < %storType)
				{
					%u.enabled = 1;
					%u.mColor = "0 0 0 255";
					%item = getWord(%loadBr,9+(%c*4));
					%itemWght= getWord(%loadBr,9+(%c*4)+3);
					%v.setBitmap("Add-Ons/System_ItemStorage/GUIs/emptyBG");

					//If item found for that cell, load info, otherwise set cell to empty
					if(%item > 0 && %item.getClassName() $= "ItemData" && %item.uiName !$= "")
					{
						%w.visible = 1;
						%stackLimit = getWord(%loadBr,9+(%c*4)+2);
						%w.setText("<just:right><font:Impact:18><color:ffffff> " @ getWord(%loadBr,9+(%c*4)+1) @ " <color:999999> " @ %stackLimit);
						%x.visible = 1;
						
						%len = strLen(getWord(%loadBr,9+(%c*4)+1) SPC %stackLimit);
						%len = (%len * 8) - 4; //8=char size; 4=two spaces between amount and weight symbol
						%x.extent = %len SPC 14;
						%x.position = (60 - %len) SPC 46;
						
						if(%item.iconName $= "" || !isFile(%item.iconName))
						{
							%sf = strReplace(%item.shapeFile,"_","/");
							%sf = strReplace(%item.shapeFile,"/"," ");
							%sf = getWord(%sf,2);
							%sf = "add-ons/print_letters_default/prints/" @ getSubStr(%sf,0,1) @ ".png";
							
							if(!isFile(%sf))
								%sf = "add-ons/print_letters_default/prints/-qmark.png";
							%t.setBitmap(%sf);
						}
						else
							%t.setBitmap(%item.IconName);
						
						%t.storedItem = %item;
						%t.storedWeight = %itemWght;

						if(%item.doColorShift == 1)
						{
							%csc = %item.colorShiftColor;
							%t.mColor = mFloatLength((getWord(%csc,0) * 255),0)
									SPC mFloatLength((getWord(%csc,1) * 255),0)
									SPC mFloatLength((getWord(%csc,2) * 255),0)
									SPC mFloatLength((getWord(%csc,3) * 255),0);
						}
						else
							%t.mColor = "255 255 255 255";
					}
					else
					{
						%t.setBitmap("\"\""); //prevents default blank image with border
						%t.storedItem = "";
						%t.storedWeight = "";
						%t.mColor = "255 255 255 255";
						%w.visible = 0;
						%x.visible = 0;
					}
				}
				else 
				{
					%t.setBitmap("\"\"");
					%t.storedItem = "";
					%t.storedWeight = "";
					%t.mColor = "255 255 255 255";
					%u.enabled = 0;
					%u.mColor = "0 0 0 63";
					%v.setBitmap("\"\"");
					%w.visible = 0;
					%x.visible = 0;
				}
			}
		}
	
		//If no save present (set all brick inv cells to empty)
		else
		{	
			%storType = mAbs(%storType);
			
			for(%c = 0; %c < 32; %c++)
			{
				%t = "BrStor" @ %c;
				%u = "BtnBS" @ %c;
				%v = "BrBp" @ %c;
				
				%w = "BrStck" @ %c;
				%x = "BrStckBG" @ %c;
				
				%t.setBitmap("\"\"");
				%t.storedItem = "";
				%t.storedWeight = "";
				%t.mColor = "255 255 255 255";
				
				%w.visible = 0;
				%x.visible = 0;
			
				if(%c < %storType)
				{
					%u.enabled = 1;
					%u.mColor = "0 0 0 255";
					%v.setBitmap("Add-Ons/System_ItemStorage/GUIs/emptyBG");
				}
				else
				{
					%u.enabled = 0;
					%u.mColor = "0 0 0 63";
					%v.setBitmap("\"\"");
				}
			}
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Load cells for player GUI
	
	if(%plyrItms != -1)
	{
		for(%c = 0; %c < 10; %c++)
		{
			%t = "plStor" @ %c;
			%u = "BtnPS" @ %c;
			%v = "PlBp" @ %c; //Plyr
			%w = "plStck" @ %c;
			%x = "PlStckBG" @ %c;
			
			//Only load cells relative to max player tool slots
			if(%c < %mxTls)
			{
				%u.enabled = 1;
				%u.mColor = "0 0 0 255";
				%item = getWord(%plyrItms,(%c*4));
				%itemWght= getWord(%plyrItms,(%c*4)+3);
				%v.setBitmap("Add-Ons/System_ItemStorage/GUIs/emptyBG");
				
				//If item found for that cell, load info, otherwise set cell to empty
				if(%item > 0 && %item.getClassName() $= "ItemData" && %item.uiName !$= "")
				{
					if(%item.iconName $= "" || !isFile(%item.iconName))
					{
						%sf = strReplace(%item.shapeFile,"_","/");
						%sf = strReplace(%item.shapeFile,"/"," ");
						%sf = getWord(%sf,2);
						%sf = "add-ons/print_letters_default/prints/" @ getSubStr(%sf,0,1) @ ".png";
						
						if(!isFile(%sf))
							%sf = "add-ons/print_letters_default/prints/-qmark.png";
						%t.setBitmap(%sf);
					}
					else
						%t.setBitmap(%item.IconName);
								
					%t.storedItem = %item;
					%t.storedWeight = %itemWght;
					%x.visible = 1;
					%x.extent = 8 SPC 14;
					%x.position = 52 SPC 46;
					%stackLimit = getWord(%loadBp,2+(%c*4)+2);
					%w.setText("<just:right><font:Impact:18><color:ffffff>1");
					%w.visible = 1;

					if(%item.doColorShift == 1)
					{
						%csc = %item.colorShiftColor;
						%t.mColor = mFloatLength((getWord(%csc,0) * 255),0)
								SPC mFloatLength((getWord(%csc,1) * 255),0)
								SPC mFloatLength((getWord(%csc,2) * 255),0)
								SPC mFloatLength((getWord(%csc,3) * 255),0);
					}
					else
						%t.mColor = "255 255 255 255";
				}
				else
				{
					%t.setBitmap("\"\"");
					%t.storedItem = "";
					%t.storedWeight = "";
					%t.mColor = "255 255 255 255";
					%x.visible = 0;
					%x.extent = 8 SPC 14;
					%x.position = 52 SPC 46;
					%w.setText("<just:right><font:Impact:18><color:ffffff>1");
					%w.visible = 0;
				}
			}
			else
			{
				%t.setBitmap("\"\"");
				%t.storedItem = "";
				%t.storedWeight = "";
				%t.mColor = "255 255 255 255";
				%u.enabled = 0;
				%u.mColor = "0 0 0 63";
				%v.setBitmap("\"\"");
				%x.visible = 0;
				%x.extent = 8 SPC 14;
				%x.position = 52 SPC 46;
				%w.setText("<just:right><font:Impact:18><color:ffffff>1");
				%w.visible = 0;
			}
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Load backpack items
	
	if(%loadBp != -1)
	{
		//later, if multiple backpack models included, change backpack preview icon to model icon
		
		//////////////////////////////////////////////////
		//Open backpack GUI; initialize
		
		if(ISMainGUI.isAwake())
		{
			ISMainGUI.add(ItemStorWndwB);
			ISMainGUI.add(ItemStorWndwC);
			ItemStorWndwB.closeCommand = "commandtoserver('ISDelVars',0);canvas.popDialog(ISMainGUI);";
			ItemStorWndwC.closeCommand = "commandtoserver('ISDelVars',0);canvas.popDialog(ISMainGUI);";
			ISBpClsBtn.command = "commandtoserver('ISDelVars',0);canvas.popDialog(ISMainGUI);";
		}
		else
		{
			canvas.pushDialog(ISBackPackGUI);
			
			for(%c = 0; %c < ISBackPackGUI.getCount(); %c++)
			{
				if(ISBackPackGUI.getObject(%c).getName() $= "ItemStorWndwB")
					%checkB = 1;
				if(ISBackPackGUI.getObject(%c).getName() $= "ItemStorWndwC")
					%checkC = 1;
			}
			if(%checkB != 1)
			{
				ISBackPackGUI.add(ItemStorWndwB);
				ItemStorWndwB.closeCommand = "commandtoserver('ISDelVars',1);canvas.popDialog(ISBackPackGUI);";
			}
			if(%checkC != 1)
			{
				ISBackPackGUI.add(ItemStorWndwC);
				ItemStorWndwC.closeCommand = "commandtoserver('ISDelVars',1);canvas.popDialog(ISBackPackGUI);";
				ISBpClsBtn.command = "commandtoserver('ISDelVars',1);canvas.popDialog(ISBackPackGUI);";
			}
		}
		
		//////////////////////////////////////////////////
		//Load cells for backpack GUI
		
		//%bkpkID = ISBackPackItem.getID(); //clients can't reference items by name (?)
		for(%c = 0; %c < 15; %c++) //load items whether present or not; if blank, it'll clear inventory
		{
			%t = "BpStor" @ %c;
			%u = "BtnBpS" @ %c;
			%w = "BpStck" @ %c;
			%x = "BpStckBG" @ %c;
			%item = getWord(%loadBP,2+(%c*4));
			%itemWght = getWord(%loadBP,2+(%c*4)+3);
			
			//If item found for that cell, load info, otherwise set cell to empty
			if(%item > 0 && %item.getClassName() $= "ItemData" && %item.uiName !$= "")
			{
				%w.visible = 1;
				%stackLimit = getWord(%loadBp,2+(%c*4)+2);
				%w.setText("<just:right><font:Impact:18><color:ffffff> " @ getWord(%loadBP,2+(%c*4)+1) @ " <color:999999> " @ %stackLimit);
				%x.visible = 1;
				
				%len = strLen(getWord(%loadBp,2+(%c*4)+1) SPC %stackLimit); //strLen(getWord(%loadBp,2+(%c*4)+1)) + strLen(%stackLimit);
				%len = (%len * 8) - 4; //8=char size; 4=two spaces between amount and weight symbol
				%x.extent = %len SPC 14;
				%x.position = (60 - %len) SPC 46;
					
				if(%item.iconName $= "" || !isFile(%item.iconName))
				{
					%sf = strReplace(%item.shapeFile,"_","/");
					%sf = strReplace(%item.shapeFile,"/"," ");
					%sf = getWord(%sf,2);
					%sf = "add-ons/print_letters_default/prints/" @ getSubStr(%sf,0,1) @ ".png";

					if(!isFile(%sf))
						%sf = "add-ons/print_letters_default/prints/-qmark.png";
					%t.setBitmap(%sf);
				}
				else
					%t.setBitmap(%item.IconName);
								
				%t.storedItem = %item;
				%t.storedWeight = %itemWght;

				if(%item.doColorShift == 1)
				{
					%csc = %item.colorShiftColor;
					%t.mColor = mFloatLength((getWord(%csc,0) * 255),0)
							SPC mFloatLength((getWord(%csc,1) * 255),0)
							SPC mFloatLength((getWord(%csc,2) * 255),0)
							SPC mFloatLength((getWord(%csc,3) * 255),0);
				}
				else
					%t.mColor = "255 255 255 255";
			}
			else
			{
				%t.setBitmap("\"\"");
				%t.storedItem = "";
				%t.storedWeight = "";
				%t.mColor = "255 255 255 255";
				
				%w.visible = 0;
				%x.visible = 0;
			}
		}
		
		//Encumbrance display
		if(getWord(%miscInfo,2))
		{
			ISEnc.setText("Encumbrance:");
			if(getWord(%miscInfo,3) > getWord(%miscInfo,4))
			{
				if(getWord(%miscInfo,3) > 99999)
					ISEncAm.setText("<font:Impact:24><color:ff0000> 99999+ of " @ getWord(%miscInfo,4) SPC getWord(%miscInfo,5));
				else
					ISEncAm.setText("<font:Impact:24><color:dd0000> " @ getWord(%miscInfo,3) @ " of " @ getWord(%miscInfo,4) SPC getWord(%miscInfo,5));
			}
			else
				ISEncAm.setText("<font:Impact:24> " @ getWord(%miscInfo,3) @ " of " @ getWord(%miscInfo,4) SPC getWord(%miscInfo,5));
		}
		else
		{
			ISEnc.setText("Encumbrance: (Disabled)");
			ISEncAm.setText("");
		}
	}
}

//////////////////////////////////////////////////
//UPDATE CURRENT AND PREVIOUS CELLS FOR CLIENT GUI
//////////////////////////////////////////////////
function ClientCmdISRefreshGUI(%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght,%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght)
{
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Most recent/current cell
	
	if(%currCell !$= "" && isObject(%currCell))
	{
		%cellN = getSubStr(%currCell,0,2);
		%cell = getSubStr(%currCell,6,2);
		%x = %cellN @ "StckBG" @ %cell;
		
		if(%itemA > 0 && %itemA.getClassName() $= "ItemData" && %itemA.uiName !$= "")
		{
			%currCell.storedItem = %itemA;
			%currCell.storedWeight = %itemAWght;
			
			if(%itemA.iconName $= "" || !isFile(%itemA.iconName))
			{
				%sf = strReplace(%itemA.shapeFile,"_","/");
				%sf = strReplace(%itemA.shapeFile,"/"," ");
				%sf = getWord(%sf,2);
				%sf = "add-ons/print_letters_default/prints/" @ getSubStr(%sf,0,1) @ ".png";
				
				if(!isFile(%sf))
					%sf = "add-ons/print_letters_default/prints/-qmark.png";
				%currCell.setBitmap(%sf);
			}
			else
				%currCell.setBitmap(%itemA.IconName);

			//Icon ColorShift
			if(%itemA.doColorShift == 1)
			{
				%csc = %itemA.colorShiftColor;
				%currCell.mColor = mFloatLength((getWord(%csc,0) * 255),0)
								SPC mFloatLength((getWord(%csc,1) * 255),0)
								SPC mFloatLength((getWord(%csc,2) * 255),0)
								SPC mFloatLength((getWord(%csc,3) * 255),0);
			}
			else
				%currCell.mColor = "255 255 255 255";
			
			//Stack Amount
			%w = %cellN @ "Stck" @ %cell;
			if(%cellN !$= "Pl")
			{
				%w.setText("<just:right><font:Impact:18><color:ffffff> " @ %itemAam @ " <color:999999> " @ %itemASkAm);
				%len = strLen(%itemAam SPC %itemASkAm); //change 1 later
				%len = (%len * 8) - 4; //8=char size; 4=two spaces between amount and weight symbol
				
			}
			else
			{
				%w.setText("<just:right><font:Impact:18><color:ffffff>1");
				%len = 8;
			}
			%w.visible = 1;
			%x.extent = %len SPC 14;
			%x.position = (60 - %len) SPC 46;
			%x.visible = 1;
		}
		else
		{
			%currCell.storedItem = "";
			%currCell.storedWeight = "";
			%currCell.setBitmap("\"\"");
			%currCell.mColor = "255 255 255 255";
			
			%w = %cellN @ "Stck" @ %cell;
			%w.visible = 0;
			%x.visible = 0;
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Previous cell
	
	if(%prevCell !$= "" && isObject(%prevCell))
	{		
		%cellN = getSubStr(%prevCell,0,2);
		%cell = getSubStr(%prevCell,6,2);
		%x = %cellN @ "StckBG" @ %cell;
		
		if(%itemB > 0 && %itemB.getClassName() $= "ItemData" && %itemB.uiName !$= "")
		{
			%prevCell.storedItem = %itemB;
			%prevCell.storedWeight = %itemBWght;
			
			if(%itemB.iconName $= "" || !isFile(%itemB.iconName))
			{
				%sf = strReplace(%itemB.shapeFile,"_","/");
				%sf = strReplace(%itemB.shapeFile,"/"," ");
				%sf = getWord(%sf,2);
				%sf = "add-ons/print_letters_default/prints/" @ getSubStr(%sf,0,1) @ ".png";
				
				if(!isFile(%sf))
					%sf = "add-ons/print_letters_default/prints/-qmark.png";
				%prevCell.setBitmap(%sf);
			}
			else
				%prevCell.setBitmap(%itemB.IconName);

			if(%itemB.doColorShift == 1)
			{
				%csc = %itemB.colorShiftColor;
				%prevCell.mColor = mFloatLength((getWord(%csc,0) * 255),0)
								SPC mFloatLength((getWord(%csc,1) * 255),0)
								SPC mFloatLength((getWord(%csc,2) * 255),0)
								SPC mFloatLength((getWord(%csc,3) * 255),0);
			}
			else
				%prevCell.mColor = "255 255 255 255";
			
			//Stack Amount
			%w = %cellN @ "Stck" @ %cell;
			if(%cellN !$= "Pl")
			{
				%w.setText("<just:right><font:Impact:18><color:ffffff> " @ %itemBam @ " <color:999999> " @ %itemBSkAm);
				%len = strLen(%itemBam SPC %itemBSkAm);
				%len = (%len * 8) - 4; //8=char size; 4=two spaces between amount and weight symbol
				
			}
			else
			{
				%w.setText("<just:right><font:Impact:18><color:ffffff>1");
				%len = 8;
			}
			%w.visible = 1;
			%x.extent = %len SPC 14;
			%x.position = (60 - %len) SPC 46;
			%x.visible = 1;
		}
		else
		{
			%prevCell.storedItem = "";
			%prevCell.storedWeight = "";
			%prevCell.setBitmap("\"\"");
			%prevCell.mColor = "255 255 255 255";

			%w = %cellN @ "Stck" @ %cell;
			%w.visible = 0;
			%x.visible = 0;
		}
	}
	
	if(%prevCell $= ItemStorWndw.prevCell || %currCell $= ItemStorWndw.prevCell)
		ItemStorWndw.prevCell = "";
}

////////////////////////////////////////////////////////////////////////////////////////
//UPDATE CLIENT COUNT, OR REMOTE ACCESS BUTTON/VALUE, ACCESS BUTTON/VALUE AND OWNER NAME
////////////////////////////////////////////////////////////////////////////////////////
function ClientCmdISRefreshInfoGUI(%clCount,%access,%rmtAcc,%owner,%pass,%enc)
{
	//Update client access number and other info
	if(%pass == 1)
	{
		IsAccessNum.setText("<font:Impact:24>" @ %clCount-1);
		return;
	}
	else if(%pass == 2)
	{
		//Encumbrance display
		if(getWord(%enc,0))
		{
			ISEnc.setText("Encumbrance:");
			if(getWord(%enc,1) > getWord(%enc,2))
			{
				if(getWord(%enc,1) > 99999)
					ISEncAm.setText("<font:Impact:24><color:ff0000> 99999+ of " @ getWord(%enc,2) SPC getWord(%enc,3));
				else
					ISEncAm.setText("<font:Impact:24><color:dd0000> " @ getWord(%enc,1) @ " of " @ getWord(%enc,2) SPC getWord(%enc,3));
			}
			else
				ISEncAm.setText("<font:Impact:24> " @ getWord(%enc,1) @ " of " @ getWord(%enc,2) SPC getWord(%enc,3));
		}
		else
		{
			ISEnc.setText("Encumbrance: (Disabled)");
			ISEncAm.setText("");
		}
		return;
	}
	else	
	{
		if(ItemStorWndw.ownerName !$= %owner && %owner != -1)
		{
			ItemStorWndw.ownerName = %owner;
			ItemStorWndw.setText("\"" @ ItemStorWndw.brName @ "\" -> " @ %owner);
		}
		
		//Set remote access button text
		if(ItemStorWndw.rmtAcc != %rmtAcc && %rmtAcc != -1)
		{
			ItemStorWndw.rmtAcc = %rmtAcc;
			
			if(%rmtAcc == 0)
			{
				ISRmteAccessBtn.setText("Remote Access [OFF]");
				ISRmteAccessBtn.mColor = "190 210 255 255";
			}
			else
			{
				ISRmteAccessBtn.setText("Remote Access [ON]");
				ISRmteAccessBtn.mColor = "150 190 255 255";
			}
		}
		
		//Access button
		if(ItemStorWndw.access != %access && %access != -1)
		{
			ItemStorWndw.access = %access;
			%mColorD = getWord(ISAccessBtn.mColor,3);
			if(%access != 0)
			{
				if(%access == 1)
				{
					ISAccessBtn.setText("PUBLIC");
					ISAccessBtn.mColor = "0 255 0 " @  %mColorD;
				}
				else if(%access == 2)
				{
					ISAccessBtn.setText("ADMIN");
					ISAccessBtn.mColor = "255 255 0 " @  %mColorD;
				}
				else if(%access == 3)
				{
					ISAccessBtn.setText("S-ADMIN");
					ISAccessBtn.mColor = "255 128 0 " @  %mColorD;
				}
			}
			else
			{
				ISAccessBtn.setText("PRIVATE");
				ISAccessBtn.mColor = "255 0 0 " @  %mColorD;
			}
		}
	}
}

//////////////////////////////////////////////
//IF UPDATING MULTIPLE CELLS FOR BRICK INV GUI
//////////////////////////////////////////////
function ClientCmdISMultRefreshGUI(%items,%inv)
{
	ItemStorWndw.prevCell = "";

	for(%c = 0; %c < (getWordCount(%items)/4); %c++)
	{
		%t = %inv @ "Stor" @ %c;
		%w = %inv @ "Stck" @ %c;
		%x = %inv @ "StckBG" @ %c;
		
		%item = getWord(%items,(%c*4)); //avoid blank word at beginning of string
		if(%item > 0 && %item.getClassName() $= "ItemData" && %item.uiName !$= "")
		{
			%itemAm = getWord(%items,(%c*4)+1);
			%itemSkAm = getWord(%items,(%c*4)+2);
			%itemAWght = getWord(%items,(%c*4)+3);
			
			//Stack Amount
			%w.setText("<just:right><font:Impact:18><color:ffffff> " @ %itemAm @ " <color:999999> " @ %itemSkAm);
			%w.visible = 1;
			
			%len = strLen(%itemAm SPC %itemSkAm);
			%len = (%len * 8) - 4; //8=char size; 4=two spaces between amount and weight symbol
			%x.extent = %len SPC 14;
			%x.position = (60 - %len) SPC 46;
				
			%x.visible = 1;
			if(%item.iconName $= "" || !isFile(%item.iconName))
			{
				%sf = strReplace(%item.shapeFile,"_","/");
				%sf = strReplace(%item.shapeFile,"/"," ");
				%sf = getWord(%sf,2);
				%sf = "add-ons/print_letters_default/prints/" @ getSubStr(%sf,0,1) @ ".png";
				
				if(!isFile(%sf))
					%sf = "add-ons/print_letters_default/prints/-qmark.png";
				%t.setBitmap(%sf);
			}
			else
				%t.setBitmap(%item.IconName);
			%t.storedItem = %item;
			%t.storedWeight = %itemAWght;

			if(%item.doColorShift == 1)
			{
				%csc = %item.colorShiftColor;
				%t.mColor = mFloatLength((getWord(%csc,0) * 255),0)
						SPC mFloatLength((getWord(%csc,1) * 255),0)
						SPC mFloatLength((getWord(%csc,2) * 255),0)
						SPC mFloatLength((getWord(%csc,3) * 255),0);
			}
			else
				%t.mColor = "255 255 255 255";
		}
		else
		{
			%t.setBitmap("\"\"");
			%t.storedItem = "";
			%t.storedWeight = "";
			%t.mColor = "255 255 255 255";
			%w.visible = 0;
			%x.visible = 0;
		}
	}
}

///////////////////////////////
//GRADUALLY LOAD ITEMS INTO GUI
///////////////////////////////
function ClientCmdISPopulateGUIRel(%inv,%cells,%items)
{
	//ItemStorWndw.prevCell = ""; //?
	
	for(%c = getWord(%cells,0); %c <= getWord(%cells,1); %c+=4)
	{
		%t = %inv @ "Stor" @ %c/4;
		%w = %inv @ "Stck" @ %c/4;
		%x = %inv @ "StckBG" @ %c/4;
		
		%item = getWord(%items,(%c - getWord(%cells,0)));
		if(%item > 0 && %item.getClassName() $= "ItemData" && %item.uiName !$= "")
		{
			%itemAm = getWord(%items,(%c - getWord(%cells,0))+1);
			%itemSkAm = getWord(%items,(%c - getWord(%cells,0))+2);
			%itemWght = getWord(%items,(%c - getWord(%cells,0))+3);
			
			//Stack Amount
			%w.setText("<just:right><font:Impact:18><color:ffffff> " @ %itemAm @ " <color:999999> " @ %itemSkAm);
			%w.visible = 1;
			
			%len =strLen(%itemAm SPC %itemSkAm);
			%len = (%len * 8) - 4; //8=char size; 4=two spaces between amount and weight symbol
			%x.extent = %len SPC 14;
			%x.position = (60 - %len) SPC 46;
				
			%x.visible = 1;
			if(%item.iconName $= "" || !isFile(%item.iconName))
			{
				%sf = strReplace(%item.shapeFile,"_","/");
				%sf = strReplace(%item.shapeFile,"/"," ");
				%sf = getWord(%sf,2);
				%sf = "add-ons/print_letters_default/prints/" @ getSubStr(%sf,0,1) @ ".png";
				
				if(!isFile(%sf))
					%sf = "add-ons/print_letters_default/prints/-qmark.png";
				%t.setBitmap(%sf);
			}
			else
				%t.setBitmap(%item.IconName);
			%t.storedItem = %item;
			%t.storedWeight = %itemWght;

			if(%item.doColorShift == 1)
			{
				%csc = %item.colorShiftColor;
				%t.mColor = mFloatLength((getWord(%csc,0) * 255),0)
						SPC mFloatLength((getWord(%csc,1) * 255),0)
						SPC mFloatLength((getWord(%csc,2) * 255),0)
						SPC mFloatLength((getWord(%csc,3) * 255),0);
			}
			else
				%t.mColor = "255 255 255 255";
		}
		else
		{
			%t.setBitmap("\"\"");
			%t.storedItem = "";
			%t.storedWeight = "";
			%t.mColor = "255 255 255 255";
			%w.visible = 0;
			%x.visible = 0;
		}
	}
}

////////////////////////////////////
//LOAD LIST OF PLAYER SAVES INTO GUI
////////////////////////////////////
function ClientCmdISLoadInfo(%range,%load,%quota,%delSave,%bkpkSaves)
{
	//If loading saves
	if(%delSave $= "")
	{
		%load = getWords(%load,1,getWordCount(%load));
		if(ItemStorWndw.host == 1)
		{
			if(%bkpkSaves != 1) //if(DDMFol.getValue() !$= "BackPacks") //
			{
				for(%c=getWord(%range,0)/6; %c<getWord(%range,1)/6 && %c<50; %c++)
				{
					if(%c == 0)
						ISSavesTxtList.clear();
						
					%brName = getWord(%load,(%c*6)-(getWord(%range,0)));
					%itemCount = getWord(%load,(%c*6)-(getWord(%range,0))+1);
					%brSize = getWord(%load,(%c*6)-(getWord(%range,0))+2);
					if(%brSize != 4)
					{
						if(%brSize != 9)
						{
							if(%brSize != 16)
							{
								if(%brSize == 32)
									%brSize = "XLarge";
							}
							else
								%brSize = "Large";
						}
						else
							%brSize = "Medium";
					}
					else
						%brSize = "Small";
					%access = getWord("Private Public Admin SAdmin",getWord(%load,(%c*6)-(getWord(%range,0))+3));
					%rAccess = getWord("Off On",getWord(%load,(%c*6)-(getWord(%range,0))+4));
					%ownerID = getWord(%load,(%c*6)-(getWord(%range,0))+5);
					
					%line = %c+1 TAB %brName TAB %itemCount TAB %brSize TAB %access TAB %rAccess TAB %ownerID;
					ISSavesTxtList.addRow(%c,%line);
				}
			}
			else
			{
				for(%c=getWord(%range,0)/3; %c<getWord(%range,1)/3 && %c<50; %c++)
				{
					if(%c == 0)
						ISSavesTxtList.clear();
						
					%ownerName = getWord(%load,(%c*3)-(getWord(%range,0)));
					%itemCount = getWord(%load,(%c*3)-(getWord(%range,0))+1);
					%ownerID = getWord(%load,(%c*3)-(getWord(%range,0))+2);
					
					%line = %c+1 TAB %ownerName TAB %itemCount TAB "" TAB "" TAB "" TAB %ownerID;
					ISSavesTxtList.addRow(%c,%line);
				}
			}
		}
		
		//////////////////////////////////////////////////
		
		else
		{
			ISQuota.setText("<font:Impact:16><just:right><color:ffffff>Max player quota:<font:impact:24> " @ %quota);
			
			for(%c=getWord(%range,0)/6; %c<getWord(%range,1)/6 && %c<50; %c++)
			{
				if(%c == 0)
					ISSavesTxtListC.clear();
					
				%brName = getWord(%load,(%c*6)-(getWord(%range,0)/6));
				%itemCount = getWord(%load,(%c*6)-(getWord(%range,0)/6)+1);
				%brSize = getWord(%load,(%c*6)-(getWord(%range,0)/6)+2);
				if(%brSize != 4)
				{
					if(%brSize != 9)
					{
						if(%brSize != 16)
						{
							if(%brSize == 32)
								%brSize = "XLarge";
						}
						else
							%brSize = "Large";
					}
					else
						%brSize = "Medium";
				}
				else
					%brSize = "Small";
				%access = getWord("Private Public Admin SAdmin",getWord(%load,(%c*6)+3));
				%rAccess = getWord("Off On",getWord(%load,(%c*6)+4));
				
				%line = %c+1 TAB %brName TAB %itemCount TAB %brSize TAB %access TAB %rAccess;
				ISSavesTxtListC.addRow(%c,%line);
			}
		}
	}
		
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	//If removing a save from list after it's been deleted from server
	else
	{
		if(ItemStorWndw.host == 1)
			%list = "ISSavesTxtList";
		else
			%list = "ISSavesTxtListC";
		
		%del = 0;
		%count = 0;
		
		if(DDMFol.getValue() !$= "BackPacks")
		{
			for(%c=0; %c<%list.rowCount() && %c<50; %c++)
			{
				%row = %list.getRowText(%c);
				if(getWord(%row,1) !$= %delSave)
				{
					%rowArr[%count] = %count+1 TAB getWords(%row,1,7);
					%count++;
				}
				else
					%del = 1;
			}
		}
		else
		{
			for(%c=0; %c<%list.rowCount() && %c<50; %c++)
			{
				%row = %list.getRowText(%c);
				if(getWord(%row,6) !$= %delSave)
				{
					%rowArr[%count] = %count+1 TAB getWords(%row,1,7);
					%count++;
				}
				else
					%del = 1;
			}
		}
		if(%del)
		{
			%list.clear();
			for(%c=0; %c<%count && %c<50; %c++)
				%list.setRowByID(%c,%rowArr[%c]);
				
			ClientCmdISMsgBox("Save Deleted","approved","Inventory save have been successfully removed; " @
				"your saves list has been updated.",0,"");
		}
		else
			ClientCmdISMsgBox("Save Not Found","denied","Save not found in list; save status unknown.",0,"");
	}
}

/////////////////////////////////////////////////////////////
//DETERMINE WHICH SAVES GUI TO LAUNCH FOR CLIENT; CALLED ONCE
/////////////////////////////////////////////////////////////
function ClientCmdISPushSavesGUI(%host,%local,%open)
{
	ItemStorWndw.host = %host;
	
	if(%host == 1)
	{
		exec("add-ons/System_ItemStorage/GUIs/ISSavesGUI_Host.gui");
		exec("add-ons/System_ItemStorage/GUIs/ISItemsGUI.gui");
		ISLoadItemSettings(%local);
		ISLoadGUISettings();
		canvas.pushDialog(ISSavesGUI_Host);
	}
	else
	{
		exec("add-ons/System_ItemStorage/GUIs/ISSavesGUI_Client.gui");
		canvas.pushDialog(ISSavesGUI_Client);
	}
}

//////////////////////////////////////////////////
//CLEAR GUI METHOD ON DISCONNECT TO PREVENT ISSUES
//////////////////////////////////////////////////
package ISAddOn_CLPackage
{
	function disconnect(%bool)
	{
		parent::disconnect(%bool);
		ItemStorWndw.host = "";
	}
};
activatePackage(ISAddOn_CLPackage);
