//Brick and backpack inventory saves are located in "Config/Server/ItemStorage" (folder and save files are created automatically)
//Event documentation and examples can be found on my Item Storage forum topics.

//////////////////////////////////////////////////
//Methods and Global Vars Reference

//%cl.ISclInfo = (0)has backpack, (1)avatar pack type, (2)has add-on/is up-to-date; 
//               (3)current weight, (4)max weight, (5)weight symbol;
//               (6)brick accessed, (7)current cell, (8)previous cell, (9)amount transferred, (10)noSwap; (7-10 for IS_UndoTransfer event; 6 for ISRefresh function)

//%cl.ISitemInfo
//%cl.brInv
//%cl.bkpkInv
//%cl.plyrInv
//%brick.ISaccessAmB, %brick.ISaccessTmB
//%cl.ISaccessAm, %cl.ISaccessTmI, %cl.ISaccessTmF

//$ItemListString
//$ItemSetArray[%itemID] = stacklimit, weight
//$HstSetString = INTRO>> (0)Settings have loaded?, (1)Open manual at startup (no longer used),
//                BKPK>> (2)enable, (3)require item, (4)enable encumbrance, (5)clear inv on death, (6)clear inv on respawn; 
//                QUOTAS>> (7)player, (8)file;
//                EVENT-SPAM>> (9)stop routine, (10)clear if continues;
//                SERVERCMD-SPAM>> (11)none, (12)notify, (13)kick, (14)ban, (15)ban-lenght;
//                MISC.>> (16)backup saves, (17)non-restricted events, (18)max weight-amount, (19)weight-symbol

//////////////////////////////////////////////////
//Register Output Events

registerOutputEvent("fxDTSBrick","IS_StoreItems","list Small 0 Medium 1 Large 2 X-Large 3",1);
registerOutputEvent("fxDTSBrick","IS_SetInv","string 5 34" TAB "datablock ItemData" TAB "bool 0" TAB "int 0 999 1",1);
registerOutputEvent("fxDTSBrick","IS_AddItem","list BrickInv 0 BackpackInv 1" TAB "datablock ItemData" TAB "bool 0" TAB "string 6 42",1);
registerOutputEvent("fxDTSBrick","IS_ClearItem","list BrickInv 0 BackpackInv 1" TAB "datablock ItemData" TAB "bool 0" TAB "int 0 32 1",1);
registerOutputEvent("fxDTSBrick","IS_TransferItem","list Brick_to_Player 0 Player_to_Brick 1 Brick_to_Backpack 2 Backpack_to_Brick 3" TAB "datablock ItemData" TAB "bool 0" TAB "int -1 999 1",1); 
registerOutputEvent("fxDTSBrick","IS_CopyInv","list From 0 To 1" TAB "string 30 150",1);
registerOutputEvent("fxDTSBrick","IS_ifItemPresent","list PlayerInv 0 BrickInv 1 BackpackInv 2" TAB "datablock ItemData" TAB "bool 0" TAB "string 200 90",1);
registerOutputEvent("fxDTSBrick","IS_ifInvSameAs","list MatchPos 0 MatchStacks 1 MatchPos&Stacks 2 MatchItemsOnly 3" TAB "bool 0" TAB "string 30 150" TAB "string 200 90",1); //"string 30 185"
registerOutputEvent("fxDTSBrick","IS_ifTransferred","list FirstSelected 0 LastSelected 1 AddedToBrick 2 RemovedFromBrick 3" TAB "datablock ItemData" TAB "bool 0" TAB "string 200 90",1);
registerOutputEvent("fxDTSBrick","IS_UndoTransfer","",1);
registerOutputEvent("fxDTSBrick","IS_VCESetBrName","string 30 150",1);
registerOutputEvent("fxDTSBrick","IS_ifItemInCells","list PlayerInv 0 BrickInv 1 BackpackInv 2" TAB "datablock ItemData" TAB "string 9 56" TAB "string 200 90",1);

//////////////////////////////////////////////////
//Register Input Events

registerInputEvent("fxDTSBrick","onISGUIOpened","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onISGUIClosed","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onISGUIAddItem","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onISGUIMoveItem","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onISGUIDropItem","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onISGUISwapItems","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onISGUIClosedAll","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onISGUIRemoveItem","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onISEventTransfer","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onISConditionTrue","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick","onISConditionFalse","Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");

//////////////////////////////////////////////////
//Execute Server Files

exec("add-ons/System_ItemStorage/Scripts/Filters.cs");
exec("add-ons/System_ItemStorage/Scripts/SaveLoadFuncs.cs");
exec("add-ons/System_ItemStorage/Scripts/EventFuncs.cs");
exec("add-ons/System_ItemStorage/BackPack/BackpackItem.cs");
$ItemSetArray[0] = "0 0";
$HstSetString = setWord($HstSetString,0,0);

////////////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////
//SHOW A PLAYER'S ENCUMBRANFCE IN CHAT
//////////////////////////////////////
function ServerCmdISShowEnc(%cl)
{
	if(ISSpamCheck(%cl,10,500,7000,5))
		return;
	if(!isObject(%cl.player))
	{
		commandtoClient(%cl,'messageboxOK',"No Player","Please wait until you spawn.");
		return;
	}
	
	//////////////////////////////////////////////////
	
	if(getWord($HstSetString,4))
	{
		%currWght = getWord(%cl.ISclInfo,3);
		if(getWord($HstSetString,4) && %currWght $= "")
		{
			ISEncumbrance(%cl,"",getWord($HstSetString,18));
			%currWght = getWord(%cl.ISclInfo,3);
		}
		if(%cl.bkpkInv !$= "")
			%bkpkItms = getWords(%cl.bkpkInv,3,62);
		else
		{
			%loadBp = ISLoadItems(%cl,%cl.bl_id,"BackPacks");
			%bkpkItms = getWords(%loadBp,2,61);
			
			if(getWord($HstSetString,4))
				%cl.ISclInfo = setWord(%cl.ISclInfo,3,%currWght);
		}
		
		if(%currWght > 99999)
			%currWght = "99999+";
		%enc = "\c6Encumbrance: \c0" @ %currWght @ " of " @ getWord($HstSetString,18) SPC getWord($HstSetString,19);
	}
	else
		%enc = "\c6Encumbrance: \c0Disabled";
		
	messageClient(%cl,"",%enc);
}

////////////////////////////////////////////////
//DISPLAY INFO ON AUX BACKPACK FUNCTIONS IN CHAT
////////////////////////////////////////////////
function ServerCmdISHelp(%cl)
{
	if(ISSpamCheck(%cl,10,500,7000,5))
		return;
	if(!isObject(%cl.player))
	{
		commandtoClient(%cl,'messageboxOK',"No Player","Please wait until you spawn.");
		return;
	}
	
	//////////////////////////////////////////////////
	
	messageClient(%cl,"","<font:calibri:19>\c6Item Storage ServerCmd Help for Backpack:");
	messageClient(%cl,"","<font:calibri:19>\c6[1] \c0Type \c6/ISShowBp\c0 to show a text version of your backpack, and \c6/ISShowEnc\c0 to show your encumbrance.");
	messageClient(%cl,"","<font:calibri:19>\c6[2] \c0Use \c6/ISTrans InvA CellA InvB CellB Amount\c0 to swap items between your backpack and tools menu (InvA should be Backpack or Player, InvB should be Backpack Player or Drop (for dropping items)).");
	messageClient(%cl,"","<font:calibri:19>\c6[3] \c0Amount is the amount of items you want to transfer; however, setting it to -1 transfers an entire stack, and -2 is for auto-stacking (invA and invB must both be Backpack for auto-stacking)");
}

////////////////////////////////////
//SHOW TEXT-BASED BACKPACK INVENTORY
////////////////////////////////////
function ServerCmdISShowBp(%cl)
{
	if(ISSpamCheck(%cl,10,500,7000,5))
		return;
	if(!isObject(%cl.player))
	{
		commandtoClient(%cl,'messageboxOK',"No Player","Please wait until you spawn.");
		return;
	}
	
	//////////////////////////////////////////////////
	
	if(getWord($HstSetString,2) != 1)
	{
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"Backpack Disabled","Backpack storage/usage has been disabled by the server host.");
		else
			commandtoClient(%cl,'ISMsgBox',"Backpack Disabled","error","Backpack storage/usage has been disabled by the server host.",0,"");
		return;
	}
	else if(getWord(%cl.ISclInfo,0) != 1 && getWord($HstSetString,3))
	{
		if(getWord(%cl.ISclInfo,2) != 4)
			commandtoClient(%cl,'messageboxOK',"No Backpack","Backpack item required in order to access its inventory.");
		else
			commandtoClient(%cl,'ISMsgBox',"No Backpack","error","Backpack item required in order to access its inventory.",0,"");
		return;
	}

	//////////////////////////////////////////////////

	if(getWord($HstSetString,4))
	{
		%currWght = getWord(%cl.ISclInfo,3);

		if(getWord($HstSetString,4) && %currWght $= "")
		{
			ISEncumbrance(%cl,"",getWord($HstSetString,18));
			%currWght = getWord(%cl.ISclInfo,3);
		}
		
		if(%currWght > 99999)
			%currWght = "99999+";
		%enc = "   (Encumbrance: " @ %currWght @ " of " @ getWord($HstSetString,18) SPC getWord($HstSetString,19) @ ")";
	}
	else
		%enc = "   (Encumbrance: Disabled)";

	if(%cl.bkpkInv !$= "")
		%bkpkItms = getWords(%cl.bkpkInv,3,62);
	else
	{
		%loadBp = ISLoadItems(%cl,%cl.bl_id,"BackPacks");
		%bkpkItms = getWords(%loadBp,2,61);
		
		if(getWord($HstSetString,4))
			%cl.ISclInfo = setWord(%cl.ISclInfo,3,%currWght);
	}
	
	//////////////////////////////////////////////////
	
	for(%c=0; %c<15; %c++)
	{
		%item = getWord(%bkpkItms,%c*4);
		if(%item > 0)
			%invStr = %invStr @ "  [" @ %c @ "]" @ strReplace(%item.uiName," ","") @ ":" @ getWord(%bkpkItms,(%c*4)+1) @ "/" @ getWord($ItemSetArray[%item],0);
		else
			%invStr = %invStr @ "  [" @ %c @ "]X";
	}
	commandtoClient(%cl,'messageboxOK',"Backpack" @ %enc,%invStr);
}

///////////////////////////////////////////////////////////////////////
//SERVER COMMAND FOR TRANSFERRING ITEMS BETWEEN BACKPACK AND PLAYER INV
///////////////////////////////////////////////////////////////////////
function ServerCmdISTrans(%cl,%invA,%cellA,%invB,%cellB,%sendAm)
{
	if(ISSpamCheck(%cl,10,500,7000,5))
		return;
	if(!isObject(%cl.player))
	{
		commandtoClient(%cl,'messageboxOK',"No Player","Please wait until you spawn.");
		return;
	}
	
	//////////////////////////////////////////////////
	
	if(%invA $= "Player")
		%prevCell = "plStor" @ %cellA;
	else if(%invA $= "Backpack")
		%prevCell = "bpStor" @ %cellA;
	else
	{
		commandtoClient(%cl,'messageboxOK',"Error","Invalid inventory.");
		return;
	}
		
	if(%invB $= "Player")
		%currCell = "plStor" @ %cellB;
	else if(%invB $= "Backpack")
		%currCell = "bpStor" @ %cellB;
	else if(%invB $= "Drop")
	{
		%currCell = "";
		%sendAm = -3;
	}
	else
	{
		commandtoClient(%cl,'messageboxOK',"Error","Invalid inventory.");
		return;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if(%invA $= "Player" || %invB $= "Player")
	{
		%mxTls = %cl.player.getDatablock().maxTools;
		%cl.plyrInv = setWord(%cl.plyrInv,0,%mxTls);
		
		for(%c=0; %c<%mxTls && %c<10; %c++)
		{
			%item = %cl.player.tool[%c];
			%plyrItms = setWord(%plyrItms,(%c*4),%item);
			
			if(%item > 0)
			{
				%currWght += getWord($ItemSetArray[%item],1);

				%plyrItms = setWord(%plyrItms,(%c*4)+1,1);
				%plyrItms = setWord(%plyrItms,(%c*4)+2,getWord($ItemSetArray[%item],0));
				%plyrItms = setWord(%plyrItms,(%c*4)+3,getWord($ItemSetArray[%item],1));
			}
			else
			{
				%plyrItms = setWord(%plyrItms,(%c*4)+1,0);
				%plyrItms = setWord(%plyrItms,(%c*4)+2,0);
				%plyrItms = setWord(%plyrItms,(%c*4)+3,0);
			}
		}
		
		%cl.plyrInv = %mxTls SPC %plyrItms;
		%delPlVar = 1;
	}
	
	//////////////////////////////////////////////////
	
	if(%invA $= "Backpack" || %invB $= "Backpack")
	{
		if(%cl.bkpkInv $= "")
		{
			%loadBp = ISLoadItems(%cl,%cl.bl_id,"BackPacks");
			
			if(%currWght < 1)
			{
				%mxTls = %cl.player.getDatablock().maxTools;
				for(%c=0; %c<%mxTls && %c<10; %c++)
				{
					%item = %cl.player.tool[%c];
					if(%item > 0)
						%currWght += getWord($ItemSetArray[%item],1);
				}
			}
			%cl.ISclInfo = setWord(%cl.ISclInfo,3,getWord(%cl.ISclInfo,3) + %currWght);
			
			if(%loadBp == 0)
				%cl.bkpkInv = 0 SPC %loadBp;
			else
				%cl.bkpkInv = 1 SPC %loadBp;
			
			%delBpVar = 1;
		}
	}

	////////////////////////////////////////////////////////////////////////////////////////////////////

	ServerCmdISRefresh(%cl,%currCell,%prevCell,0,%sendAm);
	schedule(500,0,"ServerCmdISShowBp",%cl);

	if(%delPlVar)
		%cl.plyrInv = "";
	if(%delBpVar)
		%cl.bkpkInv = "";
}

//////////////////////////////////////////////////////////////////////////
//IF PLAYER HAS THE ADD-ON (AND IT'S LATEST VERSION), UPDATE PLAYER METHOD
//////////////////////////////////////////////////////////////////////////
function ServerCmdISHasAddOnRelay(%cl,%ver)
{
	if(ISSpamCheck(%cl,7,1000,7000,5))
		return;
	if(!isObject(%cl.player))
	{
		commandtoClient(%cl,'messageboxOK',"No Player","Please wait until you spawn.");
		return;
	}
	if(%ver == 0)
		%ver = 1;
		
	%cl.ISclInfo = setWord(%cl.ISclInfo,2,%ver);
}

/////////////////////
//RESAVE DELETED SAVE
/////////////////////
function ServerCmdISReSave(%cl)
{
	if(ISSpamCheck(%cl,8,2000,12000,5))
		return;
	if(!isObject(%cl.player))
	{
		commandtoClient(%cl,'messageboxOK',"No Player","Please wait until you spawn.");
		return;
	}
	if(getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	//////////////////////////////////////////////////
	
	%brick = getWord(%cl.ISclInfo,6);
	
	if(getWord(%cl.brInv,0) > 0 && isObject(%brick) && %brick.getClassName() $= "fxDTSBrick")
	{
		%brName = getWord(%cl.brInv,8);
		%name = getWord(%cl.brInv,1);
		%storType = getWord(%cl.brInv,2);
		%brItms = getWords(%cl.brInv,11,138);
		%access = getWord(%cl.brInv,3);
		%srcBrick = %brick;
		%rmtAcc = getWord(%cl.brInv,5);
		
		//////////////////////////////////////////////////
		
		if(ISNameValid(%cl,%brName))
			return;
			
		%name = ISGetFile(%cl,%brName);
		if(%name $= "0")
			return;
			
		%load = ISLoadItems(%cl,%brName,%name);
		%saveOwnerID = getWord(%load,4);
		%saveOwnerName = getWord(%load,5);
		
		//////////////////////////////////////////////////
		
		if(%saveOwnerID $= "")
		{	
			if(ISSaveItems(%cl,%brName,%name,%storType,%brItms,%access,%srcBrick) == 1)
				return;
			
			%clTempName = getSubStr(strReplace(%cl.name," ","_"),0,30);
			%cl.brInv = setWord(%cl.brInv,6,%cl.bl_id);
			%cl.brInv = setWord(%cl.brInv,9,%cl.bl_id);
			%cl.brInv = setWord(%cl.brInv,7,%clTempName);
			%cl.brInv = setWord(%cl.brInv,10,%clTempName);
			%cl.brInv = setWord(%cl.brInv,4,%brick);
			
			ServerCmdISRefreshInfo(%cl,-1,-1,-1,%cl.bl_id,%clTempName); //Updates everyone else's GUI
		}
		else if(%saveOwnerID == %cl.bl_id)
			commandToClient(%cl,'ISMsgBox',"Error","error","You already own this inventory save.",0,"");
		else
			commandToClient(%cl,'ISMsgBox',"Error","error",%saveOwnerName @ " already owns this inventory save.",0,"");
	}
	else
		commandToClient(%cl,'ISMsgBox',"Error","denied","Past save information not detected or invalid.",0,"");
}

////////////////////////////////////
//LOAD BACKPACK INVENTORY FOR PLAYER
////////////////////////////////////
function ServerCmdISPopulateBkPkGUI(%cl,%justBackpack)
{
	if(ISSpamCheck(%cl,1,2000,12000,5))
		return;
	if(!isObject(%cl.player))
	{
		commandtoClient(%cl,'messageboxOK',"No Player","Please wait until you spawn.");
		return;
	}
	if(getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	if(getWord($HstSetString,2) == 0)
	{
		commandToClient(%cl,'ISMsgBox',"Backpack Disabled","locked","Backpack storage has been disabled by the server host.",0,"");
		return;
	}
	if(getWord($HstSetString,3))
	{
		//If requesting backpack inv, but method says it's not present, search player inv just encase
		%pl = %cl.player;
		%bkpkID = ISBackPackItem.getID();
		for(%c = 0; %c < %pl.getDatablock().maxTools; %c++)
		{
			%tool = %pl.tool[%c];
			if(%tool == %bkpkID)
			{
				%found = 1;
				%slot = %c;
				break;
			}
		}
		
		//If backpack found in player inv, update method; else, send error message
		if(%found == 1)
			%client.ISclInfo = setWord(%client.ISclInfo,0,1);
		else
		{
			%client.ISclInfo = setWord(%client.ISclInfo,0,0);
			commandToClient(%cl,'ISMsgBox',"Backpack Required","error","Backpack item required in order to use the backpack inventory.",0,"");
			return;
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if(getWord(%cl.ISclInfo,0) && %cl.player.getMountedImage(0) != ISBackPackAImage.getID())
	{
		%cl.player.currTool = %slot;
		%cl.player.playThread(0,"armReadyBoth");
		%cl.player.unMountImage(2);
		%cl.player.mountImage(ISBackPackAImage,0);
		if(getWord(%cl.ISclInfo,1) !$= "")
			%cl.player.unHideNode(getWord(%cl.ISclInfo,1));
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	%loadBP = ISLoadItems(%cl,%cl.bl_id,"BackPacks");
	if(%loadBP == 0)
		%cl.bkpkInv = 0 SPC %loadBp;
	else
		%cl.bkpkInv = 1 SPC %loadBp;
	
	if(%justBackpack != 1)
	{
		%mxTls = %cl.player.getDataBlock().maxTools;
		for(%c = 0; %c < %mxTls; %c++)
		{
			%tool = %cl.player.tool[%c];
			%plyrItms = setWord(%plyrItms,(%c*4),%tool);
			
			if(%tool > 0)
			{
				%plyrItms = setWord(%plyrItms,(%c*4)+1,1);
				%plyrItms = setWord(%plyrItms,(%c*4)+2,getWord($ItemSetArray[%tool],0));
				%plyrItms = setWord(%plyrItms,(%c*4)+3,getWord($ItemSetArray[%tool],1));
			}
			else
			{
				%plyrItms = setWord(%plyrItms,(%c*4)+1,0);
				%plyrItms = setWord(%plyrItms,(%c*4)+2,0);
				%plyrItms = setWord(%plyrItms,(%c*4)+3,0);
			}
		}
		%cl.plyrInv = %mxTls SPC %plyrItms;
	}
	else
		%plyrItms = -1;
		
	ISEncumbrance(%cl,"",getWord($HstSetString,18));
	%miscInfo = setWord(%miscInfo,2,getWord($HstSetString,4)); //%encEnbl
	%miscInfo = setWord(%miscInfo,3,getWord(%cl.ISclInfo,3)); //%currWght
	%miscInfo = setWord(%miscInfo,4,getWord($HstSetString,18)); //%maxWght
	%miscInfo = setWord(%miscInfo,5,getWord($HstSetString,19)); //%wghtSmbl

	commandToClient(%cl,'ISPopulateGUI',-1,%plyrItms,%loadBp,%mxTls,0,%miscInfo,0,0,0,0);
}

/////////////////////////////////////////////
//WHEN A CELL(S) FROM THE MAIN GUI IS UPDATED
/////////////////////////////////////////////
function ServerCmdISRefresh(%cl,%currCell,%prevCell,%execEvents,%sendAm)
{
	if(%execEvents != 1)
	{
		if(ISSpamCheck(%cl,0,33,9000,7)) //avoid auto-failing spam filter when using IS_UndoTransfer
			return;
	}
	else if(ISSpamCheck(%cl,0,500,9000,7))
		return;
	if(!isObject(%cl.player))
	{
		commandtoClient(%cl,'messageboxOK',"No Player","Please wait until you spawn.");
		return;
	}
	if(getWord($HstSetString,17) != 1 && getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	//////////////////////////////////////////////////
	
	%prevCellStr = getSubStr(%prevCell,0,6);
	%currCellStr = getSubStr(%currCell,0,6);
	%prevCellNum = getSubStr(%prevCell,6,2);
	%currCellNum = getSubStr(%currCell,6,2);

	if(%sendAm == 0) //%sendAm of 0 = cancel swap, -1 = entire stack and -2 = autostack
		return;
		
	%brick = getWord(%cl.ISclInfo,6);	
	%tempMethodBk = %cl.bkpkInv;
	%tempMethodBr = %cl.brInv;
	%tempMethodPl = %cl.plyrInv;
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Cell behavior
	
	if(%currCellStr !$= "bpStor")
	{		
		if(%currCellStr !$= "brStor")
		{
			if(%currCellStr !$= "plStor")
			{
				///////////////////////////////////////////////////////////////////////////////////////////////////
				//If dropping item from backpack

				if(%currCell $= "")
				{
					if(getWord($HstSetString,2))
					{
						if(%prevCellNum >= 15 || %prevCellNum < 0)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Previous cell is out of range; cell should be >= 0 and < 15.");
							else
								commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Previous cell is out of range; cell should be >= 0 and < 15.",0,"");
							return;
						}
						if(%prevCellStr !$= "bpStor")
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Cell Doesn't Exist","Previous cell doesn't exist.");
							else
								commandToClient(%cl,'ISMsgBox',"Cell Doesn't Exist","denied","Previous cell doesn't exist.",0,"");
							return;
						}
						
						//////////////////////////////////////////////////
						
						%item = getWord(%cl.bkpkInv,3+(%prevCellNum*4));
						%itemAm = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1);
						
						if(%item == 0 || !isObject(%item))
							return;
						
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4),0);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+1,0);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+2,0);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+3,0);
						
						%bkpkItms = getWords(%cl.bkpkInv,3,62);
						
						//////////////////////////////////////////////////
						
						if(getWord(%cl.bkpkInv,0) != 0)
						{
							if(ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,%bkpkItms,0,0) == 1)
							{
								%cl.bkpkInv = %tempMethodBk;
								return;
							}
						}
						else if(ISSaveItems(%cl,%cl.bl_id,"BackPacks",0,%bkpkItms,0) == 1)
						{
							%cl.bkpkInv = %tempMethodBk;
							return;
						}

						commandtoClient(%cl,'ISRefreshGUI',"",0,0,0,0,%prevCell,0,0,0,0);
						ISEncumbrance(%cl,"",getWord($HstSetString,18));

						//////////////////////////////////////////////////
						
						%droppedItem = new Item()
						{
							datablock = %item.getName();
							position = vectorAdd(vectorScale(%cl.player.getForwardVector(),2),%cl.player.getHackPosition());
							static = 0;
						};
						%droppedItem.setVelocity(getWord(%cl.player.getMuzzleVector(0),0)*15 SPC 
												 getWord(%cl.player.getMuzzleVector(0),1)*15 SPC
												 getWord(%cl.player.getMuzzleVector(0),2)*15);
						%droppedItem.ISstackAm = %itemAm;
						%droppedItem.setShapeName(%itemAm);
						%droppedItem.schedule(5000,"fadeOut");
						%droppedItem.schedule(7000,delete);
						%droppedItem.canPickUp = true;
						MissionCleanup.add(%droppedItem);
					}
					else
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Backpack Disabled","Backpack storage has been disabled by the server host.");
						else
							commandToClient(%cl,'ISMsgBox',"Backpack Disabled","locked","Backpack storage has been disabled by the server host.",0,"");
					}
					
					%cl.ISitemInfo = "";
					if(isObject(%brick) && %brick.getClassName() $= "fxDTSBrick")
					{
						%cl.ISclInfo = setWord(%cl.ISclInfo,7,%prevCell);
						%cl.ISclInfo = setWord(%cl.ISclInfo,8,%prevCell);
						%cl.ISclInfo = setWord(%cl.ISclInfo,9,%itemAam);
			
						fxDTSBrick::onISEventInput(%brick,%cl,10);
					}
					return;
				}
			}
			
			///////////////////////////////////////////////////////////////////////////////////////////////////
			//Player Inv
			
			else
			{
				if(%prevCellStr !$= "bpStor")
				{
					if(%prevCellStr !$= "brStor")
					{
						////////////////////////////////////////////////////////////////////////////////////////////////////
						//Player Inv -> Player Inv
						
						if(%prevCellStr $= "plStor")
						{
							%mxTls = %cl.player.getDatablock().maxTools;

							if(%prevCellNum >= %mxTls || %prevCellNum < 0)
							{
								if(getWord(%cl.ISclInfo,2) != 4)
									commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Previous cell is out of range; cell should be >= 0 and < your max number of tool slots.");
								else
									commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Previous cell is out of range; cell should be >= 0 and < your max number of tool slots.",0,"");
								return;
							}
							if(%currCellNum >= %mxTls || %currCellNum < 0)
							{
								if(getWord(%cl.ISclInfo,2) != 4)
									commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Current cell is out of range; cell should be >= 0 and < your max number of tool slots.");
								else
									commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Current cell is out of range; cell should be >= 0 and < your max number of tool slots.",0,"");
								return;
							}
						
							//////////////////////////////////////////////////
							
							%itemA = getWord(%cl.plyrInv,1+(%prevCellNum*4));
							%itemB = getWord(%cl.plyrInv,1+(%currCellNum*4));
							
							%itemAam = getWord(%cl.plyrInv,1+(%prevCellNum*4)+1);
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
							%itemAWght = getWord($ItemSetArray[%itemA],1);
							
							%itemBam = getWord(%cl.plyrInv,1+(%currCellNum*4)+1);
							%itemBSkAm = getWord($ItemSetArray[%itemB],0);
							%itemBWght = getWord($ItemSetArray[%itemB],1);
							
							if(%itemA == 0)
								%itemAname = "Nothing";
							else
								%itemAname = strReplace(%itemA.uiName," ","");
							if(%itemB == 0)
								%itemBname = "Nothing";
							else
								%itemBname = strReplace(%itemB.uiName," ","");
								
							%itemAvce = %itemAname SPC %itemAam SPC %itemASkAm SPC %itemAWght;
							%itemBvce = %itemBname SPC %itemBam SPC %itemBSkAm SPC %itemBWght;
							
							//////////////////////////////////////////////////
												
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4),%itemB);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+1,%itemBam);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+2,%itemBSkAm);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+3,%itemBWght);

							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4),%itemA);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+1,%itemAam);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+2,%itemASkAm);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+3,%itemAWght);
						
							//////////////////////////////////////////////////
							
							if(isObject(PropaneTankItem))
							{
								%PTIid = PropaneTankItem.getID();
								if(%itemA != %PTIid && %itemB != %PTIid)
								{
									if(%itemA == %cl.player.tool[%cl.player.currTool] || %itemB == %cl.player.tool[%cl.player.currTool])
										%cl.player.unMountImage(0);
								}
							}
							else if(%itemA == %cl.player.tool[%cl.player.currTool] || %itemB == %cl.player.tool[%cl.player.currTool])
								%cl.player.unMountImage(0);
								
							%cl.player.tool[%currCellNum] = %itemA; 
							messageClient(%cl,'MsgItemPickup','',%currCellNum,%itemA);
							%cl.player.tool[%prevCellNum] = %itemB; 
							messageClient(%cl,'MsgItemPickup','',%prevCellNum,%itemB);
							
							commandtoClient(%cl,'ISRefreshGUI',%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght,%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght);
						}
					}
					
					////////////////////////////////////////////////////////////////////////////////////////////////////
					//Brick Inv -> Player Inv
						
					else
					{
						%itemA = getWord(%cl.brInv,11+(%prevCellNum*4));
						%itemB = getWord(%cl.plyrInv,1+(%currCellNum*4));
						%storType = getWord(%cl.brInv,2);
						%bkpkID = ISBackPackItem.getID();
						
						if(%itemA == 0)
							%itemAname = "Nothing";
						else
							%itemAname = strReplace(%itemA.uiName," ","");
						if(%itemB == 0)
							%itemBname = "Nothing";
						else
							%itemBname = strReplace(%itemB.uiName," ","");
								
						%itemAvce = %itemAname SPC getWord(%cl.brInv,11+(%prevCellNum*4)+1) SPC getWord($ItemSetArray[%itemA],0) SPC getWord($ItemSetArray[%itemA],1);
						%itemBvce = %itemBname SPC getWord(%cl.plyrInv,1+(%currCellNum*4)+1) SPC getWord($ItemSetArray[%itemB],0) SPC getWord($ItemSetArray[%itemB],1);
							
						//////////////////////////////////////////////////
						
						%mxTls = %cl.player.getDatablock().maxTools;

						if(%prevCellNum >= %storType || %prevCellNum < 0)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Previous cell is out of range; cell should be >= 0 and < the brick inventory size.");
							else
								commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Previous cell is out of range; cell should be >= 0 and < the brick inventory size.",0,"");
							return;
						}
						if(%currCellNum >= %mxTls || %currCellNum < 0)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Current cell is out of range; cell should be >= 0 and < your max number of tool slots.");
							else
								commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Current cell is out of range; cell should be >= 0 and < your max number of tool slots.",0,"");
							return;
						}
						if(getWord(%cl.brInv,11+(%prevCellNum*4)+1) > 1 && %itemB > 0)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Illegal Move","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.");
							else
								commandToClient(%cl,'ISMsgBox',"Illegal Move","denied","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.",0,"");
							return;
						}
						if(%itemA == %bkpkID && %itemB != %bkpkID)
						{
							for(%c = 0; %c < %cl.player.getDataBlock().maxTools; %c++)
							{
								%tool = %cl.player.tool[%c];
								if(%tool == %bkpkID)
								{
									if(getWord(%cl.ISclInfo,2) != 4)
										commandtoClient(%cl,'messageboxOK',"Backpack Already Present","You already have a backpack in your inventory.");
									else
										commandToClient(%cl,'ISMsgBox',"Backpack Already Present","error","You already have a backpack in your inventory.",0,"");
									return;
								}
							}
						}
					
						//////////////////////////////////////////////////
						//Swapping a single item from brick inv with player inv
						
						if(%itemB > 0) 
						{
							%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1);
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
							%itemBam = getWord(%cl.plyrInv,1+(%currCellNum*4)+1);
							%itemBSkAm = getWord($ItemSetArray[%itemB],0);
						}
						else
						{
							%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1) - 1;
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
							%itemB = %itemA;
							%itemBam = getWord(%cl.plyrInv,1+(%currCellNum*4)+1) + 1;
							%itemBSkAm = getWord($ItemSetArray[%itemB],0);
							%noSwap = 1;
							
							if(%itemAam < 1)
								%itemA = 0;
						}

						//////////////////////////////////////////////////
						
						%itemAWght = getWord($ItemSetArray[%itemA],1);
						%itemBWght = getWord($ItemSetArray[%itemB],1);
							
						if(%noSwap)
						{						
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4),%itemA);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+1,%itemAam);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+2,%itemASkAm);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+3,%itemAWght);

							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4),%itemB);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+1,%itemBam);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+2,%itemBSkAm);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+3,%itemBWght);
							
							%temp = %currCell;
							%currCell = %prevCell;
							%prevCell = %temp;
						}
						else
						{		
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4),%itemB);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+1,%itemBam);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+2,%itemBSkAm);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+3,%itemBWght);

							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4),%itemA);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+1,%itemAam);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+2,%itemASkAm);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+3,%itemAWght);
						}
						%brItms = getWords(%cl.brInv,11,138);
						
						//////////////////////////////////////////////////
						
						%name = getWord(%cl.brInv,1);
						%srcBrick = getWord(%cl.brInv,4);
						%load = getWords(%cl.brInv,2,10);
						%brName = getWord(%cl.brInv,8);
						%access = getWord(%cl.brInv,3);
						%rmtAcc = getWord(%cl.brInv,5);
						
						//////////////////////////////////////////////////
						
						if(getWord(%cl.brInv,0) != 0)
						{
							if(ISNameValid(%cl,%brName) == 1)
							{
								%cl.brInv = %tempMethodBr;
								%cl.plyrInv = %tempMethodPl;
								return;
							}
					
							if(getWord(%cl.brInv,0) != 0)
							{
								if(ISErrorCheck(%cl,%storType,%access,%load SPC %brItms,%brick,%srcBrick,%rmtAcc) == 1)
								{
									%cl.brInv = %tempMethodBr;
									%cl.plyrInv = %tempMethodPl;
									return;
								}
							}
							if(ISOverWriteSave(%cl,%name,%brName,%storType,%brItms,%access,%brick) == 1)
							{
								%cl.brInv = %tempMethodBr;
								%cl.plyrInv = %tempMethodPl;
								return;
							}
						}
						else
						{
							if(ISSaveItems(%cl,%brName,%name,%storType,%brItms,%access,%srcBrick) == 1)
							{
								%cl.brInv = %tempMethodBr;
								%cl.plyrInv = %tempMethodPl;
								return;
							}
							else
								ServerCmdISRefreshInfo(%cl,-1,-1,-1,%cl.bl_id,getSubStr(strReplace(%cl.name," ","_"),0,30));
						}
						
						//////////////////////////////////////////////////
						
						commandtoClient(%cl,'ISRefreshGUI',%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght,%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght);
						for(%c = 0; %c < clientgroup.getCount(); %c++)
						{
							%tempCl = clientgroup.getObject(%c);
							if(getWord(%tempCl.brInv,8) $= %brName && %tempCl != %cl)
							{
								%tempCl.brInv = %cl.brInv;
								commandtoClient(%tempCl,'ISRefreshGUI',%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght,"",0,0,0,0);
							}
						}
						
						//////////////////////////////////////////////////
						
						if(%noSwap)
						{
							%cl.player.tool[%currCellNum] = %itemB; 
							messageClient(%cl,'MsgItemPickup','',%currCellNum,%itemB);
							
							if(%itemB == %bkpkID && getWord($HstSetString,2) == 1)
							{
								%cl.ISclInfo = setWord(%cl.ISclInfo,0,1);
								if(%execEvents == 1)
									commandToClient(%cl,'ISRelayBkPkToggle',2);
							}
						}
						else
						{
							if(isObject(PropaneTankItem))
							{
								%PTIid = PropaneTankItem.getID();
								if(%itemA != %PTIid && %itemB != %PTIid)
								{
									if(%itemB == %cl.player.tool[%cl.player.currTool])
										%cl.player.unMountImage(0);
								}
							}
							else if(%itemB == %cl.player.tool[%cl.player.currTool])
								%cl.player.unMountImage(0);
								
							%cl.player.tool[%currCellNum] = %itemA; 
							messageClient(%cl,'MsgItemPickup','',%currCellNum,%itemA);
							
							if(%itemA != %itemB)
							{
								if(%itemB == %bkpkID)
								{
									%cl.ISclInfo = setWord(%cl.ISclInfo,0,0);
									
									if(getWord($HstSetString,3))
										commandToClient(%cl,'ISRelayBkPkToggle',3);
									
									if(%cl.player.getMountedImage(2) == ISBackPackBImage.getID())
									{
										%cl.player.unMountImage(2);
										
										if(getWord(%cl.ISclInfo,1) !$= "")
											%cl.player.unHideNode(getWord(%cl.ISclInfo,1));
									}
									else if(%cl.player.getMountedImage(0) == ISBackPackAImage.getID())
										%cl.player.unMountImage(0);
								}
								else if(%itemA == %bkpkID && getWord($HstSetString,2) == 1)
								{
									%cl.ISclInfo = setWord(%cl.ISclInfo,0,1);
									if(%execEvents == 1)
										commandToClient(%cl,'ISRelayBkPkToggle',2);
								}
							}
						}
						%img = %cl.player.getMountedImage(2);
						if(%img > 0)
						{
							%imgFile = getWord(strReplace(%img.shapeFile,"/"," "),1);
							for(%c=0; %c<%cl.player.getDatablock().maxTools && %c<10; %c++)
							{
								%item = %cl.player.tool[%c];
								%imgBFile = getWord(strReplace(%item.shapeFile,"/"," "),1);
								if(%imgFile $= %imgBFile)
								{
									%check = 1;
									break;
								}
							}
							if(%check != 1)
								%cl.player.unMountImage(2);
						}
						ISEncumbrance(%cl,"",getWord($HstSetString,18));
					}
				}
				
				////////////////////////////////////////////////////////////////////////////////////////////////////
				//Backpack Inv -> Player Inv
					
				else
				{
					if(getWord($HstSetString,2) == 1)
					{
						%itemA = getWord(%cl.bkpkInv,3+(%prevCellNum*4));
						%itemB = getWord(%cl.plyrInv,1+(%currCellNum*4));
						%bkpkID = ISBackPackItem.getID();
						
						if(%itemA == 0)
							%itemAname = "Nothing";
						else
							%itemAname = strReplace(%itemA.uiName," ","");
						if(%itemB == 0)
							%itemBname = "Nothing";
						else
							%itemBname = strReplace(%itemB.uiName," ","");
								
						%itemAvce = %itemAname SPC getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1) SPC getWord($ItemSetArray[%itemA],0) SPC getWord($ItemSetArray[%itemA],1);
						%itemBvce = %itemBname SPC getWord(%cl.plyrInv,1+(%currCellNum*4)+1) SPC getWord($ItemSetArray[%itemB],0) SPC getWord($ItemSetArray[%itemB],1);
						
						//////////////////////////////////////////////////
						
						%mxTls = %cl.player.getDatablock().maxTools;

						if(%prevCellNum >= 15 || %prevCellNum < 0)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Previous cell is out of range; cell should be >= 0 and < 15.");
							else
								commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Previous cell is out of range; cell should be >= 0 and < 15.",0,"");
							return;
						}
						if(%currCellNum >= %mxTls || %currCellNum < 0)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Current cell is out of range; cell should be >= 0 and < your max number of tool slots.");
							else
								commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Current cell is out of range; cell should be >= 0 and < your max number of tool slots.",0,"");
							return;
						}
						if(getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1) > 1 && %itemB > 0)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Illegal Move","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.");
							else
								commandToClient(%cl,'ISMsgBox',"Illegal Move","denied","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.",0,"");
							return;
						}
						if(%itemB == %bkpkID)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Paradox Averted","You can't put a backpack inside of itself.");
							else
								commandToClient(%cl,'ISMsgBox',"Paradox Averted","paradox","You can't put a backpack inside of itself.",0,"");
							return;
						}
						if(%itemA == %bkpkID)
						{
							for(%c = 0; %c < %cl.player.getDataBlock().maxTools; %c++)
							{
								%tool = %cl.player.tool[%c];
								if(%tool == %bkpkID)
								{
									if(getWord(%cl.ISclInfo,2) != 4)
										commandtoClient(%cl,'messageboxOK',"Backpack Already Present","You already have a backpack in your inventory.");
									else
										commandToClient(%cl,'ISMsgBox',"Backpack Already Present","error","You already have a backpack in your inventory.",0,"");
									return;
								}
							}
						}
					
						//////////////////////////////////////////////////
						//Swapping a single item from brick inv with player inv
						
						if(%itemB > 0)  
						{
							%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1);
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
							%itemBam = getWord(%cl.plyrInv,1+(%currCellNum*4)+1);
							%itemBSkAm = getWord($ItemSetArray[%itemB],0);
						}
						else
						{
							%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1) - 1;
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
							%itemB = %itemA;
							%itemBam = getWord(%cl.plyrInv,1+(%currCellNum*4)+1) + 1;
							%itemBSkAm = getWord($ItemSetArray[%itemB],0);
							%noSwap = 1;
							
							if(%itemAam < 1)
								%itemA = 0;
						}
						
						//////////////////////////////////////////////////
						
						%itemAWght = getWord($ItemSetArray[%itemA],1);
						%itemBWght = getWord($ItemSetArray[%itemB],1);
							
						if(%noSwap)
						{
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4),%itemA);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+1,%itemAam);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+2,%itemASkAm);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+3,%itemAWght);

							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4),%itemB);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+1,%itemBam);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+2,%itemBSkAm);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+3,%itemBWght);
							
							%temp = %currCell;
							%currCell = %prevCell;
							%prevCell = %temp;
						}
						else
						{
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4),%itemB);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+1,%itemBam);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+2,%itemBSkAm);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+3,%itemBWght);

							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4),%itemA);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+1,%itemAam);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+2,%itemASkAm);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%currCellNum*4)+3,%itemAWght);
						}
						%bkpkItms = getWords(%cl.bkpkInv,3,62);
						
						//////////////////////////////////////////////////
						
						if(getWord(%cl.bkpkInv,0) != 0)
						{
							if(ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,%bkpkItms,0,0) == 1)
							{
								%cl.bkpkInv = %tempMethodBk;
								%cl.plyrInv = %tempMethodPl;
								return;
							}
						}
						else if(ISSaveItems(%cl,%cl.bl_id,"BackPacks",0,%bkpkItms,0) == 1)
						{
							%cl.bkpkInv = %tempMethodBk;
							%cl.plyrInv = %tempMethodPl;
							return;
						}
						
						//////////////////////////////////////////////////
						
						commandtoClient(%cl,'ISRefreshGUI',%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght,%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght);
						
						if(%noSwap)
						{
							%cl.player.tool[%currCellNum] = %itemB; 
							messageClient(%cl,'MsgItemPickup','',%currCellNum,%itemB);
						}
						else
						{
							if(isObject(PropaneTankItem))
							{
								%PTIid = PropaneTankItem.getID();
								if(%itemA != %PTIid && %itemB != %PTIid)
								{
									if(%itemB == %cl.player.tool[%cl.player.currTool])
										%cl.player.unMountImage(0);
								}
							}
							else if(%itemB == %cl.player.tool[%cl.player.currTool])
								%cl.player.unMountImage(0);
								
							%cl.player.tool[%currCellNum] = %itemA; 
							messageClient(%cl,'MsgItemPickup','',%currCellNum,%itemA);
						}
						%img = %cl.player.getMountedImage(2);
						if(%img > 0)
						{
							%imgFile = getWord(strReplace(%img.shapeFile,"/"," "),1);
							for(%c=0; %c<%cl.player.getDatablock().maxTools && %c<10; %c++)
							{
								%item = %cl.player.tool[%c];
								%imgBFile = getWord(strReplace(%item.shapeFile,"/"," "),1);
								if(%imgFile $= %imgBFile)
								{
									%check = 1;
									break;
								}
							}
							if(%check != 1)
								%cl.player.unMountImage(2);
						}
					}
					else
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Backpack Disabled","Backpack storage has been disabled by the server host.");
						else
							commandToClient(%cl,'ISMsgBox',"Backpack Disabled","locked","Backpack storage has been disabled by the server host.",0,"");
					}
				}
			}
		}
		
		////////////////////////////////////////////////////////////////////////////////////////////////////
		//Brick Inv
		
		else
		{
			if(%prevCellStr !$= "bpStor")
			{
				if(%prevCellStr !$= "brStor")
				{
					////////////////////////////////////////////////////////////////////////////////////////////////////
					//Player Inv -> Brick Inv
					
					if(%prevCellStr $= "plStor")
					{
						%itemA = getWord(%cl.plyrInv,1+(%prevCellNum*4));
						%itemB = getWord(%cl.brInv,11+(%currCellNum*4));
						%storType = getWord(%cl.brInv,2);
						%bkpkID = ISBackPackItem.getID();
						
						if(%itemA == 0)
							%itemAname = "Nothing";
						else
							%itemAname = strReplace(%itemA.uiName," ","");
						if(%itemB == 0)
							%itemBname = "Nothing";
						else
							%itemBname = strReplace(%itemB.uiName," ","");
								
						%itemAvce = %itemAname SPC getWord(%cl.plyrInv,1+(%prevCellNum*4)+1) SPC getWord($ItemSetArray[%itemA],0) SPC getWord($ItemSetArray[%itemA],1);
						%itemBvce = %itemBname SPC getWord(%cl.brInv,11+(%currCellNum*4)+1) SPC getWord($ItemSetArray[%itemB],0) SPC getWord($ItemSetArray[%itemB],1);
						
						//////////////////////////////////////////////////
						
						%mxTls = %cl.player.getDatablock().maxTools;

						if(%prevCellNum >= %mxTls || %prevCellNum < 0)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Previous cell is out of range; cell should be >= 0 and < your max number of tool slots.");
							else
								commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Previous cell is out of range; cell should be >= 0 and < your max number of tool slots.",0,"");
							return;
						}
						if(%currCellNum >= %storType || %currCellNum < 0)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Current cell is out of range; cell should be >= 0 and < the brick inventory size.");
							else
								commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Current cell is out of range; cell should be >= 0 and < the brick inventory size.",0,"");
							return;
						}
						
						%tempBSkAm = getWord(%cl.brInv,11+(%currCellNum*4)+1);
						if(%tempBSkAm > 1 && (%itemA != %itemB || %tempBSkAm >= getWord($ItemSetArray[%itemB],0)))
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Illegal Move","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.");
							else
								commandToClient(%cl,'ISMsgBox',"Illegal Move","denied","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.",0,"");
							return;
						}
						if(%itemB == %bkpkID && %itemA != %bkpkID)
						{
							for(%c = 0; %c < %cl.player.getDataBlock().maxTools; %c++)
							{
								%tool = %cl.player.tool[%c];
								if(%tool == %bkpkID)
								{
									if(getWord(%cl.ISclInfo,2) != 4)
										commandtoClient(%cl,'messageboxOK',"Backpack Already Present","You already have a backpack in your inventory.");
									else
										commandToClient(%cl,'ISMsgBox',"Backpack Already Present","error","You already have a backpack in your inventory.",0,"");
									return;
								}
							}
						}
					
						//////////////////////////////////////////////////
						//Transfer or swap itemA/itemB (item-stacking)
						
						if(%itemB > 0)
						{
							if(%itemA != %itemB) //if itemA and itemB are different, just swap
							{
								%itemBam = getWord(%cl.brInv,11+(%currCellNum*4)+1);
								
								if(%itemBam == 1)
								{
									%itemAam = 1;
									%itemASkAm = getWord($ItemSetArray[%itemA],0);
									%itemBSkAm = getWord($ItemSetArray[%itemB],0);
								}
								else
								{
									if(getWord(%cl.ISclInfo,2) != 4)
										commandtoClient(%cl,'messageboxOK',"Illegal Move","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.");
									else
										commandToClient(%cl,'ISMsgBox',"Illegal Move","denied","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.",0,"");
									return;
								}
							}
							else //if itemA and itemB are same, either swap or just transfer itemA
							{
								%itemBam = getWord(%cl.brInv,11+(%currCellNum*4)+1);
								%itemBSkAm = getWord($ItemSetArray[%itemB],0);
								
								if((%itemBam+1) <= %itemBSkAm) //if itemB stack can hold one more item
								{
									%itemBam++;
									
									%itemA = 0;
									%itemAam = 0;
									%itemASkAm = 0;
									
									%noSwap = 1;
								}
								else //if itemB stack is already full
								{
									if(getWord(%cl.ISclInfo,2) != 4)
										commandtoClient(%cl,'messageboxOK',"Illegal Move","Stack of items in the brick's inventory is full; items can't be transferred nor swapped.");
									else
										commandToClient(%cl,'ISMsgBox',"Illegal Move","denied","Stack of items in the brick's inventory is full; items can't be transferred nor swapped.",0,"");
									return;
								}
							}
						}
						else
						{
							%itemB = %itemA;
							%itemBam = 1;
							%itemBSkAm = getWord($ItemSetArray[%itemA],0);
							
							%itemAam = 0;
							%itemASkAm = 0;
							%itemA = 0;
							
							%noSwap = 1;
						}
						
						//////////////////////////////////////////////////
						
						%itemAWght = getWord($ItemSetArray[%itemA],1);
						%itemBWght = getWord($ItemSetArray[%itemB],1);
							
						if(%noSwap)
						{
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4),%itemA);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+1,%itemAam);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+2,%itemASkAm);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+3,%itemAWght);

							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4),%itemB);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+1,%itemBam);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+2,%itemBSkAm);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+3,%itemBWght);
							
							%temp = %currCell;
							%currCell = %prevCell;
							%prevCell = %temp;
						}
						else
						{
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4),%itemB);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+1,%itemBam);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+2,%itemBSkAm);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+3,%itemBWght);

							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4),%itemA);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+1,%itemAam);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+2,%itemASkAm);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+3,%itemAWght);
						}
						%brItms = getWords(%cl.brInv,11,138);
						
						//////////////////////////////////////////////////
						
						%name = getWord(%cl.brInv,1);
						%srcBrick = getWord(%cl.brInv,4);
						%load = getWords(%cl.brInv,2,10);
						%brName = getWord(%cl.brInv,8);
						%access = getWord(%cl.brInv,3);
						%rmtAcc = getWord(%cl.brInv,5);
						
						//////////////////////////////////////////////////
						
						if(getWord(%cl.brInv,0) != 0)
						{
							if(ISNameValid(%cl,%brName) == 1)
							{
								%cl.brInv = %tempMethodBr;
								%cl.plyrInv = %tempMethodPl;
								return;
							}
					
							if(getWord(%cl.brInv,0) != 0)
							{
								if(ISErrorCheck(%cl,%storType,%access,%load SPC %brItms,%brick,%srcBrick,%rmtAcc) == 1)
								{
									%cl.brInv = %tempMethodBr;
									%cl.plyrInv = %tempMethodPl;
									return;
								}
							}
							if(ISOverWriteSave(%cl,%name,%brName,%storType,%brItms,%access,%brick) == 1)
							{
								%cl.brInv = %tempMethodBr;
								%cl.plyrInv = %tempMethodPl;
								return;
							}
						}
						else
						{
							if(ISSaveItems(%cl,%brName,%name,%storType,%brItms,%access,%srcBrick) == 1)
							{
								%cl.brInv = %tempMethodBr;
								%cl.plyrInv = %tempMethodPl;
								return;
							}
							else
								ServerCmdISRefreshInfo(%cl,-1,-1,-1,%cl.bl_id,getSubStr(strReplace(%cl.name," ","_"),0,30));
						}
						
						//////////////////////////////////////////////////
						
						commandtoClient(%cl,'ISRefreshGUI',%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght,%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght);
						for(%c = 0; %c < clientgroup.getCount(); %c++)
						{
							%tempCl = clientgroup.getObject(%c);
							if(getWord(%tempCl.brInv,8) $= %brName && %tempCl != %cl)
							{
								%tempCl.brInv = %cl.brInv;
								commandtoClient(%tempCl,'ISRefreshGUI',%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght,"",0,0,0,0);
							}
						}
						
						//////////////////////////////////////////////////
						
						if(%noSwap)
						{
							if(isObject(PropaneTankItem))
							{
								%PTIid = PropaneTankItem.getID();
								if(%itemA != %PTIid && %itemB != %PTIid)
								{
									if(%itemB == %cl.player.tool[%cl.player.currTool])
										%cl.player.unMountImage(0);
								}
							}
							else if(%itemB == %cl.player.tool[%cl.player.currTool])
								%cl.player.unMountImage(0);
								
							%cl.player.tool[%prevCellNum] = %itemA; 
							messageClient(%cl,'MsgItemPickup','',%prevCellNum,%itemA);

							if(%itemB == %bkpkID)
							{
								%cl.ISclInfo = setWord(%cl.ISclInfo,0,0);
								
								if(getWord($HstSetString,3))
									commandToClient(%cl,'ISRelayBkPkToggle',3);
								
								if(%cl.player.getMountedImage(2) == ISBackPackBImage.getID())
									%cl.player.unMountImage(2);
								if(getWord(%cl.ISclInfo,1) !$= "")
									%cl.player.unHideNode(getWord(%cl.ISclInfo,1));
							}
						}
						else
						{
							if(isObject(PropaneTankItem))
							{
								%PTIid = PropaneTankItem.getID();
								if(%itemA != %PTIid && %itemB != %PTIid)
								{
									if(%itemA == %cl.player.tool[%cl.player.currTool])
										%cl.player.unMountImage(0);
								}
							}
							else if(%itemA == %cl.player.tool[%cl.player.currTool])
								%cl.player.unMountImage(0);
								
							%cl.player.tool[%prevCellNum] = %itemB; 
							messageClient(%cl,'MsgItemPickup','',%prevCellNum,%itemB);
							
							if(%itemA != %itemB)
							{
								if(%itemA == %bkpkID)
								{
									%cl.ISclInfo = setWord(%cl.ISclInfo,0,0);
									
									if(getWord($HstSetString,3))
										commandToClient(%cl,'ISRelayBkPkToggle',3);
									
									if(%cl.player.getMountedImage(2) == ISBackPackBImage.getID())
										%cl.player.unMountImage(2);
									if(getWord(%cl.ISclInfo,1) !$= "")
										%cl.player.unHideNode(getWord(%cl.ISclInfo,1));
								}
								else if(%itemB == %bkpkID && getWord($HstSetString,2) == 1)
								{
									%cl.ISclInfo = setWord(%cl.ISclInfo,0,1);
									if(%execEvents == 1)
										commandToClient(%cl,'ISRelayBkPkToggle',2);
								}
							}
						}
						%img = %cl.player.getMountedImage(2);
						if(%img > 0)
						{
							%imgFile = getWord(strReplace(%img.shapeFile,"/"," "),1);
							for(%c=0; %c<%cl.player.getDatablock().maxTools && %c<10; %c++)
							{
								%item = %cl.player.tool[%c];
								%imgBFile = getWord(strReplace(%item.shapeFile,"/"," "),1);
								if(%imgFile $= %imgBFile)
								{
									%check = 1;
									break;
								}
							}
							if(%check != 1)
								%cl.player.unMountImage(2);
						}
						ISEncumbrance(%cl,"",getWord($HstSetString,18));
					}
				}
				
				////////////////////////////////////////////////////////////////////////////////////////////////////
				//Brick Inv -> Brick Inv
			
				else
				{
					%itemA = getWord(%cl.brInv,11+(%prevCellNum*4));
					%itemB = getWord(%cl.brInv,11+(%currCellNum*4));
					%storType = getWord(%cl.brInv,2);
					
					if(%itemA == 0)
							%itemAname = "Nothing";
						else
							%itemAname = strReplace(%itemA.uiName," ","");
						if(%itemB == 0)
							%itemBname = "Nothing";
						else
							%itemBname = strReplace(%itemB.uiName," ","");
								
						%itemAvce = %itemAname SPC getWord(%cl.brInv,11+(%prevCellNum*4)+1) SPC getWord($ItemSetArray[%itemA],0) SPC getWord($ItemSetArray[%itemA],1);
						%itemBvce = %itemBname SPC getWord(%cl.brInv,11+(%currCellNum*4)+1) SPC getWord($ItemSetArray[%itemB],0) SPC getWord($ItemSetArray[%itemB],1);
						
					//////////////////////////////////////////////////
					
					if(%prevCellNum >= %storType || %prevCellNum < 0)
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Previous cell is out of range; cell should be >= 0 and < the brick inventory size.");
						else
							commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Previous cell is out of range; cell should be >= 0 and < the brick inventory size.",0,"");
						return;
					}
					if(%currCellNum >= %storType || %currCellNum < 0)
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Current cell is out of range; cell should be >= 0 and < the brick inventory size.");
						else
							commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Current cell is out of range; cell should be >= 0 and < the brick inventory size.",0,"");
						return;
					}
					if(%sendAm != -1 && %sendAm != -2)
						%sendAm = mAbs(mFloatLength(%sendAm,0));
					if(%sendAm > getWord($ItemSetArray[%itemA],0))
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Invalid Amount","Requested stack transfer amount exceeds stack limit.");
						else
							commandToClient(%cl,'ISMsgBox',"Invalid Amount","denied","Requested stack transfer amount exceeds stack limit.",0,"");
						return;
					}
					if(%sendAm > getWord(%cl.brInv,11+(%prevCellNum*4)+1))
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Invalid Amount","Requested stack transfer amount exceeds amount of items in stack.");
						else
							commandToClient(%cl,'ISMsgBox',"Invalid Amount","denied","Requested stack transfer amount exceeds amount of items in stack.",0,"");
						return;
					}
					
					//////////////////////////////////////////////////
					//Autostack
					
					if(%prevCell $= %currCell)
					{
						if(%sendAm == -2)
						{
							%autoStack = 1;
							%itemBam = getWord(%cl.brInv,11+(%currCellNum*4)+1);
							%itemBSkAm = getWord($itemSetArray[%itemB],0);
							%itemBWght = getWord($itemSetArray[%itemB],1);
							
							if(%itemBam >= %itemBSkAm)
								return;
							
							for(%c=0;%c<%storType && %c<32;%c++)
							{
								%cellRel = "BrStor" @ %c;
								%itemRel = getWord(%cl.brInv,11+(%c*4));
								%itemAmRel = getWord(%cl.brInv,11+(%c*4)+1);
								%itemWghtRel = getWord(%cl.brInv,11+(%c*4)+3);
								
								if(%itemRel > 0)
									%itemSkAmRel = getWord($itemSetArray[%itemRel],0);
								else
									%itemSkAmRel = 0;
								
								if(%itemRel == %itemB && %c != %currCellNum)
								{
									if((%itemBam + %itemCount + %itemAmRel) <= %itemBSkAm)
									{
										%newItems = %newItems SPC 0 SPC 0 SPC 0 SPC 0;
										%itemCount += %itemAmRel;
									}
									else
									{
										if((%itemBam + %itemCount) < %itemBSkAm)
										{
											%newItems = %newItems SPC %itemB SPC %itemAmRel-(%itemBSkAm-(%itemBam+%itemCount)) SPC %itemBSkAm SPC %itemBWght;
											%itemCount += (%itemBSkAm-(%itemBam+%itemCount));
										}
										else
											%newItems = %newItems SPC %itemRel SPC %itemAmRel SPC %itemSkAmRel SPC %itemWghtRel;
									}
								}
								else
									%newItems = %newItems SPC %itemRel SPC %itemAmRel SPC %itemSkAmRel SPC %itemWghtRel;
									
							}
							%itemCount += %itemBam;
							%newItems = setWord(%newItems,(%prevCellNum*4)+1,%itemB);
							%newItems = setWord(%newItems,(%prevCellNum*4)+2,%itemCount);
							%newItems = setWord(%newItems,(%prevCellNum*4)+3,%itemBSkAm);
							%newItems = setWord(%newItems,(%prevCellNum*4)+4,%itemBWght);
						}
						else
							return;
					}
					
					//////////////////////////////////////////////////
					//Transfer or swap itemA/itemB (item-stacking)
					
					else
					{
						if(%itemA == %itemB) //if itemA and itemB are the same, just send itemA
						{
							%itemBam = getWord(%cl.brInv,11+(%currCellNum*4)+1);
							if(%sendAm == -1)
								%itemBamInit = %itemBam;
							%itemBSkAm = getWord($ItemSetArray[%itemB],0);
							
							if(%itemBam < %itemBSkAm)
							{
								%itemASkAm = getWord($ItemSetArray[%itemA],0);
								%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1);
								if(%sendAm == -1)
									%sendAm = %itemAam;
								
								%noSwap = 1;
								%itemBam += %sendAm;
								
								if(%itemBam > %itemBSkAm)
								{
									%itemAam = (%itemAam-%sendAm)+(%itemBam-%itemBSkAm);
									%itemBam = %itemBSkAm;
								}
								else
								{
									%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1) - %sendAm;
									if(%itemAam < 1)
										%itemA = 0;
								}
							}
							else
							{
								%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1);
								%itemASkAm = getWord($ItemSetArray[%itemA],0);
							}
							
							if(%itemBamInit > 0)
								%sendAm = %itemBam - %itemBamInit;
						}
						else //if itemA and itemB are not the same, send itemA or swap both
						{
							if(%itemB > 0) //if no itemB, just send itemA
							{
								%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1);
								%itemASkAm = getWord($ItemSetArray[%itemA],0);
								%itemBam = getWord(%cl.brInv,11+(%currCellNum*4)+1);
								%itemBSkAm = getWord($ItemSetArray[%itemB],0);
								
								%sendAm = %itemAam;
							}
							else
							{
								if(%sendAm == -1) //if sending entire stack
								{
									%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1);
									%itemASkAm = getWord($ItemSetArray[%itemA],0);
									%itemBam = getWord(%cl.brInv,11+(%currCellNum*4)+1);
									%itemBSkAm = getWord($ItemSetArray[%itemB],0);
									
									%sendAm = %itemAam;
								}
								else //if sending specified amount
								{
									%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1) - %sendAm;
									%itemASkAm = getWord($ItemSetArray[%itemA],0);
									%itemB = %itemA;
									%itemBam = getWord(%cl.brInv,11+(%currCellNum*4)+1) + %sendAm;
									%itemBSkAm = getWord($ItemSetArray[%itemB],0);
									%noSwap = 1;
									
									if(%itemAam < 1)
										%itemA = 0;
								}
							}
						}
					}
					%newItems = getWords(%newItems,1,getWordCount(%newItems));
				
					//////////////////////////////////////////////////
					
					if(%autoStack != 1)
					{
						%itemAWght = getWord($ItemSetArray[%itemA],1);
						%itemBWght = getWord($ItemSetArray[%itemB],1);
							
						if(%noSwap)
						{
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4),%itemA);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+1,%itemAam);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+2,%itemASkAm);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+3,%itemAWght);

							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4),%itemB);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+1,%itemBam);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+2,%itemBSkAm);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+3,%itemBWght);
							
							%temp = %currCell;
							%currCell = %prevCell;
							%prevCell = %temp;
						}
						else
						{
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4),%itemB);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+1,%itemBam);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+2,%itemBSkAm);
							%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+3,%itemBWght);

							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4),%itemA);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+1,%itemAam);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+2,%itemASkAm);
							%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+3,%itemAWght);
						}
						%brItms = getWords(%cl.brInv,11,138);
					}
					else
					{
						%cl.brInv = getWords(%cl.brInv,0,10) SPC %newItems;
						%brItms = %newItems;
					}
					
					//////////////////////////////////////////////////
					
					%name = getWord(%cl.brInv,1);
					%srcBrick = getWord(%cl.brInv,4);
					%load = getWords(%cl.brInv,2,10);
					%brName = getWord(%cl.brInv,8);
					%access = getWord(%cl.brInv,3);
					%rmtAcc = getWord(%cl.brInv,5);
					
					//////////////////////////////////////////////////
					
					if(getWord(%cl.brInv,0) != 0)
					{
						if(ISNameValid(%cl,%brName) == 1)
						{
							%cl.brInv = %tempMethodBr;
							return;
						}
				
						if(getWord(%cl.brInv,0) != 0)
						{
							if(ISErrorCheck(%cl,%storType,%access,%load SPC %brItms,%brick,%srcBrick,%rmtAcc) == 1)
							{
								%cl.brInv = %tempMethodBr;
								return;
							}
						}
						if(ISOverWriteSave(%cl,%name,%brName,%storType,%brItms,%access,%brick) == 1)
						{
							%cl.brInv = %tempMethodBr;
							return;
						}
					}
					else
					{
						if(ISSaveItems(%cl,%brName,%name,%storType,%brItms,%access,%srcBrick) == 1)
						{
							%cl.brInv = %tempMethodBr;
							return;
						}
						else
							ServerCmdISRefreshInfo(%cl,-1,-1,-1,%cl.bl_id,getSubStr(strReplace(%cl.name," ","_"),0,30));
					}

					//////////////////////////////////////////////////
					
					%count = getWordCount(%newItems);
					for(%c = 0; %c < clientgroup.getCount(); %c++)
					{
						%tempCl = clientgroup.getObject(%c);
						if(getWord(%tempCl.brInv,8) $= %brName)
						{
							if(%tempCl != %cl)
								%tempCl.brInv = %cl.brInv;
							
							if(%autoStack != 1)
								commandtoClient(%tempCl,'ISRefreshGUI',%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght,%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght);
							else
							{
								if(getWordCount(%newItems) < 255)
									commandtoClient(%tempCl,'ISMultRefreshGUI',%newItems,"Br");
								else
								{
									%loadBrTemp = "";
									%b = 0;
									
									for(%c=9; %c<%count; %c+=4)
									{
										if(strLen(%loadBrTemp SPC getWord(%newItems,%c) SPC getWord(%newItems,%c+1) SPC getWord(%newItems,%c+2) SPC getWord(%newItems,%c+3)) < 255)
										{
											%loadBrTemp = %loadBrTemp SPC getWord(%newItems,%c) SPC getWord(%newItems,%c+1) SPC getWord(%newItems,%c+2) SPC getWord(%newItems,%c+3);
											
											if((%c+4) >= %count)
											{
												commandtoClient(%tempCl,'ISPopulateGUIRel',"br",(%b SPC (%c-9)),getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
												break;
											}
										}
										else
										{
											commandtoClient(%tempCl,'ISPopulateGUIRel',"br",%b SPC (%c-9),getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
											%loadBrTemp = " " @ getWord(%newItems,%c) SPC getWord(%newItems,%c+1) SPC getWord(%newItems,%c+2) SPC getWord(%newItems,%c+3);
											%b = (%c-9);
											
											if((%c+4) >= %count)
											{
												commandtoClient(%tempCl,'ISPopulateGUIRel',"br",(%b SPC (%c-9)),getSubStr(%loadBrTemp,1,strLen(%loadBrTemp)));
												break;
											}
										}
									}
								}
							}
						}
					}
					
				}
			}
			
			////////////////////////////////////////////////////////////////////////////////////////////////////
			//Backpack Inv -> Brick Inv
			
			else
			{
				if(getWord($HstSetString,2) == 1)
				{
					%itemA = getWord(%cl.bkpkInv,3+(%prevCellNum*4));
					%itemB = getWord(%cl.brInv,11+(%currCellNum*4));
					%storType = getWord(%cl.brInv,2);
					
					if(%itemA == 0)
						%itemAname = "Nothing";
					else
						%itemAname = strReplace(%itemA.uiName," ","");
					if(%itemB == 0)
						%itemBname = "Nothing";
					else
						%itemBname = strReplace(%itemB.uiName," ","");
								
					%itemAvce = %itemAname SPC getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1) SPC getWord($ItemSetArray[%itemA],0) SPC getWord($ItemSetArray[%itemA],1);
					%itemBvce = %itemBname SPC getWord(%cl.brInv,11+(%currCellNum*4)+1) SPC getWord($ItemSetArray[%itemB],0) SPC getWord($ItemSetArray[%itemB],1);
						
					//////////////////////////////////////////////////
					
					if(%prevCellNum >= 15 || %prevCellNum < 0)
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Previous cell is out of range; cell should be >= 0 and < 15.");
						else
							commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Previous cell is out of range; cell should be >= 0 and < 15.",0,"");
						return;
					}
					if(%currCellNum >= %storType || %currCellNum < 0)
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Current cell is out of range; cell should be >= 0 and < the brick inventory size.");
						else
							commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Current cell is out of range; cell should be >= 0 and < the brick inventory size.",0,"");
						return;
					}
					if(%itemB == ISBackPackItem.getID())
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Error","You can't put a backpack inside of another backpack.");
						else
							commandToClient(%cl,'ISMsgBox',"Error","error","You can't put a backpack inside of another backpack.",0,"");
						return;
					}
					if(%sendAm != -1 && %sendAm != -2)
						%sendAm = mAbs(mFloatLength(%sendAm,0));
					if(%sendAm > getWord($ItemSetArray[%itemA],0))
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Invalid Amount","Requested stack transfer amount exceeds stack limit.");
						else
							commandToClient(%cl,'ISMsgBox',"Invalid Amount","denied","Requested stack transfer amount exceeds stack limit.",0,"");
						return;
					}
					if(%sendAm > getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1))
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Invalid Amount","Requested stack transfer amount exceeds amount in stack.");
						else
							commandToClient(%cl,'ISMsgBox',"Invalid Amount","denied","Requested stack transfer amount exceeds amount in stack.",0,"");
						return;
					}
					
					//////////////////////////////////////////////////
					//Transfer or swap itemA/itemB (item-stacking)
					
					if(%itemA == %itemB)
					{
						%itemBam = getWord(%cl.brInv,11+(%currCellNum*4)+1);
						if(%sendAm == -1)
							%itemBamInit = %itemBam;
						%itemBSkAm = getWord($ItemSetArray[%itemB],0);
						
						if(%itemBam < %itemBSkAm)
						{
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
							%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1);
							
							if(%sendAm == -1)
								%sendAm = %itemAam;
							
							%noSwap = 1;
							%itemBam += %sendAm;
							
							if(%itemBam > %itemBSkAm)
							{
								%itemAam = (%itemAam-%sendAm)+(%itemBam-%itemBSkAm);
								%itemBam = %itemBSkAm;
							}
							else
							{
								%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1) - %sendAm;
								
								if(%itemAam < 1)
									%itemA = 0;
							}
						}
						else
						{
							%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1);
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
						}
						
						if(%itemBamInit > 0)
							%sendAm = %itemBam - %itemBamInit;
					}
					else
					{
						//If itemA and itemB are different, switch both only
						if(%itemB > 0)
						{
							%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1);
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
							%itemBam = getWord(%cl.brInv,11+(%currCellNum*4)+1);
							%itemBSkAm = getWord($ItemSetArray[%itemB],0);
							
							%sendAm = %itemAam;
						}
						
						//If itemB doesn't exist, move item stack or specified amount to second cell
						else
						{
							if(%sendAm == -1) //if sending entire stack
							{
								%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1);
								%itemASkAm = getWord($ItemSetArray[%itemA],0);
								%itemBam = getWord(%cl.brInv,11+(%currCellNum*4)+1);
								%itemBSkAm = getWord($ItemSetArray[%itemB],0);
								
								%sendAm = %itemAam;
							}
							else //if sending specific amount
							{
								%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1) - %sendAm;
								%itemASkAm = getWord($ItemSetArray[%itemA],0);
								%itemB = %itemA;
								%itemBam = getWord(%cl.brInv,11+(%currCellNum*4)+1) + %sendAm;
								%itemBSkAm = getWord($ItemSetArray[%itemB],0);
								%noSwap = 1;
								
								if(%itemAam < 1)
									%itemA = 0;
							}
						}
					}
					
					//////////////////////////////////////////////////
					
					%itemAWght = getWord($ItemSetArray[%itemA],1);
					%itemBWght = getWord($ItemSetArray[%itemB],1);
						
					if(%noSwap)
					{
						%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4),%itemB);
						%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+1,%itemBam);
						%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+2,%itemBSkAm);
						%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+3,%itemBWght);
						
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4),%itemA);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+1,%itemAam);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+2,%itemASkAm);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+3,%itemAWght);
						
						%temp = %currCell;
						%currCell = %prevCell;
						%prevCell = %temp;
					}
					else
					{
						%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4),%itemA);
						%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+1,%itemAam);
						%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+2,%itemASkAm);
						%cl.brInv = setWord(%cl.brInv,11+(%currCellNum*4)+3,%itemAWght);
						
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4),%itemB);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+1,%itemBam);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+2,%itemBSkAm);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+3,%itemBWght);
					}
					
					//////////////////////////////////////////////////
					
					%name = getWord(%cl.brInv,1);
					%srcBrick = getWord(%cl.brInv,4);
					%load = getWords(%cl.brInv,2,10);
					%brItms = getWords(%cl.brInv,11,138);
					%bkpkItms = getWords(%cl.bkpkInv,3,62);
					%brName = getWord(%cl.brInv,8);
					%access = getWord(%cl.brInv,3);
					%rmtAcc = getWord(%cl.brInv,5);
					
					//////////////////////////////////////////////////
					
					if(getWord(%cl.brInv,0) != 0)
					{
						if(ISNameValid(%cl,%brName) == 1)
						{
							%cl.brInv = %tempMethodBr;
							%cl.bkpkInv = %tempMethodBk;
							return;
						}
			
						if(getWord(%cl.brInv,0) != 0)
						{
							if(ISErrorCheck(%cl,%storType,%access,%load SPC %brItms,%brick,%srcBrick,%rmtAcc) == 1)
							{
								%cl.brInv = %tempMethodBr;
								%cl.bkpkInv = %tempMethodBk;
								return;
							}
						}
						if(ISOverWriteSave(%cl,%name,%brName,%storType,%brItms,%access,%brick) == 1)
						{
							%cl.brInv = %tempMethodBr;
							%cl.bkpkInv = %tempMethodBk;
							return;
						}
					}
					else
					{
						if(ISSaveItems(%cl,%brName,%name,%storType,%brItms,%access,%srcBrick) == 1)
						{
							%cl.brInv = %tempMethodBr;
							%cl.bkpkInv = %tempMethodBk;
							return;
						}
						else
							ServerCmdISRefreshInfo(%cl,-1,-1,-1,%cl.bl_id,getSubStr(strReplace(%cl.name," ","_"),0,30));
					}
					
					//////////////////////////////////////////////////
					
					if(getWord(%cl.bkpkInv,0) != 0)
					{
						if(ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,%bkpkItms,0,0) == 1)
						{
							%cl.brInv = %tempMethodBr;
							%cl.bkpkInv = %tempMethodBk;
							ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,getWords(%tempMethodBk,3,62),0,0);
							return;
						}
					}
					else if(ISSaveItems(%cl,%cl.bl_id,"BackPacks",0,%bkpkItms,0) == 1)
					{
						%cl.brInv = %tempMethodBr;
						%cl.bkpkInv = %tempMethodBk;
						ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,getWords(%tempMethodBk,3,62),0,0);
						return;
					}

					//////////////////////////////////////////////////
					
					commandtoClient(%cl,'ISRefreshGUI',%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght,%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght);
					for(%c = 0; %c < clientgroup.getCount(); %c++)
					{
						%tempCl = clientgroup.getObject(%c);
						if(getWord(%tempCl.brInv,8) $= %brName && %tempCl != %cl)
						{
							%tempCl.brInv = %cl.brInv;
							commandtoClient(%tempCl,'ISRefreshGUI',"",0,0,0,0,%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght);
						}
					}
					ISEncumbrance(%cl,"",getWord($HstSetString,18));
				}
				else
				{
					if(getWord(%cl.ISclInfo,2) != 4)
						commandtoClient(%cl,'messageboxOK',"Backpack Disabled","Backpack storage has been disabled by the server host.");
					else
						commandToClient(%cl,'ISMsgBox',"Backpack Disabled","locked","Backpack storage has been disabled by the server host.",0,"");
				}
			}
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Backpack Inv
	
	else
	{
		if(getWord($HstSetString,2) == 1)
		{
			if(%prevCellStr !$= "bpStor")
			{
				if(%prevCellStr !$= "brStor")
				{
					////////////////////////////////////////////////////////////////////////////////////////////////////
					//Player Inv -> Backpack Inv
					
					if(%prevCellStr $= "plStor")
					{
						%itemA = getWord(%cl.plyrInv,1+(%prevCellNum*4));
						%itemB = getWord(%cl.bkpkInv,3+(%currCellNum*4));
						
						if(%itemA == 0)
							%itemAname = "Nothing";
						else
							%itemAname = strReplace(%itemA.uiName," ","");
						if(%itemB == 0)
							%itemBname = "Nothing";
						else
							%itemBname = strReplace(%itemB.uiName," ","");
								
						%itemAvce = %itemAname SPC getWord(%cl.plyrInv,1+(%prevCellNum*4)+1) SPC getWord($ItemSetArray[%itemA],0) SPC getWord($ItemSetArray[%itemA],1);
						%itemBvce = %itemBname SPC getWord(%cl.bkpkInv,3+(%currCellNum*4)+1) SPC getWord($ItemSetArray[%itemB],0) SPC getWord($ItemSetArray[%itemB],1);
						
						//////////////////////////////////////////////////
					
						%mxTls = %cl.player.getDatablock().maxTools;
						
						if(%prevCellNum >= %mxTls || %prevCellNum < 0)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Previous cell is out of range; cell should be >= 0 and < your number of max tool slots.");
							else
								commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Previous cell is out of range; cell should be >= 0 and < your number of max tool slots.",0,"");
							return;
						}
						if(%currCellNum >= 15 || %currCellNum < 0)
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Current cell is out of range; cell should be >= 0 and < 15.");
							else
								commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Current cell is out of range; cell should be >= 0 and < 15.",0,"");
							return;
						}
					
						%tempBSkAm = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1);
						if(%tempBSkAm > 1 && (%itemA != %itemB || %tempBSkAm >= getWord($ItemSetArray[%itemB],0))) //no need to check itemA
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Illegal Move","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.");
							else
								commandToClient(%cl,'ISMsgBox',"Illegal Move","denied","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.",0,"");
							return;
						}
						if(%itemA == ISBackPackItem.getID())
						{
							if(getWord(%cl.ISclInfo,2) != 4)
								commandtoClient(%cl,'messageboxOK',"Paradox Averted","You can't put a backpack inside of itself.");
							else
								commandToClient(%cl,'ISMsgBox',"Paradox Averted","paradox","You can't put a backpack inside of itself.",0,"");
							return;
						}
					
						//////////////////////////////////////////////////
						//Transfer or swap itemA/itemB (item-stacking)
						
						//If itemA and itemB are different, switch both only
						if(%itemB > 0)
						{
							if(%itemA != %itemB)
							{
								%itemBam = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1);
								
								if(%itemBam == 1)
								{
									%itemAam = 1;
									%itemASkAm = getWord($ItemSetArray[%itemA],0);
									%itemBSkAm = getWord($ItemSetArray[%itemB],0);
								}
								else
								{
									if(getWord(%cl.ISclInfo,2) != 4)
										commandtoClient(%cl,'messageboxOK',"Illegal Move","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.");
									else
										commandToClient(%cl,'ISMsgBox',"Illegal Move","denied","You can't swap a stack of items with an item in your player inventory if the amount stacked is > 1.",0,"");
									return;
								}
							}
							else
							{
								%itemBam = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1);
								%itemBSkAm = getWord($ItemSetArray[%itemB],0);
								
								if((%itemBam+1) <= %itemBSkAm)
								{
									%itemBam++;
									
									%itemA = 0;
									%itemAam = 0;
									%itemASkAm = 0;
									
									%noSwap = 1;
								}
								else
								{
									if(getWord(%cl.ISclInfo,2) != 4)
										commandtoClient(%cl,'messageboxOK',"Illegal Move","Stack of items in the brick's inventory is full; items can't be transferred nor swapped.");
									else
										commandToClient(%cl,'ISMsgBox',"Illegal Move","denied","Stack of items in the brick's inventory is full; items can't be transferred nor swapped.",0,"");
									return;
								}
							}
						}
						
						//If itemB doesn't exist, move item stack or specified amount to second cell
						else
						{
							%itemB = %itemA;
							%itemBam = 1;
							%itemBSkAm = getWord($ItemSetArray[%itemA],0);
							
							%itemAam = 0;
							%itemASkAm = 0;
							%itemA = 0;
							
							%noSwap = 1;
						}
						
						//////////////////////////////////////////////////
						
						%itemAWght = getWord($ItemSetArray[%itemA],1);
						%itemBWght = getWord($ItemSetArray[%itemB],1);
							
						if(%noSwap)
						{
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4),%itemA);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+1,%itemAam);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+2,%itemASkAm);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+3,%itemAWght);

							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4),%itemB);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+1,%itemBam);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+2,%itemBSkAm);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+3,%itemBWght);
							
							%temp = %currCell;
							%currCell = %prevCell;
							%prevCell = %temp;
						}
						else
						{
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4),%itemB);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+1,%itemBam);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+2,%itemBSkAm);
							%cl.plyrInv = setWord(%cl.plyrInv,1+(%prevCellNum*4)+3,%itemBWght);

							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4),%itemA);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+1,%itemAam);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+2,%itemASkAm);
							%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+3,%itemAWght);
						}
						%bkpkItms = getWords(%cl.bkpkInv,3,62);
						
						//////////////////////////////////////////////////
						
						if(getWord(%cl.bkpkInv,0) != 0)
						{
							if(ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,%bkpkItms,0,0) == 1)
							{
								%cl.bkpkInv = %tempMethodBk;
								%cl.plyrInv = %tempMethodPl;
								return;
							}
						}
						else if(ISSaveItems(%cl,%cl.bl_id,"BackPacks",0,%bkpkItms,0) == 1)
						{
							%cl.bkpkInv = %tempMethodBk;
							%cl.plyrInv = %tempMethodPl;
							return;
						}
						
						//////////////////////////////////////////////////
						
						commandtoClient(%cl,'ISRefreshGUI',%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght,%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght);
						
						if(%noSwap)
						{
							if(isObject(PropaneTankItem))
							{
								%PTIid = PropaneTankItem.getID();
								if(%itemA != %PTIid && %itemB != %PTIid)
								{
									if(%itemB == %cl.player.tool[%cl.player.currTool])
										%cl.player.unMountImage(0);
								}
							}
							else if(%itemB == %cl.player.tool[%cl.player.currTool])
								%cl.player.unMountImage(0);
							
							%cl.player.tool[%prevCellNum] = %itemA; 
							messageClient(%cl,'MsgItemPickup','',%prevCellNum,%itemA);
						}
						else
						{
							if(isObject(PropaneTankItem))
							{
								%PTIid = PropaneTankItem.getID();
								if(%itemA != %PTIid && %itemB != %PTIid)
								{
									if(%itemA == %cl.player.tool[%cl.player.currTool])
										%cl.player.unMountImage(0);
								}
							}
							else if(%itemA == %cl.player.tool[%cl.player.currTool])
								%cl.player.unMountImage(0);
							
							%cl.player.tool[%prevCellNum] = %itemB; 
							messageClient(%cl,'MsgItemPickup','',%prevCellNum,%itemB);
						}
						%img = %cl.player.getMountedImage(2);
						if(%img > 0)
						{
							%imgFile = getWord(strReplace(%img.shapeFile,"/"," "),1);
							for(%c=0; %c<%cl.player.getDatablock().maxTools && %c<10; %c++)
							{
								%item = %cl.player.tool[%c];
								%imgBFile = getWord(strReplace(%item.shapeFile,"/"," "),1);
								if(%imgFile $= %imgBFile)
								{
									%check = 1;
									break;
								}
							}
							if(%check != 1)
								%cl.player.unMountImage(2);
						}
					}
				}
				
				////////////////////////////////////////////////////////////////////////////////////////////////////
				//Brick Inv -> Backpack Inv
				
				else
				{
					%itemA = getWord(%cl.brInv,11+(%prevCellNum*4));
					%itemB = getWord(%cl.bkpkInv,3+(%currCellNum*4));
					%storType = getWord(%cl.brInv,2);

					if(%itemA == 0)
						%itemAname = "Nothing";
					else
						%itemAname = strReplace(%itemA.uiName," ","");
					if(%itemB == 0)
						%itemBname = "Nothing";
					else
						%itemBname = strReplace(%itemB.uiName," ","");
							
					%itemAvce = %itemAname SPC getWord(%cl.brInv,11+(%prevCellNum*4)+1) SPC getWord($ItemSetArray[%itemA],0) SPC getWord($ItemSetArray[%itemA],1);
					%itemBvce = %itemBname SPC getWord(%cl.bkpkInv,3+(%currCellNum*4)+1) SPC getWord($ItemSetArray[%itemB],0) SPC getWord($ItemSetArray[%itemB],1);
						
					//////////////////////////////////////////////////
					
					if(%prevCellNum >= %storType || %prevCellNum < 0)
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Previous cell is out of range; cell should be >= 0 and < the brick inventory size.");
						else
							commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Previous cell is out of range; cell should be >= 0 and < the brick inventory size.",0,"");
						return;
					}
					if(%currCellNum >= 15 || %currCellNum < 0)
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Current cell is out of range; cell should be >= 0 and < 15.");
						else
							commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Current cell is out of range; cell should be >= 0 and < 15.",0,"");
						return;
					}
					if(%itemA == ISBackPackItem.getID())
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Error","You can't put a backpack inside of another backpack.");
						else
							commandToClient(%cl,'ISMsgBox',"Error","error","You can't put a backpack inside of another backpack.",0,"");
						return;
					}
					if(%sendAm != -1 && %sendAm != -2)
						%sendAm = mAbs(mFloatLength(%sendAm,0));
					if(%sendAm > getWord($ItemSetArray[%itemA],0))
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Invalid Amount","Requested stack transfer amount exceeds stack limit.");
						else
							commandToClient(%cl,'ISMsgBox',"Invalid Amount","denied","Requested stack transfer amount exceeds stack limit.",0,"");
						return;
					}
					if(%sendAm > getWord(%cl.brInv,11+(%prevCellNum*4)+1))
					{
						if(getWord(%cl.ISclInfo,2) != 4)
							commandtoClient(%cl,'messageboxOK',"Invalid Amount","Requested stack transfer amount exceeds amount in stack.");
						else
							commandToClient(%cl,'ISMsgBox',"Invalid Amount","denied","Requested stack transfer amount exceeds amount in stack.",0,"");
						return;
					}
					
					//////////////////////////////////////////////////
					//Transfer or swap itemA/itemB (item-stacking)
					
					if(%itemA == %itemB) //swap if either is at max
					{
						%itemBam = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1);
						if(%sendAm == -1)
							%itemBamInit = %itemBam;
						%itemBSkAm = getWord($ItemSetArray[%itemB],0);
						
						if(%itemBam < %itemBSkAm) //if itemB not at max, else swap both stacks
						{
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
							%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1);
							
							if(%sendAm == -1)
								%sendAm = %itemAam;
							
							%noSwap = 1; //unless one stack is at max
							%itemBam += %sendAm;
							
							if(%itemBam > %itemBSkAm) //if itemB is over max after adding amount from other stack
							{
								%itemAam = (%itemAam-%sendAm)+(%itemBam-%itemBSkAm);
								%itemBam = %itemBSkAm;
							}
							else
							{
								%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1) - %sendAm;
								if(%itemAam < 1)
									%itemA = 0;
							}
						}
						else
						{
							%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1);
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
						}
						
						if(%itemBamInit > 0)
							%sendAm = %itemBam - %itemBamInit;
					}
					else
					{
						//////////////////////////////////////////////////
						
						if(%itemB > 0)
						{
							%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1);
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
							%itemBam = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1);
							%itemBSkAm = getWord($ItemSetArray[%itemB],0);
							
							%sendAm = %itemAam;
						}
						
						//////////////////////////////////////////////////
						
						else
						{
							if(%sendAm == -1) //entire stack
							{
								%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1);
								%itemASkAm = getWord($ItemSetArray[%itemA],0);
								%itemBam = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1);
								%itemBSkAm = getWord($ItemSetArray[%itemB],0);
								
								%sendAm = %itemAam;
							}
							else //specific amount
							{
								%itemAam = getWord(%cl.brInv,11+(%prevCellNum*4)+1) - %sendAm;
								%itemASkAm = getWord($ItemSetArray[%itemA],0);
								%itemB = %itemA;
								%itemBam = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1) + %sendAm;
								%itemBSkAm = getWord($ItemSetArray[%itemB],0);
								%noSwap = 1;
								
								if(%itemAam < 1)
									%itemA = 0;
							}
						}
					}
					
					//////////////////////////////////////////////////
					
					%itemAWght = getWord($ItemSetArray[%itemA],1);
					%itemBWght = getWord($ItemSetArray[%itemB],1);
					
					if(%noSwap)
					{			
						%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4),%itemA);
						%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+1,%itemAam);
						%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+2,%itemASkAm);
						%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+3,%itemAWght);
						
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4),%itemB);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+1,%itemBam);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+2,%itemBSkAm);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+3,%itemBWght);
						
						%temp = %currCell;
						%currCell = %prevCell;
						%prevCell = %temp;
					}
					else
					{
						%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4),%itemB);
						%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+1,%itemBam);
						%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+2,%itemBSkAm);
						%cl.brInv = setWord(%cl.brInv,11+(%prevCellNum*4)+3,%itemBWght);
						
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4),%itemA);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+1,%itemAam);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+2,%itemASkAm);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+3,%itemAWght);
					}
					
					//////////////////////////////////////////////////
					
					%name = getWord(%cl.brInv,1);
					%srcBrick = getWord(%cl.brInv,4);
					%load = getWords(%cl.brInv,2,10);
					%brItms = getWords(%cl.brInv,11,138);
					%bkpkItms = getWords(%cl.bkpkInv,3,62);
					%brName = getWord(%cl.brInv,8);
					%access = getWord(%cl.brInv,3);
					%rmtAcc = getWord(%cl.brInv,5);
					
					//////////////////////////////////////////////////
					
					if(getWord(%cl.brInv,0) != 0)
					{
						if(ISNameValid(%cl,%brName) == 1)
						{
							%cl.brInv = %tempMethodBr;
							%cl.bkpkInv = %tempMethodBk;
							return;
						}
				
						if(getWord(%cl.brInv,0) != 0)
						{
							if(ISErrorCheck(%cl,%storType,%access,%load SPC %brItms,%brick,%srcBrick,%rmtAcc) == 1)
							{
								%cl.brInv = %tempMethodBr;
								%cl.bkpkInv = %tempMethodBk;
								return;
							}
						}
						if(ISOverWriteSave(%cl,%name,%brName,%storType,%brItms,%access,%brick) == 1)
						{
							%cl.brInv = %tempMethodBr;
							%cl.bkpkInv = %tempMethodBk;
							return;
						}
					}
					else
					{
						if(ISSaveItems(%cl,%brName,%name,%storType,%brItms,%access,%srcBrick) == 1)
						{
							%cl.brInv = %tempMethodBr;
							%cl.bkpkInv = %tempMethodBk;
							return;
						}
						else
							ServerCmdISRefreshInfo(%cl,-1,-1,-1,%cl.bl_id,getSubStr(strReplace(%cl.name," ","_"),0,30));
					}
					
					//////////////////////////////////////////////////
					
					if(getWord(%cl.bkpkInv,0) != 0)
					{
						if(ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,%bkpkItms,0,0) == 1)
						{
							%cl.brInv = %tempMethodBr;
							%cl.bkpkInv = %tempMethodBk;
							ISOverWriteSave(%cl,%name,%brName,%storType,getWords(%tempMethodBr,11,138),%access,%brick);
							return;
						}
					}
					else if(ISSaveItems(%cl,%cl.bl_id,"BackPacks",0,%bkpkItms,0) == 1)
					{
						%cl.brInv = %tempMethodBr;
						%cl.bkpkInv = %tempMethodBk;
						ISOverWriteSave(%cl,%name,%brName,%storType,getWords(%tempMethodBr,11,138),%access,%brick);
						return;
					}
					//////////////////////////////////////////////////
					
					commandtoClient(%cl,'ISRefreshGUI',%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght,%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght);
					for(%c = 0; %c < clientgroup.getCount(); %c++)
					{
						%tempCl = clientgroup.getObject(%c);
						if(getWord(%tempCl.brInv,8) $= %brName && %tempCl != %cl)
						{
							%tempCl.brInv = %cl.brInv;
							commandtoClient(%tempCl,'ISRefreshGUI',"",0,0,0,0,%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght);
						}
					}
					ISEncumbrance(%cl,"",getWord($HstSetString,18));
				}
			}
			
			////////////////////////////////////////////////////////////////////////////////////////////////////
			//Backpack Inv -> Backpack Inv
			
			else
			{
				%itemA = getWord(%cl.bkpkInv,3+(%prevCellNum*4));
				%itemB = getWord(%cl.bkpkInv,3+(%currCellNum*4));
				
				if(%itemA == 0)
					%itemAname = "Nothing";
				else
					%itemAname = strReplace(%itemA.uiName," ","");
				if(%itemB == 0)
					%itemBname = "Nothing";
				else
					%itemBname = strReplace(%itemB.uiName," ","");
						
				%itemAvce = %itemAname SPC getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1) SPC getWord($ItemSetArray[%itemA],0) SPC getWord($ItemSetArray[%itemA],1);
				%itemBvce = %itemBname SPC getWord(%cl.bkpkInv,3+(%currCellNum*4)+1) SPC getWord($ItemSetArray[%itemB],0) SPC getWord($ItemSetArray[%itemB],1);
						
				//////////////////////////////////////////////////
				
				if(%prevCellNum >= 15 || %prevCellNum < 0)
				{
					if(getWord(%cl.ISclInfo,2) != 4)
						commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Previous cell is out of range; cell should be >= 0 and < 15.");
					else
						commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Previous cell is out of range; cell should be >= 0 and < 15.",0,"");
					return;
				}
				if(%currCellNum >= 15 || %currCellNum < 0)
				{
					if(getWord(%cl.ISclInfo,2) != 4)
						commandtoClient(%cl,'messageboxOK',"Cell Out Of Range","Current cell is out of range; cell should be >= 0 and < 15.");
					else
						commandToClient(%cl,'ISMsgBox',"Cell Out Of Range","denied","Current cell is out of range; cell should be >= 0 and < 15.",0,"");
					return;
				}
				if(%sendAm != -1 && %sendAm != -2)
					%sendAm = mAbs(mFloatLength(%sendAm,0));
				if(%sendAm > getWord($ItemSetArray[%itemA],0))
				{
					if(getWord(%cl.ISclInfo,2) != 4)
						commandtoClient(%cl,'messageboxOK',"Invalid Amount","Requested stack transfer amount exceeds stack limit.");
					else
						commandToClient(%cl,'ISMsgBox',"Invalid Amount","denied","Requested stack transfer amount exceeds stack limit.",0,"");
					return;
				}
				if(%sendAm > getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1))
				{
					if(getWord(%cl.ISclInfo,2) != 4)
						commandtoClient(%cl,'messageboxOK',"Invalid Amount","Requested stack transfer amount exceeds amount of items in stack.");
					else
						commandToClient(%cl,'ISMsgBox',"Invalid Amount","denied","Requested stack transfer amount exceeds amount of items in stack.",0,"");
					return;
				}
				
				//////////////////////////////////////////////////
				//Autostack
				
				if(%prevCell $= %currCell)
				{
					if(%sendAm == -2)
					{
						%autoStack = 1;
						%itemBam = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1);
						%itemBSkAm = getWord($itemSetArray[%itemB],0);
						%itemBWght = getWord($itemSetArray[%itemB],1);
						
						if(%itemBam >= %itemBSkAm)
							return;
						
						for(%c=0;%c<15;%c++)
						{
							%cellRel = "BpStor" @ %c;
							%itemRel = getWord(%cl.bkpkInv,3+(%c*4));
							%itemAmRel = getWord(%cl.bkpkInv,3+(%c*4)+1);
							%itemWghtRel = getWord(%cl.bkpkInv,3+(%c*4)+3);
							
							if(%itemRel > 0)
								%itemSkAmRel = getWord($itemSetArray[%itemRel],0);
							else
								%itemSkAmRel = 0; //?
							
							if(%itemRel == %itemB && %c != %currCellNum)
							{
								if((%itemBam + %itemCount + %itemAmRel) <= %itemBSkAm)
								{
									%newItems = %newItems SPC 0 SPC 0 SPC 0 SPC 0;
									%itemCount += %itemAmRel;
								}
								else
								{
									if((%itemBam + %itemCount) < %itemBSkAm)
									{
										%newItems = %newItems SPC %itemB SPC %itemAmRel-(%itemBSkAm-(%itemBam+%itemCount)) SPC %itemBSkAm SPC %itemBWght;
										%itemCount += (%itemBSkAm-(%itemBam+%itemCount));
									}
									else
										%newItems = %newItems SPC %itemRel SPC %itemAmRel SPC %itemSkAmRel SPC %itemWghtRel;
								}
							}
							else
								%newItems = %newItems SPC %itemRel SPC %itemAmRel SPC %itemSkAmRel SPC %itemWghtRel;
								
						}
						%itemCount += %itemBam;
						%newItems = setWord(%newItems,(%prevCellNum*4)+1,%itemB);
						%newItems = setWord(%newItems,(%prevCellNum*4)+2,%itemCount);
						%newItems = setWord(%newItems,(%prevCellNum*4)+3,%itemBSkAm);
						%newItems = setWord(%newItems,(%prevCellNum*4)+4,%itemBWght);
					}
					else
						return;
				}
				
				//////////////////////////////////////////////////
				//Transfer or swap itemA/itemB (item-stacking)
				
				else
				{
					if(%itemA == %itemB) //swap if either is at max
					{
						%itemBam = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1);
						if(%sendAm == -1)
							%itemBamInit = %itemBam;
						%itemBSkAm = getWord($ItemSetArray[%itemB],0);
						
						if(%itemBam < %itemBSkAm) //if itemB not at max, else swap both stacks
						{
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
							%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1);
							if(%sendAm == -1)
								%sendAm = %itemAam;
							
							%noSwap = 1; //unless one stack is at max
							%itemBam += %sendAm;
							
							if(%itemBam > %itemBSkAm) //if itemB is over max after adding amount from other stack
							{
								%itemAam = (%itemAam-%sendAm)+(%itemBam-%itemBSkAm);
								%itemBam = %itemBSkAm;
							}
							else
							{
								%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1) - %sendAm;
								
								if(%itemAam < 1)
									%itemA = 0;
							}
						}
						else
						{
							%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1);
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
						}
						
						if(%itemBamInit > 0)
							%sendAm = %itemBam - %itemBamInit;
					}
					else
					{
						//If itemA and itemB are different, switch both only
						if(%itemB > 0)
						{
							%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1);
							%itemASkAm = getWord($ItemSetArray[%itemA],0);
							%itemBam = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1);
							%itemBSkAm = getWord($ItemSetArray[%itemB],0);
							
							%sendAm = %itemAam;
						}
						
						//If itemB doesn't exist, move item stack or specified amount to second cell
						else
						{
							if(%sendAm == -1) //entire stack
							{
								%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1);
								%itemASkAm = getWord($ItemSetArray[%itemA],0);
								%itemBam = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1);
								%itemBSkAm = getWord($ItemSetArray[%itemB],0);
								
								%sendAm = %itemAam;
							}
							else //specific amount
							{
								%itemAam = getWord(%cl.bkpkInv,3+(%prevCellNum*4)+1) - %sendAm;
								%itemASkAm = getWord($ItemSetArray[%itemA],0);
								%itemB = %itemA;
								%itemBam = getWord(%cl.bkpkInv,3+(%currCellNum*4)+1) + %sendAm;
								%itemBSkAm = getWord($ItemSetArray[%itemB],0);
								%noSwap = 1;
								
								if(%itemAam < 1)
									%itemA = 0;
							}
						}
					}
				}
				%newItems = getWords(%newItems,1,getWordCount(%newItems));
				
				//////////////////////////////////////////////////

				if(%autoStack != 1)
				{
					%itemAWght = getWord($ItemSetArray[%itemA],1);
					%itemBWght = getWord($ItemSetArray[%itemB],1);
				
					if(%noSwap)
					{
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4),%itemA);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+1,%itemAam);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+2,%itemASkAm);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+3,%itemAWght);
						
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4),%itemB);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+1,%itemBam);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+2,%itemBSkAm);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+3,%itemBWght);
						
						%temp = %currCell;
						%currCell = %prevCell;
						%prevCell = %temp;
					}
					else
					{
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4),%itemB);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+1,%itemBam);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+2,%itemBSkAm);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%prevCellNum*4)+3,%itemBWght);
						
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4),%itemA);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+1,%itemAam);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+2,%itemASkAm);
						%cl.bkpkInv = setWord(%cl.bkpkInv,3+(%currCellNum*4)+3,%itemAWght);
					}
				}
				else
					%cl.bkpkInv = getWords(%cl.bkpkInv,0,2) SPC %newItems;
					
				//////////////////////////////////////////////////
				
				%bkpkItms = getWords(%cl.bkpkInv,3,62);
				
				if(getWord(%cl.bkpkInv,0) != 0)
				{
					if(ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,%bkpkItms,0,0) == 1)
					{
						%cl.bkpkInv = %tempMethodBk;
						return;
					}
				}
				else if(ISSaveItems(%cl,%cl.bl_id,"BackPacks",0,%bkpkItms,0) == 1)
				{
					%cl.bkpkInv = %tempMethodBk;
					return;
				}
				
				//////////////////////////////////////////////////
				
				if(%autoStack != 1)
					commandtoClient(%cl,'ISRefreshGUI',%currCell,%itemA,%itemAam,%itemASkAm,%itemAWght,%prevCell,%itemB,%itemBam,%itemBSkAm,%itemBWght);
				else if(%cl.bkpkInv !$= "")
					commandtoClient(%cl,'ISMultRefreshGUI',%newItems,"Bp");
			}
		}
		else
		{
			if(getWord(%cl.ISclInfo,2) != 4)
				commandtoClient(%cl,'messageboxOK',"Backpack Disabled","Backpack storage has been disabled by the server host.");
			else
				commandToClient(%cl,'ISMsgBox',"Backpack Disabled","locked","Backpack storage has been disabled by the server host.",0,"");
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	%cl.ISitemInfo = "";

	//////////////////////////////////////////////////
	//Info for IS_UndoTransfer
	
	%cl.ISclInfo = setWord(%cl.ISclInfo,7,%currCell);
	%cl.ISclInfo = setWord(%cl.ISclInfo,8,%prevCell);
	
	if(%prevCellStr $= "plStor" || %currCellStr $= "plStor")
		%cl.ISclInfo = setWord(%cl.ISclInfo,9,1);
	else
		%cl.ISclInfo = setWord(%cl.ISclInfo,9,%sendAm);
	
	%cl.ISclInfo = setWord(%cl.ISclInfo,10,%noSwap);
		
	//////////////////////////////////////////////////
			
	if(%execEvents && isObject(%brick) && %brick.getClassName() $= "fxDTSBrick")
	{
		if(%prevCellStr !$= "brStor")
		{
			if(%prevCellStr !$= "plStor")
			{
				if(%prevCellStr $= "bpStor")
					%invA = "Backpack";
			}
			else
				%invA = "Player";
		}
		else
			%invA = "Brick";
			
		if(%currCellStr !$= "brStor")
		{
			if(%currCellStr !$= "plStor")
			{
				if(%currCellStr $= "bpStor")
					%invB = "Backpack";
			}
			else
				%invB = "Player";
		}
		else
			%invB = "Brick";
			
		%cl.ISitemInfo = %itemAvce SPC %invA SPC %itemBvce SPC %invB;
		
		if(%prevCellStr !$= %currCellStr)
		{
			if(%prevCellStr $= "brStor")
				%cl.ISitemInfo = %cl.ISitemInfo SPC %itemBvce SPC %invB SPC %itemAvce SPC %invA;
			else if(%currCellStr $= "brStor")
				%cl.ISitemInfo = %cl.ISitemInfo SPC %itemAvce SPC %invA SPC %itemBvce SPC %invB;
		}
		
		%cl.ISitemInfo = setWord(%cl.ISitemInfo,20,%prevCellNum);
		%cl.ISitemInfo = setWord(%cl.ISitemInfo,21,%currCellNum);
		
		//////////////////////////////////////////////////
		
		fxDTSBrick::onISEventInput(%brick,%cl,9); //swap items
		
		if(%prevCellStr $= "brStor")
		{
			if(%currCellStr $= "brStor")
				fxDTSBrick::onISEventInput(%brick,%cl,2); //move item
			else
			{
				fxDTSBrick::onISEventInput(%brick,%cl,1); //remove item
				if(%noSwap != 1)
				{
					if(%itemB > 0)
						fxDTSBrick::onISEventInput(%brick,%cl,0); //add item
				}
			}
		}
		else if(%currCellStr $= "brStor")
		{
			fxDTSBrick::onISEventInput(%brick,%cl,0); //add item
			if(%noSwap != 1)
			{
				if(%itemB > 0)
					fxDTSBrick::onISEventInput(%brick,%cl,1); //remove item
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////
//SAVING/UPDATING ACCESS VALUE, REMOTE ACCESS VALUE, SOURCE BRICK OR OWNER FOR AN INVENTORY
///////////////////////////////////////////////////////////////////////////////////////////
function ServerCmdISRefreshInfo(%cl,%srcBrick,%access,%rmtAcc,%ownerID,%ownerName)
{
	if(ISSpamCheck(%cl,6,1000,7000,5))
		return;
	if(!isObject(%cl.player))
	{
		commandtoClient(%cl,'messageboxOK',"No Player","Please wait until you spawn.");
		return;
	}
	if(getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if(getWord(%cl.brInv,0) != 0)
	{
		if(%cl.bl_id == getWord(%cl.brInv,6) || %cl.islocalconnection() || %cl.bl_id == getNumKeyID())
		{
			%brName = getWord(%cl.brInv,8);
			%name = getWord(%cl.brInv,1);
			%tempsrcBrick = %srcBrick;
			%tempaccess = %access;
			%temprmtAcc = %rmtAcc;
			%tempownerID = %ownerID;
			
			if(%access == -1)
				%access = getWord(%cl.brInv,3);
			if(%srcBrick == -1)
				%srcBrick = getWord(%cl.brInv,4);
			if(%rmtAcc == -1)
				%rmtAcc = getWord(%cl.brInv,5);
			if(%ownerID == -1)
			{
				%ownerID = getWord(%cl.brInv,6);
				%ownerName = getWord(%cl.brInv,7);
			}
			
			////////////////////////////////////////////////////////////////////////////////////////////////////
			
			if(ISSaveInfo(%cl,%brName,%name,%access,%srcBrick,%rmtAcc,%ownerID,%ownerName))
				return;
			
			for(%c = 0; %c < clientgroup.getCount(); %c++)
			{
				%tempCl = clientgroup.getObject(%c);
				if(getWord(%tempCl.brInv,8) $= %brName)
				{
					if(getWord(%tempCl.brInv,0) != 1)
						%tempCl.brInv = setWord(%tempCl.brInv,0,1);
					if(%access != -1)
						%tempCl.brInv = setWord(%tempCl.brInv,3,%access);
					if(%srcBrick != -1)
						%tempCl.brInv = setWord(%tempCl.brInv,4,%srcBrick);
					if(%rmtAcc != -1)
						%tempCl.brInv = setWord(%tempCl.brInv,5,%rmtAcc);
					if(%ownerID != -1)
					{
						%tempCl.brInv = setWord(%tempCl.brInv,6,%ownerID);
						%tempCl.brInv = setWord(%tempCl.brInv,7,%ownerName);
					}
					commandtoClient(%tempCl,'ISRefreshInfoGUI',0,%access,%rmtAcc,%ownerName,0,0); //if ownername == -1?
				}
			}
			
			////////////////////////////////////////////////////////////////////////////////////////////////////
			
			if(%tempaccess != -1)
			{
				if(%access != 0)
				{
					if(%access != 1)
					{
						if(%access != 2)
							%temp = "SuperAdminOnly";
						else
							%temp = "AdminOnly";
					}
					else
						%temp = "Public";
				}
				else
					%temp = "Private";
				
				commandToClient(%cl,'ISMsgBox',"Permissions Updated","approved",
					"Access setting for this storage brick has been successfully changed to \"" @ %temp @ "\".",0,"");
			}
			
			//////////////////////////////////////////////////
			
			else if(%temprmtAcc != -1)
			{
				if(%temprmtAcc == 0)
					%tempRmtAccss = "Disabled / Off";
				else
					%tempRmtAccss = "Enabled / On";
				
				commandToClient(%cl,'ISMsgBox',"Remote Access Updated","approved",
					"Remote Access setting for this storage brick has been successfully changed to \"" @ %tempRmtAccss @ "\".",0,"");
			}
			
			//////////////////////////////////////////////////
			
			else if(%tempsrcBrick != -1)
				commandToClient(%cl,'ISMsgBox',"Source Brick Updated","approved",
					"This brick has been successfully set as the new source brick for the inventory \"" @ %brName @ "\".",0,"");
			
			//If resaving deleted save or creating new save
			else if(%tempownerID != -1)
				commandToClient(%cl,'ISMsgBox',"New Save Created","approved","Owner successfully updated; new save created.",0,"");
		}
		else
			commandToClient(%cl,'ISMsgBox',"Save Failed","denied",
				"Only the host or save-owner can change settings for this inventory.",0,"");
	}
	else
		commandToClient(%cl,'ISMsgBox',"No Save Detected","error",
			"No save detected; please save items first.",0,"");
}

/////////////////////////////////////////////////////////////////////
//DELETE SPECIFIC CLIENT'S SERVER VARIALBES (USED FOR AUTHENTICATION)
/////////////////////////////////////////////////////////////////////
function ServerCmdISDelVars(%cl,%bkpk)
{
	if(ISSpamCheck(%cl,2,2000,12000,5))
		return;
	if(isObject(%cl.player))
	{
		if(getWord(%cl.ISclInfo,2) != 4)
		{
			if(getWord(%cl.ISclInfo,2) == 0)
				commandtoClient(%cl,'messageboxOK',"Add-On Required",
					"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
					"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
			else if(getWord(%cl.ISclInfo,2) == 1)
				commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
					"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
					"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
			return;
		}

		////////////////////////////////////////////////////////////////////////////////////////////////////
		
		if(%bkpk != 1)
		{
			%brName = getWord(%cl.brInv,8);
			%cl.brInv = "";
			%cl.bkpkInv = "";
			%cl.plyrInv = "";
			
			for(%c = 0; %c < clientgroup.getCount(); %c++)
			{
				%tempCl = clientgroup.getObject(%c);
				if(getWord(%tempCl.brInv,8) $= %brName)
					%clCount++;
			}
			
			for(%c = 0; %c < clientgroup.getCount(); %c++)
			{
				%tempCl = clientgroup.getObject(%c);
				if(getWord(%tempCl.brInv,8) $= %brName)
					commandtoClient(%tempCl,'ISRefreshInfoGUI',%clCount,0,0,0,1,0);
			}
			
			//////////////////////////////////////////////////
			
			%brick = getWord(%cl.ISclInfo,6);

			if(isObject(%brick) && %brick.getClassName() $= "fxDTSBrick")
			{
				fxDTSBrick::onISEventInput(%brick,%cl,4);
				if(%clCount <= 0)
					fxDTSBrick::onISEventInput(%brick,%cl,5);
			}
			%cl.ISclInfo = setWord(%cl.ISclInfo,6,"");
		}
		
		////////////////////////////////////////////////////////////////////////////////////////////////////
		
		else
		{
			%cl.bkpkInv = "";
			%cl.plyrInv = "";
			
			if(%cl.player.currTool == -1 && %cl.player.getMountedImage(2) != ISBackPackBImage.getID())
			{
				%cl.player.unMountImage(0);
				%cl.player.mountImage(ISBackPackBImage,2);
				%cl.player.playThread(0,"root");
				
				if(%cl.pack > 0)
				{
					%packName = getWord(" armor bucket cape pack quiver tank",%cl.pack);
					%cl.ISclInfo = setWord(%cl.ISclInfo,1,%packName);
					%cl.player.hideNode(%packName);
				}
			}
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	else
	{
		%cl.brInv = "";
		%cl.bkpkInv = "";
		%cl.plyrInv = "";
	}
	
	%cl.ISitemInfo = "";
}

////////////////////////////////////////////////////////////////////////////
//RELAY SAVE INFORMATION FROM SERVER TO CLIENT (DEPENDING ON IF HOST OR NOT)
////////////////////////////////////////////////////////////////////////////
function ServerCmdISListSaves(%cl,%slctn,%slctnData,%fldr)
{
	if(ISSpamCheck(%cl,3,2000,12000,5))
		return;
	if(!isObject(%cl.player))
	{
		commandtoClient(%cl,'messageboxOK',"No Player","Please wait until you spawn.");
		return;
	}
	if(getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//If host, find saves by given information; return strings of save name, size, etc. if found
	
	if(%cl.islocalconnection() || %cl.bl_id == getNumKeyID())
	{
		if(%slctn $= "(selection)")
		{
			commandtoClient(%cl,'ISMsgBox',"Selection Type Blank","error","Selection type for listing saves has been left blank.",0,"");
			return;
		}
		else if((%slctn !$= "AllSaves" || %slctn !$= "YourSaves") && %slctnData $= "")
		{
			commandtoClient(%cl,'ISMsgBox',"Textbox Blank","error","Textbox for selection data has been left blank.",0,"");
			return;
		}
		else if(%fldr $= "(file)")
		{
			commandtoClient(%cl,'ISMsgBox',"Selection File Blank","error","File selection for listing saves has been left blank.",0,"");
			return;
		}
		
		//////////////////////////////////////////////////
		
		if(%slctn $= "PlayerID")
		{
			if(%slctnData !$= "self")
			{
				if(%fldr $= "BackPacks")
					%load = ISLoadInfo(%slctn,%slctnData,%fldr,0);
				else
					%load = ISLoadInfo(%slctn,%slctnData,%fldr,4);
			}
			else
				%load = ISLoadInfo(%slctn,%cl.bl_id,"AllFiles",4);
		}
		else if(%slctn $= "PlayerName")
		{
			if(%fldr $= "BackPacks")
				%load = ISLoadInfo(%slctn,%slctnData,%fldr,1);
			else
				%load = ISLoadInfo(%slctn,%slctnData,%fldr,5);
		}
		else if(%slctn $= "SaveName")
			%load = ISLoadInfo(%slctn,%slctnData,%fldr,6);
		else if(%slctn $= "AllSaves")
		{
			if(%fldr $= "BackPacks" || %fldr $= "AllFiles")
				%load = ISLoadInfo(%slctn,"AllSaves",%fldr,0);
			else
				%load = ISLoadInfo(%slctn,%slctnData,%fldr,"");
			
		}
		else if(%slctn $= "YourSaves")
		{
			if(%fldr $= "BackPacks")
				%load = ISLoadInfo(%slctn,%cl.bl_id,%fldr,0);
			else
				%load = ISLoadInfo(%slctn,%cl.bl_id,%fldr,4);
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//If not host, find saves by client's ID; return strings of save name, size, etc. if found
	
	else if(%slctnData $= "self")
		%load = ISLoadInfo("PlayerID",%cl.bl_id,"AllFiles",4);
		
	%quota = getWord($HstSetString,7); //grab quota value from server
	%count = getWordCount(%load);
	
	if(strLen(%load) >= 255)
	{
		if(%fldr $= "BackPacks")
		{
			%loadTemp = "";
			%b = 1;
			
			for(%c=1; %c<%count; %c+=3)
			{
				if(strLen(%loadTemp SPC getWord(%load,%c) SPC getWord(%load,%c+1) SPC getWord(%load,%c+2)) < 255)
				{
					%loadTemp = %loadTemp SPC getWord(%load,%c) SPC getWord(%load,%c+1) SPC getWord(%load,%c+2);
					
					if((%c+3) >= %count)
					{
						commandToClient(%cl,'ISLoadInfo',%b-1 SPC %c+2,%loadTemp,%quota,"",1);
						return;
					}
				}
				else
				{
					commandToClient(%cl,'ISLoadInfo',%b-1 SPC %c-1,%loadTemp,%quota,"",1);
					%loadTemp = " " @ getWord(%load,%c) SPC getWord(%load,%c+1) SPC getWord(%load,%c+2);
					%b = %c;
					
					if((%c+3) >= %count)
					{
						commandToClient(%cl,'ISLoadInfo',%b-1 SPC %c+2,%loadTemp,%quota,"",1);
						return;
					}
				}
			}
		}
		else
		{
			%loadTemp = "";
			%b = 1;
			
			for(%c=1; %c<%count; %c+=6)
			{
				if(strLen(%loadTemp SPC getWord(%load,%c) SPC getWord(%load,%c+1) SPC getWord(%load,%c+2) SPC getWord(%load,%c+3) SPC getWord(%load,%c+4) SPC getWord(%load,%c+5)) < 255)
				{
					%loadTemp = %loadTemp SPC getWord(%load,%c) SPC getWord(%load,%c+1) SPC getWord(%load,%c+2) SPC getWord(%load,%c+3) SPC getWord(%load,%c+4) SPC getWord(%load,%c+5);
					
					if((%c+6) >= %count)
					{
						commandToClient(%cl,'ISLoadInfo',%b-1 SPC %c+5,%loadTemp,%quota,"",0);
						return;
					}
				}
				else
				{
					commandToClient(%cl,'ISLoadInfo',%b-1 SPC %c-1,%loadTemp,%quota,"",0);
					%loadTemp = " " @ getWord(%load,%c) SPC getWord(%load,%c+1) SPC getWord(%load,%c+2) SPC getWord(%load,%c+3) SPC getWord(%load,%c+4) SPC getWord(%load,%c+5);
					%b = %c;
					
					if((%c+6) >= %count)
					{
						commandToClient(%cl,'ISLoadInfo',%b-1 SPC %c+5,%loadTemp,%quota,"",0);
						return;
					}
				}
			}
		}
	}
	else
	{
		if(%fldr $= "BackPacks")
			commandToClient(%cl,'ISLoadInfo',0 SPC getWord(%load,0)*3,%load,%quota,"",1);
		else
			commandToClient(%cl,'ISLoadInfo',0 SPC getWord(%load,0)*6,%load,%quota,"",0);
	}
}

/////////////////////////////////////////////////////////////////////////////////////
//DELETE SAVE FROM SERVER BY CLIENT'S REQUEST (IF SAVE FOUND AND THEY ARE HOST/OWNER)
/////////////////////////////////////////////////////////////////////////////////////
function ServerCmdISDelSave(%cl,%brInfo)
{
	if(ISSpamCheck(%cl,4,2000,12000,5))
		return;
	if(!isObject(%cl.player))
	{
		commandtoClient(%cl,'messageboxOK',"No Player","Please wait until you spawn.");
		return;
	}
	if(getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
		
	%brName = getWord(%brInfo,0);
	%brType = getWord(%brInfo,1);

	if(%brName $= "")
	{
		commandtoClient(%cl,'ISMsgBox',"Nothing Selected","error","No selection made.",0,"");
		return;
	}
	
	if(%brType !$= "BackPacks")
	{
		%name = ISGetFile(%cl,%brName);
		if(%name $= "0") 
			return;
		
		////////////////////////////////////////////////////////////////////////////////////////////////////
		
		%fp = "Config/Server/ItemStorage/" @ %name @ ".txt";
		%fpB = "Config/Server/ItemStorage/BackupFiles/" @ %name @ ".txt";
		%file = new FileObject();
		
		if(isFile(%fp))
		{
			%file.openForRead(%fp);
			%lineNum = 0;
			
			while(!%file.isEOF())
			{
				%load = %file.readLine();
				
				if(getWord(%load,6) !$= %brName)
				{
					if(getWord(%load,0) != 0)
					{
						%wrLn[%lineNum] = %load;
						%lineNum++;
					}
				}
				
				//////////////////////////////////////////////////
				//Else, check if client is host/owner
				
				else
				{
					if(%cl.bl_id != getWord(%load,4) && !%cl.islocalconnection() && %cl.bl_id != getNumKeyID())
					{
						commandtoClient(%cl,'ISMsgBox',"Access Denied","denied",
							"Only the server host or the storage brick owner can delete this save.",0,"");
						%file.close();
						%file.delete();
						return;
					}
					else
						%del = 1; //file found and removed
				}
			}
			
			////////////////////////////////////////////////////////////////////////////////////////////////////
			//Write save file
			
			%file.openForWrite(%fp);
			%file.writeLine(">>List of all item storage saves with names beginning with the letters: " @ %name);
			%file.writeLine(">>StorageSize, AccessValue, SourceBrick, RemoteAccessValue, OwnerID/Name, BrickName, LastEditedByID/Name, Items");
			for(%c = 0; %c < %lineNum; %c++)
				%file.writeLine(%wrLn[%c]);
			%file.close();
			
			if(getWord($HstSetString,16))
			{
				%file.openForWrite(%fpB);
				%file.writeLine(">>List of all item storage saves with names beginning with the letters: " @ %name);
				%file.writeLine(">>StorageSize, AccessValue, SourceBrick, RemoteAccessValue, OwnerID/Name, BrickName, LastEditedByID/Name, Items");
				for(%c = 0; %c < %lineNum; %c++)
					%file.writeLine(%wrLn[%c]);
				%file.close();
			}
			%file.delete();
		}
	}
	else
	{
		%fp = "Config/Server/ItemStorage/BackPacks.txt";
		%file = new FileObject();
		
		if(isFile(%fp))
		{
			%file.openForRead(%fp);
			%lineNum = 0;
			
			while(!%file.isEOF())
			{
				%load = %file.readLine();
				if(getWord(%load,0) !$= %brName)
				{
					if(getWord(%load,0) != 0)
					{
						%wrLn[%lineNum] = %load;
						%lineNum++;
					}
				}
				
				//////////////////////////////////////////////////
				//Else, check if client is host/owner
				
				else
				{
					if(!%cl.islocalconnection() && %cl.bl_id != getNumKeyID())
					{
						commandtoClient(%cl,'ISMsgBox',"Access Denied","denied",
							"Only the server host can delete backpack saves.",0,"");
						%file.close();
						%file.delete();
						return;
					}
					else
						%del = 1; //file found and removed
				}
			}
			
			////////////////////////////////////////////////////////////////////////////////////////////////////
			//Write save file
			
			%file.openForWrite(%fp);
			%file.writeLine(">>List of all item storage saves for player backpacks");
			%file.writeLine(">>OwnerID/Name, Items");
			for(%c = 0; %c < %lineNum; %c++)
				%file.writeLine(%wrLn[%c]);
			%file.close();
			
			if(getWord($HstSetString,16))
			{
				%file.openForWrite(%fpB);
				%file.writeLine(">>List of all item storage saves for player backpacks");
				%file.writeLine(">>OwnerID/Name, Items");
				for(%c = 0; %c < %lineNum; %c++)
					%file.writeLine(%wrLn[%c]);
				%file.close();
			}
			%file.delete();
		}
	}
	
	if(%del == 1)
		commandToClient(%cl,'ISLoadInfo',0,0,0,%brName,0);
	else
		commandToClient(%cl,'ISMsgBox',"Save Not Found","denied","Save not found; removal failed.",0,"");
}

///////////////////////////////////////////////////////////////
//DETERMINE WHICH SAVES GUI TO OPEN FOR CLIENT (IF HOST OR NOT)
///////////////////////////////////////////////////////////////
function ServerCmdISPushSavesGUI(%cl) //only needs to be called once per game per client
{
	if(ISSpamCheck(%cl,5,1000,7000,5))
		return;
	if(!isObject(%cl.player))
	{
		commandToClient(%cl,'ISMsgBox',"Error","error","Please wait until you spawn.",0,"");
		return;
	}
	if(getWord(%cl.ISclInfo,2) != 4)
	{
		if(getWord(%cl.ISclInfo,2) == 0)
			commandtoClient(%cl,'messageboxOK',"Add-On Required",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"you don't seem to have it. Please download version 4 from RTB, restart Blockland and then rejoin.");
		else if(getWord(%cl.ISclInfo,2) == 1)
			commandtoClient(%cl,'messageboxOK',"Add-On Outdated",
				"This server requires version 4 of the <a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a> - " @
				"your version is out of date. Please download version 4 from RTB, restart Blockland and then rejoin.");
		return;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if(%cl.islocalconnection() || %cl.bl_id == getNumKeyID())
		%host = 1;
	else
		%host = 0;
	
	if(%cl.islocalconnection())
		%local = 1;
		
	commandtoClient(%cl,'ISPushSavesGUI',%host,%local);
}

//////////////////////////
//SETUP SERVER ITEMS ARRAY
//////////////////////////
function ServerCmdISItmSetArr(%cl,%itemString,%pass)
{
	if(!isObject(%cl.player))
	{
		commandToClient(%cl,'ISMsgBox',"Error","error","Please wait until you spawn.",0,"");
		return;
	}
	//No spam check - this function must be called multiple times within a short period
	
	//////////////////////////////////////////////////
	
	if(%cl.islocalconnection() || %cl.bl_id == getNumKeyID())
	{
		//Close player inventory GUIs (if first pass) to update stack limits
		if(%pass == 0)
		{
			for(%c=0;%c<clientgroup.getCount();%c++)
			{
				%tempCl = clientgroup.getObject(%c);
				ISEncumbrance(%tempCl,"",getWord($HstSetString,18));
				
				if(getWord(%tempCl.brInv,8) !$= "" || getWord(%tempCl.bkpkInv,1) !$= "") //or use strLen instead
				{
					commandToClient(%tempCl,'ISRelayBkPkToggle',5);
					if(getWord(%tempCl.brInv,8) !$= "")
						ServerCmdISDelVars(%tempCl,getWord(%tempCl.ISclInfo,6),0);
					else if(getWord(%tempCl.bkpkInv,1) !$= "")
						ServerCmdISDelVars(%tempCl,0,1);
					
					if(%tempCl != %cl)
						commandToClient(%tempCl,'ISMsgBox',"Item Settings Updated","error","The host has updated item settings for the server. Inventory GUIs have been closed to apply the changes; sorry for the inconvenience.",0,"");
				}
			}
			messageAll("","<color:ffffff>>> <color:ff0000>The server owner has updated item stack and weight values (Item Storage).");
		}
		
		//////////////////////////////////////////////////
		
		//Update server item-settings array
		for(%c=0;%c<getWordCount(%itemString);%c+=3)
		{
			%itemID = getWord(%itemString,(%c));
			if(isObject(%itemID))
			{
				%itemStack = mFloatLength(getWord(%itemString,(%c)+1),0);
				if(%itemStack > 999)
					%itemStack = 999;
				else if(%itemStack < 1)
					%itemStack = 1;
					
				%itemWeight = mFloatLength(getWord(%itemString,(%c)+2),0);
				if(%itemWeight > 99999)
					%itemWeight = 99999;
					
				$ItemSetArray[%itemID] = %itemStack SPC %itemWeight;
			}
		}
	}
	else
		commandToClient(%cl,'ISMsgBox',"Access Denied","denied","Only the server host can update item settings for this add-on.",0,"");
}

//////////////////////////////
//SETUP SERVER SETTINGS STRING
//////////////////////////////
function ServerCmdISServSetString(%cl,%str)
{
	if(ISSpamCheck(%cl,9,2000,17000,7))
		return;
	if(!isObject(%cl.player))
	{
		commandToClient(%cl,'ISMsgBox',"Error","error","Please wait until you spawn.",0,"");
		return;
	}
		
	//////////////////////////////////////////////////
	
	if(%cl.islocalconnection() || %cl.bl_id == getNumKeyID())
	{
		if(getWord(%str,7) > 100)
			%str = setWord(%str,7,100);
		else
			%str = setWord(%str,7,mAbs(mFloatLength(getWord(%str,7),0)));
		if(getWord(%str,8) > 1000)
			%str = setWord(%str,7,1000);
		else
			%str = setWord(%str,8,mAbs(mFloatLength(getWord(%str,8),0)));
		if(getWord(%str,18) > 99999)
			%str = setWord(%str,18,99999);
		else
			%str = setWord(%str,18,mAbs(mFloatLength(getWord(%str,18),0)));
		if(getWord(%str,19) < 5)
			%str = setWord(%str,19,getWord("g kg oz lb N b",mAbs(mFloatLength(getWord(%str,19),0))));
		else
			%str = setWord(%str,19,"lb");
		
		$HstSetString = %str;
		
		//Close all currently open player inventory GUIs
		for(%c=0;%c<clientgroup.getCount();%c++)
		{
			%tempCl = clientgroup.getObject(%c);
			ISEncumbrance(%tempCl,"",getWord($HstSetString,18));
			
			if(getWord(%tempCl.brInv,8) !$= "" || getWord(%tempCl.bkpkInv,1) !$= "") //or use strLen instead
			{
					commandToClient(%tempCl,'ISRelayBkPkToggle',5);
					if(getWord(%tempCl.brInv,8) !$= "")
						ServerCmdISDelVars(%tempCl,getWord(%tempCl.ISclInfo,6),0);
					else if(getWord(%tempCl.bkpkInv,1) !$= "")
						ServerCmdISDelVars(%tempCl,0,1);
				
				if(%tempCl != %cl)
					commandToClient(%tempCl,'ISMsgBox',"Add-On Settings Updated","error","The host has updated add-on settings for the server. Inventory GUIs have been closed to apply the changes; sorry for the inconvenience.",0,"");
			}
		}
		messageAll("","<color:ffffff>>> <color:ff0000>The server owner has updated server settings (Item Storage).");
	}
	else
		commandToClient(%cl,'ISMsgBox',"Access Denied","denied","Only the server host can update server settings for this add-on.",0,"");
}

///////////////////////////////
//LOAD ITEM AND SERVER SETTINGS
///////////////////////////////
function ISLoadSettings()
{
	%fp = "Config/Client/ItemStorageCl.txt";
	%file = new FileObject();
	if(!isFile(%fp)) 
	{
		%file.openForWrite(%fp);
		%file.writeLine(">>Client-sided GUI and Item settings");
	}
	%file.openForRead(%fp);
	
	//Load add-on settings
	%file.readLine();
	%strLn = %file.readLine();
	if(getWord(%strLn,0) != 4)
		%strLn = "0 1 1 1 0 0 0 25 250 1 1 0 0 1 0 60 0 0 500 lb";
	%strLnTemp = "0 1 1 1 0 0 0 25 250 1 1 0 0 1 0 60 0 0 500 lb";

	//////////////////////////////////////////////////
	
	for(%c=0; %c<20; %c++)
	{
		if(getWord(%strLn,%c) !$= "")
		{
			if(%c == 7)
			{
				if(getWord(%strLn,7) > 100)
					%strLn = setWord(%strLn,7,100);
				else
					%strLn = setWord(%strLn,7,mAbs(mFloatLength(getWord(%strLn,7),0)));
			}
			else if(%c == 8)
			{
				if(getWord(%strLn,8) > 1000)
					%strLn = setWord(%strLn,7,1000);
				else
					%strLn = setWord(%strLn,8,mAbs(mFloatLength(getWord(%strLn,8),0)));
			}
			else if(%c == 18)
			{
				if(getWord(%strLn,18) > 99999)
					%strLn = setWord(%strLn,18,99999);
				else
					%strLn = setWord(%strLn,18,mAbs(mFloatLength(getWord(%strLn,18),0)));
			}
			else if(%c == 19)
			{
				if(getWord(%strLn,19) < 6)
					%strLn = setWord(%strLn,19,getWord("g kg oz lb N b",mAbs(mFloatLength(getWord(%strLn,19),0))));
				else
					%strLn = setWord(%strLn,19,"lb");
			}
		}
		else
			%strLn = setWord(%strLn,%c,getWord(%strLnTemp,%c));
	}
	$HstSetString = %strLn;
	$HstSetString = setWord($HstSetString,0,4);
	
	%file.close();

	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	//Load item settings
	$ItemListString = 0;

	for(%c=1;%c<DataBlockGroup.getCount();%c++)
	{
		%item = DataBlockGroup.getObject(%c);
		if(isObject(%item) && %item.getClassName() $= "ItemData" && %item.uiName !$= "")
		{
			$ItemListString = $ItemListString SPC %item;
			
			%check = 0;
			%itemUIN = strReplace(%item.uiName," ","_");

			%file.openForRead(%fp);	
			%file.readLine();
			%file.readLine();
			
			while(!%file.isEOF() && %check != 1)
			{
				%strLn = %file.readLine();

				if(getWord(%strLn,0) $= %itemUIN)
				{
					%stack = mAbs(mFloatLength(getWord(%strLn,1),0));
					if(%stack > 999)
						%stack = 999;
					else if(%stack < 1)
						%stack = 1;
						
					%weight = mAbs(mFloatLength(getWord(%strLn,2),0));
					if(%weight > 99999)
						%weight = 99999;
						
					%check = 1;
				}
			}
			if(%check != 1)
			{
				%stack = 16;
				%weight = 10;
			}
			$itemSetArray[%item] = %stack SPC %weight;
		}
		%file.close();
	}
	%file.delete();
}

/////////
//PACKAGE
/////////
package ISAddOn_Package
{
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Register VCE variables
	
	function VCE_initServer()
	{
		Parent::VCE_initServer();
		
		//Current and previous-selected swapped item info
		registerSpecialVar(GameConnection,"itemA","getWord(%this.ISitemInfo,0)");
		registerSpecialVar(GameConnection,"itemB","getWord(%this.ISitemInfo,5)");
		registerSpecialVar(GameConnection,"itemAam","getWord(%this.ISitemInfo,1)");
		registerSpecialVar(GameConnection,"itemBam","getWord(%this.ISitemInfo,6)");
		registerSpecialVar(GameConnection,"itemAsk","getWord(%this.ISitemInfo,2)");
		registerSpecialVar(GameConnection,"itemBsk","getWord(%this.ISitemInfo,7)");
		registerSpecialVar(GameConnection,"itemAw","getWord(%this.ISitemInfo,3)");
		registerSpecialVar(GameConnection,"itemBw","getWord(%this.ISitemInfo,8)");
		registerSpecialVar(GameConnection,"invA","getWord(%this.ISitemInfo,4)");
		registerSpecialVar(GameConnection,"invB","getWord(%this.ISitemInfo,9)");
		
		//Added and removed swapped item info
		registerSpecialVar(GameConnection,"itemAdd","getWord(%this.ISitemInfo,10)");
		registerSpecialVar(GameConnection,"itemRem","getWord(%this.ISitemInfo,15)");
		registerSpecialVar(GameConnection,"itemAddAm","getWord(%this.ISitemInfo,11)");
		registerSpecialVar(GameConnection,"itemRemAm","getWord(%this.ISitemInfo,16)");
		registerSpecialVar(GameConnection,"itemAddSk","getWord(%this.ISitemInfo,12)");
		registerSpecialVar(GameConnection,"itemRemSk","getWord(%this.ISitemInfo,17)");
		registerSpecialVar(GameConnection,"itemAddW","getWord(%this.ISitemInfo,13)");
		registerSpecialVar(GameConnection,"itemRemW","getWord(%this.ISitemInfo,18)");
		registerSpecialVar(GameConnection,"invAdd","getWord(%this.ISitemInfo,14)");
		
		//Client and backpack info
		registerSpecialVar(GameConnection,"IsEnc","%this.overEnc");
		registerSpecialVar(GameConnection,"HasBp","getWord(%this.ISclInfo,0)");
		registerSpecialVar(GameConnection,"BpSvd","getWord(%this.bkpkInv,0)"); //only works if bkpk open
		registerSpecialVar(GameConnection,"BpOwrN","getWord(%this.bkpkInv,2)"); //only works if bkpk open
		registerSpecialVar(GameConnection,"BpOwrID","getWord(%this.bkpkInv,1)"); //only works if bkpk open
		registerSpecialVar(GameConnection,"BpOpn","%this.bkpkInv !$= \"\"");
		registerSpecialVar(GameConnection,"BrOpn","%this.brInv !$= \"\"");
		registerSpecialVar(GameConnection,"HasMod","getWord(%this.ISclInfo,2)");
		registerSpecialVar(GameConnection,"PlW","getWord(%this.ISclInfo,3)");
		
		//Brick info
		registerSpecialVar(GameConnection,"BrNme","getWord(%this.brInv,8)");
		registerSpecialVar(GameConnection,"BrID","getWord(%this.ISclInfo,6)");
		registerSpecialVar(GameConnection,"SendAm","getWord(%this.ISclInfo,9)"); //takes -1 amount into account
		registerSpecialVar(GameConnection,"BrSz","getWord(%this.brInv,2)");
		registerSpecialVar(GameConnection,"BrOwrN","getWord(%this.brInv,6)");
		registerSpecialVar(GameConnection,"BrOwrID","getWord(%this.brInv,7)");
		registerSpecialVar(GameConnection,"BrEditN","getWord(%this.brInv,9)"); 
		registerSpecialVar(GameConnection,"BrEditID","getWord(%this.brInv,10)");
		registerSpecialVar(GameConnection,"cellA","getWord(%this.ISitemInfo,20)");
		registerSpecialVar(GameConnection,"cellB","getWord(%this.ISitemInfo,21)");
		
		//Server settings
		registerSpecialVar(GameConnection,"EncEnab","getWord($HstSetString,4)");
		registerSpecialVar(GameConnection,"BpEnab","getWord($HstSetString,2)");
		registerSpecialVar(GameConnection,"BpReq","getWord($HstSetString,3)");
		registerSpecialVar(GameConnection,"EvtRes","getWord($HstSetString,17)");
		registerSpecialVar(GameConnection,"maxW","getWord($HstSetString,18)");
		registerSpecialVar(GameConnection,"WSym","getWord($HstSetString,19)");
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////////
	
	function serverCmdDropPlayerAtCamera(%client)
	{
		parent::serverCmdDropPlayerAtCamera(%client);
		ISEncumbrance(%client,getWord(%client.ISclInfo,3),getWord($HstSetString,18));
	}

	//////////////////////////////////////////////////
	
	function Observer::onTrigger(%this, %obj, %trigger, %state)
	{
		if(%trigger == 0 && %state == 0)
		{
			if(isObject(%obj) && isObject(%client = %obj.getControllingClient()))
			{
				if(getWord(%client.ISclInfo,0) != 1)
				{
					if(getWord($HstSetString,3) != 1)
					{
						if(getWord($HstSetString,4))
							ServerCmdISPopulateBkPkGUI(%client,0);
					}
					else
						ISEncumbrance(%client,getWord(%client.ISclInfo,3),getWord($HstSetString,18));
				}
				else if(getWord($HstSetString,4))
					ServerCmdISPopulateBkPkGUI(%client,0);
			}
		}
		
		return parent::onTrigger(%this, %obj, %trigger, %state);
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//Notify players to have add-on downloaded when connecting to server
	
	function GameConnection::autoAdminCheck(%client)
	{
		parent::autoAdminCheck(%client);

		messageClient(%client,"","This server requires \c6version 4\c0 of the <linkcolor:ffffff><a:forum.returntoblockland.com/dlm/viewFile.php?id=5243>Item Storage Add-On</a>; " @
			"please make sure you have it downloaded. Otherwise, you'll be restricted from using certain features.");
		messageClient(%client,""," ");
		
		if(getWord($HstSetString,0) < 1)
			ISLoadSettings();
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	function GameConnection::applyBodyParts(%client)
	{
		parent::applyBodyParts(%client);
		
		%player = %client.player;
		if(isObject(%player))
		{
			%packName = getWord(" armor bucket cape pack quiver tank",%client.pack);
			%client.ISclInfo = setWord(%client.ISclInfo,1,%packName);
			
			if(%client.pack > 0)
				%player.unMountImage(2);
			else
			{
				for(%c = 0; %c < %player.getDatablock().maxTools; %c++)
				{
					%tool = %player.tool[%c];
					if(%tool == ISBackPackItem.getID())
					{
						if(%player.getMountedImage(2) != ISBackPackBImage.getID())
							%player.mountImage(ISBackPackBImage,2);
							
						return;
					}
				}
			}
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	//
	
	function GameConnection::onDeath(%client)
	{
		parent::onDeath(%client);
		
		if(getWord($HstSetString,5))
		{
			%bkpkItms = "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0";
			ISOverWriteSave(%client,"BackPacks",%client.bl_id,0,%bkpkItms,0,0,1);
		}
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////

	function GameConnection::SpawnPlayer(%client)
	{
		parent::SpawnPlayer(%client);
		
		if(getWord(%client.ISclInfo,2) $= "")
			commandToClient(%client,'ISHasAddOnRelay');
		
		%pl = %client.player;
		%bkpkID = ISBackPackItem.getID();
		for(%c = 0; %c < %pl.getDatablock().maxTools; %c++)
		{
			%tool = %pl.tool[%c];
			if(%tool == %bkpkID)
			{
				%check = 1;
				break;
			}
		}
		if(%check != 1)
			%client.ISclInfo = setWord(%client.ISclInfo,0,0);
		else
			%client.ISclInfo = setWord(%client.ISclInfo,0,1);
		
		if(getWord($HstSetString,6))
		{
			%bkpkItms = "0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0";
			ISOverWriteSave(%client,"BackPacks",%client.bl_id,0,%bkpkItms,0,0,1);
		}
		ISEncumbrance(%client,"",getWord($HstSetString,18));
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	function servercmdDropTool(%client,%slot)
	{
		%player = %client.player;
		if(isObject(%player))
		{				
			if(%client.plyrInv !$= "")
			{
				%client.plyrInv = setWord(%client.plyrInv,1+(%slot*4),0);
				%client.plyrInv = setWord(%client.plyrInv,1+(%slot*4)+1,0);
				%client.plyrInv = setWord(%client.plyrInv,1+(%slot*4)+2,0);
				%client.plyrInv = setWord(%client.plyrInv,1+(%slot*4)+3,0);
				
				commandtoClient(%client,'ISRefreshGUI',"plStor" @ %slot,0,0,0,0,"",0,0,0,0);
			}
			
			%item = %client.player.tool[%slot];
			if(isObject(PropaneTankItem))
			{
				%PTIid = PropaneTankItem.getID();
				if(%item != %PTIid)
				{
					if(%item == %client.player.tool[%client.player.currTool])
						%client.player.unMountImage(0);
				}
			}
			else if(%item == %client.player.tool[%client.player.currTool])
				%client.player.unMountImage(0);
				
			if(%item == ISBackpackItem.getID())
			{
				%client.ISclInfo = setWord(%client.ISclInfo,0,0);
				commandToClient(%client,'ISRelayBkPkToggle',3);
				
					%client.player.unMountImage(2);
				if(getWord(%client.ISclInfo,1) !$= "")
					%client.player.unHideNode(getWord(%client.ISclInfo,1));
			}
			
			%img = %client.player.getMountedImage(2);
			if(%img > 0)
			{
				%imgFile = getWord(strReplace(%img.shapeFile,"/"," "),1);
				for(%c=0; %c<%client.player.getDatablock().maxTools && %c<10; %c++)
				{
					%item = %client.player.tool[%c];
					%imgBFile = getWord(strReplace(%item.shapeFile,"/"," "),1);
					if(%imgFile $= %imgBFile)
					{
						%check = 1;
						break;
					}
				}
				if(%check != 1)
					%client.player.unMountImage(2);
			}
		}
		%parent = parent::servercmdDropTool(%client,%slot);
		ISEncumbrance(%client,"",getWord($HstSetString,18));
		
		return %parent;
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	function Player::pickup(%obj,%item)
	{
		if(%item.canPickUp)
		{
			%cl = %obj.client;
			%itemID = %item.getDataBlock().getID();
			%bkpkID = ISBackPackItem.getID();
			
			//////////////////////////////////////////////////
						
			if(%cl.plyrInv !$= "")
			{
				for(%c=0; %c<%obj.getDataBlock().maxTools && %c<10; %c++)
				{
					if(%obj.tool[%c] == 0)
					{
						%slot = %c;
						break;
					}
				}
				%itemAm = 1;
				%itemSkAm = getWord($ItemSetArray[%itemID],0);
				%itemWght = getWord($ItemSetArray[%itemID],1);

				%cl.plyrInv = setWord(%cl.plyrInv,1+(%slot*4),%itemID);
				%cl.plyrInv = setWord(%cl.plyrInv,1+(%slot*4)+1,%itemAm);
				%cl.plyrInv = setWord(%cl.plyrInv,1+(%slot*4)+2,%itemSkAm);
				%cl.plyrInv = setWord(%cl.plyrInv,1+(%slot*4)+3,%itemWght);
				
				commandtoClient(%cl,'ISRefreshGUI',"plStor" @ %slot,%itemID,%itemAm,%itemSkAm,%itemWght,"",0,0,0,0);
				
			}
			
			if(%item.isStackAm > 1)
			{
				if(getWord($HstSetString,2) && (getWord(%cl.ISclInfo,0) || getWord($HstSetString,3) != 1) && %itemID != %bkpkID)
				{
					if(%cl.bkpkInv !$= "")
					{
						%loadBp = getWords(%cl.bkpkInv,1,62);//63?
						%bkpkItms = getWords(%cl.bkpkInv,3,62);//63?
						%savePres = getWord(%cl.bkpkInv,0);
					}
					else
					{
						%loadBp = ISLoadItems(%cl,%cl.bl_id,"BackPacks");
						%bkpkItms = getWords(%loadBp,2,61);
						
						if(%loadBp == 0)
							%savePres = 0;
						else
							%savePres = 1;
					}
					
					%remAm = %item.isStackAm-1;
					for(%c=0; %c<15 && %remAm > 0; %c++)
					{
						%tempItem = getWord(%bkpkItms,(%c*4));
						%tempAm = getWord(%bkpkItms,(%c*4)+1);
						%tempSkAm = getWord($itemSetArray[%tempItem],0);
						
						if(%tempItem == %itemID && %tempSkAm > %tempAm)
						{
							%found = 1;
							if(%remAm > (%tempSkAm - %tempAm))
								%rem = %tempSkAm - %tempAm;
							else
								%rem = %remAm;
								
							%tempAm += %rem;
							%remAm -= %rem;
							
							%bkpkItms = setWord(%bkpkItms,(%c*4),%itemID);
							%bkpkItms = setWord(%bkpkItms,(%c*4)+1,%tempAm);
							%bkpkItms = setWord(%bkpkItms,(%c*4)+2,getWord($itemSetArray[%itemID],0));
							%bkpkItms = setWord(%bkpkItms,(%c*4)+3,getWord($ItemSetArray[%itemID],1));
						}
					}
					
					%tempSkAm = getWord($itemSetArray[%itemID],0);
					for(%c=0; %c<15 && %remAm > 0; %c++)
					{
						%tempItem = getWord(%bkpkItms,(%c*4));
						if(%tempItem == 0)
						{
							%found = 1;
							if(%remAm > %tempSkAm)
								%rem = %tempSkAm;
							else
								%rem = %remAm;
								
							%tempAm = %rem;
							%remAm -= %rem;
							
							%bkpkItms = setWord(%bkpkItms,(%c*4),%itemID);
							%bkpkItms = setWord(%bkpkItms,(%c*4)+1,%tempAm);
							%bkpkItms = setWord(%bkpkItms,(%c*4)+2,%tempSkAm);
							%bkpkItms = setWord(%bkpkItms,(%c*4)+3,getWord($ItemSetArray[%itemID],1));
						}
					}
					if(%found)
					{
						if(%savePres)
						{
							if(ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,%bkpkItms,0,0) == 1)
							{
								ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,getWords(%loadBp,2,61),0,0);//loadbp...
								return;
							}
						}
						else if(ISSaveItems(%cl,%cl.bl_id,"BackPacks",0,%bkpkItms,0) == 1)
						{
							ISOverWriteSave(%cl,"BackPacks",%cl.bl_id,0,getWords(%loadBp,2,61),0,0);//loadbp...
							return;
						}
						if(%cl.bkpkInv !$= "")
						{
							%cl.bkpkInv = getWords(%cl.bkpkInv,0,2) SPC %bkpkItms;
							commandToClient(%cl,'ISMultRefreshGUI',%bkpkItms,"Bp");
						}
					}
					if(%remAm > 0)
					{
						%droppedItem = new Item()
						{
							datablock = %itemID.getName();
							position = vectorAdd(vectorScale(%cl.player.getForwardVector(),2),%cl.player.getHackPosition());
							static = 0;
						};
						%droppedItem.setVelocity(getWord(%cl.player.getMuzzleVector(0),0)*15 SPC 
												 getWord(%cl.player.getMuzzleVector(0),1)*15 SPC
												 getWord(%cl.player.getMuzzleVector(0),2)*15);
						%droppedItem.ISstackAm = %remAm;
						%droppedItem.setShapeName(%remAm);
						%droppedItem.schedule(5000,"fadeOut");
						%droppedItem.schedule(7000,delete);
						%droppedItem.canPickUp = true;
						MissionCleanup.add(%droppedItem);
					}
				}
				else
				{
					%droppedItem = new Item()
					{
						datablock = %itemID.getName();
						position = vectorAdd(vectorScale(%cl.player.getForwardVector(),2),%cl.player.getHackPosition());
						static = 0;
					};
					%droppedItem.setVelocity(getWord(%cl.player.getMuzzleVector(0),0)*15 SPC 
											 getWord(%cl.player.getMuzzleVector(0),1)*15 SPC
											 getWord(%cl.player.getMuzzleVector(0),2)*15);
					%droppedItem.ISstackAm = %item.isStackAm - 1;
					%droppedItem.setShapeName(%item.isStackAm - 1);
					%droppedItem.schedule(5000,"fadeOut");
					%droppedItem.schedule(7000,delete);
					%droppedItem.canPickUp = true;
					MissionCleanup.add(%droppedItem);
				}
			}
			
			if(%itemID == %bkpkID)
			{
				%cl.ISclInfo = setWord(%cl.ISclInfo,0,1);
				if(getWord($HstSetString,2))
					commandToClient(%cl,'ISRelayBkPkToggle',4);
				
				if(%obj.tool[%obj.currTool] != %bkpkID)
				{
					if(%cl.pack > 0 && %obj.getMountedImage(2) == 0)
					{
						%packName = getWord(" armor bucket cape pack quiver tank",%cl.pack);

						%cl.ISclInfo = setWord(%cl.ISclInfo,1,%packName);
						%obj.hideNode(%packName);
					}
					%obj.mountImage(ISBackPackBImage,2);
				}		
			}
		}
		%canPickUp = %item.canPickUp;
		
		%parent = parent::pickup(%obj,%item);
		if(%canPickUp)
			ISEncumbrance(%cl,"",getWord($HstSetString,18));
		return %parent;
	}
};
activatePackage(ISAddOn_Package);
